#ifndef _H_057B87760EF1571F393BA4DA0DD7D2AC_GripperCommand_DCPS_H_
#define _H_057B87760EF1571F393BA4DA0DD7D2AC_GripperCommand_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GripperCommand_.h"


namespace control_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class GripperCommand_TypeSupportInterface;

            typedef GripperCommand_TypeSupportInterface * GripperCommand_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_TypeSupportInterface> GripperCommand_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GripperCommand_TypeSupportInterface> GripperCommand_TypeSupportInterface_out;


            class GripperCommand_DataWriter;

            typedef GripperCommand_DataWriter * GripperCommand_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_DataWriter> GripperCommand_DataWriter_var;
            typedef DDS_DCPSInterface_out < GripperCommand_DataWriter> GripperCommand_DataWriter_out;


            class GripperCommand_DataReader;

            typedef GripperCommand_DataReader * GripperCommand_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_DataReader> GripperCommand_DataReader_var;
            typedef DDS_DCPSInterface_out < GripperCommand_DataReader> GripperCommand_DataReader_out;


            class GripperCommand_DataReaderView;

            typedef GripperCommand_DataReaderView * GripperCommand_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_DataReaderView> GripperCommand_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GripperCommand_DataReaderView> GripperCommand_DataReaderView_out;

            struct GripperCommand_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GripperCommand_, struct GripperCommand_Seq_uniq_> GripperCommand_Seq;
            typedef DDS_DCPSSequence_var < GripperCommand_Seq> GripperCommand_Seq_var;
            typedef DDS_DCPSSequence_out < GripperCommand_Seq> GripperCommand_Seq_out;

            class  GripperCommand_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GripperCommand_TypeSupportInterface_ptr _ptr_type;
                typedef GripperCommand_TypeSupportInterface_var _var_type;

                static GripperCommand_TypeSupportInterface_ptr _duplicate (GripperCommand_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GripperCommand_TypeSupportInterface () {};
                ~GripperCommand_TypeSupportInterface () {};
            private:
                GripperCommand_TypeSupportInterface (const GripperCommand_TypeSupportInterface &);
                GripperCommand_TypeSupportInterface & operator = (const GripperCommand_TypeSupportInterface &);
            };

            class  GripperCommand_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GripperCommand_DataWriter_ptr _ptr_type;
                typedef GripperCommand_DataWriter_var _var_type;

                static GripperCommand_DataWriter_ptr _duplicate (GripperCommand_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GripperCommand_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GripperCommand_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GripperCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GripperCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GripperCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GripperCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GripperCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GripperCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GripperCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GripperCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GripperCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_& instance_data) = 0;

            protected:
                GripperCommand_DataWriter () {};
                ~GripperCommand_DataWriter () {};
            private:
                GripperCommand_DataWriter (const GripperCommand_DataWriter &);
                GripperCommand_DataWriter & operator = (const GripperCommand_DataWriter &);
            };

            class  GripperCommand_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GripperCommand_DataReader_ptr _ptr_type;
                typedef GripperCommand_DataReader_var _var_type;

                static GripperCommand_DataReader_ptr _duplicate (GripperCommand_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_& instance) = 0;

            protected:
                GripperCommand_DataReader () {};
                ~GripperCommand_DataReader () {};
            private:
                GripperCommand_DataReader (const GripperCommand_DataReader &);
                GripperCommand_DataReader & operator = (const GripperCommand_DataReader &);
            };

            class  GripperCommand_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GripperCommand_DataReaderView_ptr _ptr_type;
                typedef GripperCommand_DataReaderView_var _var_type;

                static GripperCommand_DataReaderView_ptr _duplicate (GripperCommand_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_& instance) = 0;

            protected:
                GripperCommand_DataReaderView () {};
                ~GripperCommand_DataReaderView () {};
            private:
                GripperCommand_DataReaderView (const GripperCommand_DataReaderView &);
                GripperCommand_DataReaderView & operator = (const GripperCommand_DataReaderView &);
            };
        }

    }

}

#endif
