#ifndef _H_887F538990C0E29AD231983F5F353479_JointControllerState__H_
#define _H_887F538990C0E29AD231983F5F353479_JointControllerState__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace control_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  JointControllerState_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Double set_point_;
                ::DDS::Double process_value_;
                ::DDS::Double process_value_dot_;
                ::DDS::Double error_;
                ::DDS::Double time_step_;
                ::DDS::Double command_;
                ::DDS::Double p_;
                ::DDS::Double i_;
                ::DDS::Double d_;
                ::DDS::Double i_clamp_;
                ::DDS::Boolean antiwindup_;
            };

            typedef DDS_DCPSStruct_var<JointControllerState_> JointControllerState__var;
            typedef DDS_DCPSStruct_out < JointControllerState_> JointControllerState__out;

        }

    }

}

#endif /* _H_887F538990C0E29AD231983F5F353479_JointControllerState__H_ */
