#ifndef _H_B320377FEFB689555B5B57E4EDC6E789_PidState__H_
#define _H_B320377FEFB689555B5B57E4EDC6E789_PidState__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "builtin_interfaces/msg/dds_opensplice/Duration_.h"


namespace control_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  PidState_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::builtin_interfaces::msg::dds_::Duration_ timestep_;
                ::DDS::Double error_;
                ::DDS::Double error_dot_;
                ::DDS::Double p_error_;
                ::DDS::Double i_error_;
                ::DDS::Double d_error_;
                ::DDS::Double p_term_;
                ::DDS::Double i_term_;
                ::DDS::Double d_term_;
                ::DDS::Double i_max_;
                ::DDS::Double i_min_;
                ::DDS::Double output_;
            };

            typedef DDS_DCPSStruct_var<PidState_> PidState__var;
            typedef DDS_DCPSStruct_out < PidState_> PidState__out;

        }

    }

}

#endif /* _H_B320377FEFB689555B5B57E4EDC6E789_PidState__H_ */
