#ifndef _H_D614B7422DE138DD288258079F70F914_GripperCommand_DCPS_H_
#define _H_D614B7422DE138DD288258079F70F914_GripperCommand_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GripperCommand_.h"


namespace control_msgs
{
    namespace action
    {
        namespace dds_
        {
            class GripperCommand_Goal_TypeSupportInterface;

            typedef GripperCommand_Goal_TypeSupportInterface * GripperCommand_Goal_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Goal_TypeSupportInterface> GripperCommand_Goal_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Goal_TypeSupportInterface> GripperCommand_Goal_TypeSupportInterface_out;


            class GripperCommand_Goal_DataWriter;

            typedef GripperCommand_Goal_DataWriter * GripperCommand_Goal_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Goal_DataWriter> GripperCommand_Goal_DataWriter_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Goal_DataWriter> GripperCommand_Goal_DataWriter_out;


            class GripperCommand_Goal_DataReader;

            typedef GripperCommand_Goal_DataReader * GripperCommand_Goal_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Goal_DataReader> GripperCommand_Goal_DataReader_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Goal_DataReader> GripperCommand_Goal_DataReader_out;


            class GripperCommand_Goal_DataReaderView;

            typedef GripperCommand_Goal_DataReaderView * GripperCommand_Goal_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Goal_DataReaderView> GripperCommand_Goal_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Goal_DataReaderView> GripperCommand_Goal_DataReaderView_out;

            struct GripperCommand_Goal_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GripperCommand_Goal_, struct GripperCommand_Goal_Seq_uniq_> GripperCommand_Goal_Seq;
            typedef DDS_DCPSSequence_var < GripperCommand_Goal_Seq> GripperCommand_Goal_Seq_var;
            typedef DDS_DCPSSequence_out < GripperCommand_Goal_Seq> GripperCommand_Goal_Seq_out;

            class  GripperCommand_Goal_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GripperCommand_Goal_TypeSupportInterface_ptr _ptr_type;
                typedef GripperCommand_Goal_TypeSupportInterface_var _var_type;

                static GripperCommand_Goal_TypeSupportInterface_ptr _duplicate (GripperCommand_Goal_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Goal_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Goal_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Goal_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Goal_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GripperCommand_Goal_TypeSupportInterface () {};
                ~GripperCommand_Goal_TypeSupportInterface () {};
            private:
                GripperCommand_Goal_TypeSupportInterface (const GripperCommand_Goal_TypeSupportInterface &);
                GripperCommand_Goal_TypeSupportInterface & operator = (const GripperCommand_Goal_TypeSupportInterface &);
            };

            class  GripperCommand_Goal_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GripperCommand_Goal_DataWriter_ptr _ptr_type;
                typedef GripperCommand_Goal_DataWriter_var _var_type;

                static GripperCommand_Goal_DataWriter_ptr _duplicate (GripperCommand_Goal_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Goal_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Goal_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Goal_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Goal_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GripperCommand_Goal_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GripperCommand_Goal_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GripperCommand_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GripperCommand_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GripperCommand_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GripperCommand_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GripperCommand_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GripperCommand_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GripperCommand_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GripperCommand_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GripperCommand_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_Goal_& instance_data) = 0;

            protected:
                GripperCommand_Goal_DataWriter () {};
                ~GripperCommand_Goal_DataWriter () {};
            private:
                GripperCommand_Goal_DataWriter (const GripperCommand_Goal_DataWriter &);
                GripperCommand_Goal_DataWriter & operator = (const GripperCommand_Goal_DataWriter &);
            };

            class  GripperCommand_Goal_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GripperCommand_Goal_DataReader_ptr _ptr_type;
                typedef GripperCommand_Goal_DataReader_var _var_type;

                static GripperCommand_Goal_DataReader_ptr _duplicate (GripperCommand_Goal_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Goal_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Goal_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Goal_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Goal_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_Goal_& instance) = 0;

            protected:
                GripperCommand_Goal_DataReader () {};
                ~GripperCommand_Goal_DataReader () {};
            private:
                GripperCommand_Goal_DataReader (const GripperCommand_Goal_DataReader &);
                GripperCommand_Goal_DataReader & operator = (const GripperCommand_Goal_DataReader &);
            };

            class  GripperCommand_Goal_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GripperCommand_Goal_DataReaderView_ptr _ptr_type;
                typedef GripperCommand_Goal_DataReaderView_var _var_type;

                static GripperCommand_Goal_DataReaderView_ptr _duplicate (GripperCommand_Goal_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Goal_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Goal_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Goal_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Goal_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_Goal_& instance) = 0;

            protected:
                GripperCommand_Goal_DataReaderView () {};
                ~GripperCommand_Goal_DataReaderView () {};
            private:
                GripperCommand_Goal_DataReaderView (const GripperCommand_Goal_DataReaderView &);
                GripperCommand_Goal_DataReaderView & operator = (const GripperCommand_Goal_DataReaderView &);
            };
            class GripperCommand_SendGoal_Request_TypeSupportInterface;

            typedef GripperCommand_SendGoal_Request_TypeSupportInterface * GripperCommand_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_SendGoal_Request_TypeSupportInterface> GripperCommand_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GripperCommand_SendGoal_Request_TypeSupportInterface> GripperCommand_SendGoal_Request_TypeSupportInterface_out;


            class GripperCommand_SendGoal_Request_DataWriter;

            typedef GripperCommand_SendGoal_Request_DataWriter * GripperCommand_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_SendGoal_Request_DataWriter> GripperCommand_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GripperCommand_SendGoal_Request_DataWriter> GripperCommand_SendGoal_Request_DataWriter_out;


            class GripperCommand_SendGoal_Request_DataReader;

            typedef GripperCommand_SendGoal_Request_DataReader * GripperCommand_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_SendGoal_Request_DataReader> GripperCommand_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GripperCommand_SendGoal_Request_DataReader> GripperCommand_SendGoal_Request_DataReader_out;


            class GripperCommand_SendGoal_Request_DataReaderView;

            typedef GripperCommand_SendGoal_Request_DataReaderView * GripperCommand_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_SendGoal_Request_DataReaderView> GripperCommand_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GripperCommand_SendGoal_Request_DataReaderView> GripperCommand_SendGoal_Request_DataReaderView_out;

            struct GripperCommand_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GripperCommand_SendGoal_Request_, struct GripperCommand_SendGoal_Request_Seq_uniq_> GripperCommand_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < GripperCommand_SendGoal_Request_Seq> GripperCommand_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GripperCommand_SendGoal_Request_Seq> GripperCommand_SendGoal_Request_Seq_out;

            class  GripperCommand_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GripperCommand_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GripperCommand_SendGoal_Request_TypeSupportInterface_var _var_type;

                static GripperCommand_SendGoal_Request_TypeSupportInterface_ptr _duplicate (GripperCommand_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GripperCommand_SendGoal_Request_TypeSupportInterface () {};
                ~GripperCommand_SendGoal_Request_TypeSupportInterface () {};
            private:
                GripperCommand_SendGoal_Request_TypeSupportInterface (const GripperCommand_SendGoal_Request_TypeSupportInterface &);
                GripperCommand_SendGoal_Request_TypeSupportInterface & operator = (const GripperCommand_SendGoal_Request_TypeSupportInterface &);
            };

            class  GripperCommand_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GripperCommand_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef GripperCommand_SendGoal_Request_DataWriter_var _var_type;

                static GripperCommand_SendGoal_Request_DataWriter_ptr _duplicate (GripperCommand_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GripperCommand_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GripperCommand_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GripperCommand_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GripperCommand_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GripperCommand_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GripperCommand_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GripperCommand_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GripperCommand_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GripperCommand_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GripperCommand_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GripperCommand_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_SendGoal_Request_& instance_data) = 0;

            protected:
                GripperCommand_SendGoal_Request_DataWriter () {};
                ~GripperCommand_SendGoal_Request_DataWriter () {};
            private:
                GripperCommand_SendGoal_Request_DataWriter (const GripperCommand_SendGoal_Request_DataWriter &);
                GripperCommand_SendGoal_Request_DataWriter & operator = (const GripperCommand_SendGoal_Request_DataWriter &);
            };

            class  GripperCommand_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GripperCommand_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef GripperCommand_SendGoal_Request_DataReader_var _var_type;

                static GripperCommand_SendGoal_Request_DataReader_ptr _duplicate (GripperCommand_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_SendGoal_Request_& instance) = 0;

            protected:
                GripperCommand_SendGoal_Request_DataReader () {};
                ~GripperCommand_SendGoal_Request_DataReader () {};
            private:
                GripperCommand_SendGoal_Request_DataReader (const GripperCommand_SendGoal_Request_DataReader &);
                GripperCommand_SendGoal_Request_DataReader & operator = (const GripperCommand_SendGoal_Request_DataReader &);
            };

            class  GripperCommand_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GripperCommand_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef GripperCommand_SendGoal_Request_DataReaderView_var _var_type;

                static GripperCommand_SendGoal_Request_DataReaderView_ptr _duplicate (GripperCommand_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_SendGoal_Request_& instance) = 0;

            protected:
                GripperCommand_SendGoal_Request_DataReaderView () {};
                ~GripperCommand_SendGoal_Request_DataReaderView () {};
            private:
                GripperCommand_SendGoal_Request_DataReaderView (const GripperCommand_SendGoal_Request_DataReaderView &);
                GripperCommand_SendGoal_Request_DataReaderView & operator = (const GripperCommand_SendGoal_Request_DataReaderView &);
            };
            class GripperCommand_SendGoal_Response_TypeSupportInterface;

            typedef GripperCommand_SendGoal_Response_TypeSupportInterface * GripperCommand_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_SendGoal_Response_TypeSupportInterface> GripperCommand_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GripperCommand_SendGoal_Response_TypeSupportInterface> GripperCommand_SendGoal_Response_TypeSupportInterface_out;


            class GripperCommand_SendGoal_Response_DataWriter;

            typedef GripperCommand_SendGoal_Response_DataWriter * GripperCommand_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_SendGoal_Response_DataWriter> GripperCommand_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GripperCommand_SendGoal_Response_DataWriter> GripperCommand_SendGoal_Response_DataWriter_out;


            class GripperCommand_SendGoal_Response_DataReader;

            typedef GripperCommand_SendGoal_Response_DataReader * GripperCommand_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_SendGoal_Response_DataReader> GripperCommand_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GripperCommand_SendGoal_Response_DataReader> GripperCommand_SendGoal_Response_DataReader_out;


            class GripperCommand_SendGoal_Response_DataReaderView;

            typedef GripperCommand_SendGoal_Response_DataReaderView * GripperCommand_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_SendGoal_Response_DataReaderView> GripperCommand_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GripperCommand_SendGoal_Response_DataReaderView> GripperCommand_SendGoal_Response_DataReaderView_out;

            struct GripperCommand_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GripperCommand_SendGoal_Response_, struct GripperCommand_SendGoal_Response_Seq_uniq_> GripperCommand_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < GripperCommand_SendGoal_Response_Seq> GripperCommand_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GripperCommand_SendGoal_Response_Seq> GripperCommand_SendGoal_Response_Seq_out;

            class  GripperCommand_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GripperCommand_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GripperCommand_SendGoal_Response_TypeSupportInterface_var _var_type;

                static GripperCommand_SendGoal_Response_TypeSupportInterface_ptr _duplicate (GripperCommand_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GripperCommand_SendGoal_Response_TypeSupportInterface () {};
                ~GripperCommand_SendGoal_Response_TypeSupportInterface () {};
            private:
                GripperCommand_SendGoal_Response_TypeSupportInterface (const GripperCommand_SendGoal_Response_TypeSupportInterface &);
                GripperCommand_SendGoal_Response_TypeSupportInterface & operator = (const GripperCommand_SendGoal_Response_TypeSupportInterface &);
            };

            class  GripperCommand_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GripperCommand_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef GripperCommand_SendGoal_Response_DataWriter_var _var_type;

                static GripperCommand_SendGoal_Response_DataWriter_ptr _duplicate (GripperCommand_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GripperCommand_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GripperCommand_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GripperCommand_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GripperCommand_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GripperCommand_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GripperCommand_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GripperCommand_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GripperCommand_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GripperCommand_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GripperCommand_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GripperCommand_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_SendGoal_Response_& instance_data) = 0;

            protected:
                GripperCommand_SendGoal_Response_DataWriter () {};
                ~GripperCommand_SendGoal_Response_DataWriter () {};
            private:
                GripperCommand_SendGoal_Response_DataWriter (const GripperCommand_SendGoal_Response_DataWriter &);
                GripperCommand_SendGoal_Response_DataWriter & operator = (const GripperCommand_SendGoal_Response_DataWriter &);
            };

            class  GripperCommand_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GripperCommand_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef GripperCommand_SendGoal_Response_DataReader_var _var_type;

                static GripperCommand_SendGoal_Response_DataReader_ptr _duplicate (GripperCommand_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_SendGoal_Response_& instance) = 0;

            protected:
                GripperCommand_SendGoal_Response_DataReader () {};
                ~GripperCommand_SendGoal_Response_DataReader () {};
            private:
                GripperCommand_SendGoal_Response_DataReader (const GripperCommand_SendGoal_Response_DataReader &);
                GripperCommand_SendGoal_Response_DataReader & operator = (const GripperCommand_SendGoal_Response_DataReader &);
            };

            class  GripperCommand_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GripperCommand_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef GripperCommand_SendGoal_Response_DataReaderView_var _var_type;

                static GripperCommand_SendGoal_Response_DataReaderView_ptr _duplicate (GripperCommand_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_SendGoal_Response_& instance) = 0;

            protected:
                GripperCommand_SendGoal_Response_DataReaderView () {};
                ~GripperCommand_SendGoal_Response_DataReaderView () {};
            private:
                GripperCommand_SendGoal_Response_DataReaderView (const GripperCommand_SendGoal_Response_DataReaderView &);
                GripperCommand_SendGoal_Response_DataReaderView & operator = (const GripperCommand_SendGoal_Response_DataReaderView &);
            };
            class Sample_GripperCommand_SendGoal_Request_TypeSupportInterface;

            typedef Sample_GripperCommand_SendGoal_Request_TypeSupportInterface * Sample_GripperCommand_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GripperCommand_SendGoal_Request_TypeSupportInterface> Sample_GripperCommand_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GripperCommand_SendGoal_Request_TypeSupportInterface> Sample_GripperCommand_SendGoal_Request_TypeSupportInterface_out;


            class Sample_GripperCommand_SendGoal_Request_DataWriter;

            typedef Sample_GripperCommand_SendGoal_Request_DataWriter * Sample_GripperCommand_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GripperCommand_SendGoal_Request_DataWriter> Sample_GripperCommand_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GripperCommand_SendGoal_Request_DataWriter> Sample_GripperCommand_SendGoal_Request_DataWriter_out;


            class Sample_GripperCommand_SendGoal_Request_DataReader;

            typedef Sample_GripperCommand_SendGoal_Request_DataReader * Sample_GripperCommand_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GripperCommand_SendGoal_Request_DataReader> Sample_GripperCommand_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GripperCommand_SendGoal_Request_DataReader> Sample_GripperCommand_SendGoal_Request_DataReader_out;


            class Sample_GripperCommand_SendGoal_Request_DataReaderView;

            typedef Sample_GripperCommand_SendGoal_Request_DataReaderView * Sample_GripperCommand_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GripperCommand_SendGoal_Request_DataReaderView> Sample_GripperCommand_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GripperCommand_SendGoal_Request_DataReaderView> Sample_GripperCommand_SendGoal_Request_DataReaderView_out;

            struct Sample_GripperCommand_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GripperCommand_SendGoal_Request_, struct Sample_GripperCommand_SendGoal_Request_Seq_uniq_> Sample_GripperCommand_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GripperCommand_SendGoal_Request_Seq> Sample_GripperCommand_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GripperCommand_SendGoal_Request_Seq> Sample_GripperCommand_SendGoal_Request_Seq_out;

            class  Sample_GripperCommand_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GripperCommand_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GripperCommand_SendGoal_Request_TypeSupportInterface_var _var_type;

                static Sample_GripperCommand_SendGoal_Request_TypeSupportInterface_ptr _duplicate (Sample_GripperCommand_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GripperCommand_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GripperCommand_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GripperCommand_SendGoal_Request_TypeSupportInterface () {};
                ~Sample_GripperCommand_SendGoal_Request_TypeSupportInterface () {};
            private:
                Sample_GripperCommand_SendGoal_Request_TypeSupportInterface (const Sample_GripperCommand_SendGoal_Request_TypeSupportInterface &);
                Sample_GripperCommand_SendGoal_Request_TypeSupportInterface & operator = (const Sample_GripperCommand_SendGoal_Request_TypeSupportInterface &);
            };

            class  Sample_GripperCommand_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GripperCommand_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GripperCommand_SendGoal_Request_DataWriter_var _var_type;

                static Sample_GripperCommand_SendGoal_Request_DataWriter_ptr _duplicate (Sample_GripperCommand_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GripperCommand_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GripperCommand_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GripperCommand_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GripperCommand_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GripperCommand_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GripperCommand_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GripperCommand_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GripperCommand_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GripperCommand_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GripperCommand_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GripperCommand_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GripperCommand_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GripperCommand_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GripperCommand_SendGoal_Request_& instance_data) = 0;

            protected:
                Sample_GripperCommand_SendGoal_Request_DataWriter () {};
                ~Sample_GripperCommand_SendGoal_Request_DataWriter () {};
            private:
                Sample_GripperCommand_SendGoal_Request_DataWriter (const Sample_GripperCommand_SendGoal_Request_DataWriter &);
                Sample_GripperCommand_SendGoal_Request_DataWriter & operator = (const Sample_GripperCommand_SendGoal_Request_DataWriter &);
            };

            class  Sample_GripperCommand_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GripperCommand_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef Sample_GripperCommand_SendGoal_Request_DataReader_var _var_type;

                static Sample_GripperCommand_SendGoal_Request_DataReader_ptr _duplicate (Sample_GripperCommand_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GripperCommand_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GripperCommand_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GripperCommand_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GripperCommand_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GripperCommand_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GripperCommand_SendGoal_Request_& instance) = 0;

            protected:
                Sample_GripperCommand_SendGoal_Request_DataReader () {};
                ~Sample_GripperCommand_SendGoal_Request_DataReader () {};
            private:
                Sample_GripperCommand_SendGoal_Request_DataReader (const Sample_GripperCommand_SendGoal_Request_DataReader &);
                Sample_GripperCommand_SendGoal_Request_DataReader & operator = (const Sample_GripperCommand_SendGoal_Request_DataReader &);
            };

            class  Sample_GripperCommand_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GripperCommand_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GripperCommand_SendGoal_Request_DataReaderView_var _var_type;

                static Sample_GripperCommand_SendGoal_Request_DataReaderView_ptr _duplicate (Sample_GripperCommand_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GripperCommand_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GripperCommand_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GripperCommand_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GripperCommand_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GripperCommand_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GripperCommand_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GripperCommand_SendGoal_Request_& instance) = 0;

            protected:
                Sample_GripperCommand_SendGoal_Request_DataReaderView () {};
                ~Sample_GripperCommand_SendGoal_Request_DataReaderView () {};
            private:
                Sample_GripperCommand_SendGoal_Request_DataReaderView (const Sample_GripperCommand_SendGoal_Request_DataReaderView &);
                Sample_GripperCommand_SendGoal_Request_DataReaderView & operator = (const Sample_GripperCommand_SendGoal_Request_DataReaderView &);
            };
            class Sample_GripperCommand_SendGoal_Response_TypeSupportInterface;

            typedef Sample_GripperCommand_SendGoal_Response_TypeSupportInterface * Sample_GripperCommand_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GripperCommand_SendGoal_Response_TypeSupportInterface> Sample_GripperCommand_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GripperCommand_SendGoal_Response_TypeSupportInterface> Sample_GripperCommand_SendGoal_Response_TypeSupportInterface_out;


            class Sample_GripperCommand_SendGoal_Response_DataWriter;

            typedef Sample_GripperCommand_SendGoal_Response_DataWriter * Sample_GripperCommand_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GripperCommand_SendGoal_Response_DataWriter> Sample_GripperCommand_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GripperCommand_SendGoal_Response_DataWriter> Sample_GripperCommand_SendGoal_Response_DataWriter_out;


            class Sample_GripperCommand_SendGoal_Response_DataReader;

            typedef Sample_GripperCommand_SendGoal_Response_DataReader * Sample_GripperCommand_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GripperCommand_SendGoal_Response_DataReader> Sample_GripperCommand_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GripperCommand_SendGoal_Response_DataReader> Sample_GripperCommand_SendGoal_Response_DataReader_out;


            class Sample_GripperCommand_SendGoal_Response_DataReaderView;

            typedef Sample_GripperCommand_SendGoal_Response_DataReaderView * Sample_GripperCommand_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GripperCommand_SendGoal_Response_DataReaderView> Sample_GripperCommand_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GripperCommand_SendGoal_Response_DataReaderView> Sample_GripperCommand_SendGoal_Response_DataReaderView_out;

            struct Sample_GripperCommand_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GripperCommand_SendGoal_Response_, struct Sample_GripperCommand_SendGoal_Response_Seq_uniq_> Sample_GripperCommand_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GripperCommand_SendGoal_Response_Seq> Sample_GripperCommand_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GripperCommand_SendGoal_Response_Seq> Sample_GripperCommand_SendGoal_Response_Seq_out;

            class  Sample_GripperCommand_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GripperCommand_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GripperCommand_SendGoal_Response_TypeSupportInterface_var _var_type;

                static Sample_GripperCommand_SendGoal_Response_TypeSupportInterface_ptr _duplicate (Sample_GripperCommand_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GripperCommand_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GripperCommand_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GripperCommand_SendGoal_Response_TypeSupportInterface () {};
                ~Sample_GripperCommand_SendGoal_Response_TypeSupportInterface () {};
            private:
                Sample_GripperCommand_SendGoal_Response_TypeSupportInterface (const Sample_GripperCommand_SendGoal_Response_TypeSupportInterface &);
                Sample_GripperCommand_SendGoal_Response_TypeSupportInterface & operator = (const Sample_GripperCommand_SendGoal_Response_TypeSupportInterface &);
            };

            class  Sample_GripperCommand_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GripperCommand_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GripperCommand_SendGoal_Response_DataWriter_var _var_type;

                static Sample_GripperCommand_SendGoal_Response_DataWriter_ptr _duplicate (Sample_GripperCommand_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GripperCommand_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GripperCommand_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GripperCommand_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GripperCommand_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GripperCommand_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GripperCommand_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GripperCommand_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GripperCommand_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GripperCommand_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GripperCommand_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GripperCommand_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GripperCommand_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GripperCommand_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GripperCommand_SendGoal_Response_& instance_data) = 0;

            protected:
                Sample_GripperCommand_SendGoal_Response_DataWriter () {};
                ~Sample_GripperCommand_SendGoal_Response_DataWriter () {};
            private:
                Sample_GripperCommand_SendGoal_Response_DataWriter (const Sample_GripperCommand_SendGoal_Response_DataWriter &);
                Sample_GripperCommand_SendGoal_Response_DataWriter & operator = (const Sample_GripperCommand_SendGoal_Response_DataWriter &);
            };

            class  Sample_GripperCommand_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GripperCommand_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef Sample_GripperCommand_SendGoal_Response_DataReader_var _var_type;

                static Sample_GripperCommand_SendGoal_Response_DataReader_ptr _duplicate (Sample_GripperCommand_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GripperCommand_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GripperCommand_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GripperCommand_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GripperCommand_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GripperCommand_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GripperCommand_SendGoal_Response_& instance) = 0;

            protected:
                Sample_GripperCommand_SendGoal_Response_DataReader () {};
                ~Sample_GripperCommand_SendGoal_Response_DataReader () {};
            private:
                Sample_GripperCommand_SendGoal_Response_DataReader (const Sample_GripperCommand_SendGoal_Response_DataReader &);
                Sample_GripperCommand_SendGoal_Response_DataReader & operator = (const Sample_GripperCommand_SendGoal_Response_DataReader &);
            };

            class  Sample_GripperCommand_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GripperCommand_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GripperCommand_SendGoal_Response_DataReaderView_var _var_type;

                static Sample_GripperCommand_SendGoal_Response_DataReaderView_ptr _duplicate (Sample_GripperCommand_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GripperCommand_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GripperCommand_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GripperCommand_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GripperCommand_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GripperCommand_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GripperCommand_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GripperCommand_SendGoal_Response_& instance) = 0;

            protected:
                Sample_GripperCommand_SendGoal_Response_DataReaderView () {};
                ~Sample_GripperCommand_SendGoal_Response_DataReaderView () {};
            private:
                Sample_GripperCommand_SendGoal_Response_DataReaderView (const Sample_GripperCommand_SendGoal_Response_DataReaderView &);
                Sample_GripperCommand_SendGoal_Response_DataReaderView & operator = (const Sample_GripperCommand_SendGoal_Response_DataReaderView &);
            };
            class GripperCommand_Result_TypeSupportInterface;

            typedef GripperCommand_Result_TypeSupportInterface * GripperCommand_Result_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Result_TypeSupportInterface> GripperCommand_Result_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Result_TypeSupportInterface> GripperCommand_Result_TypeSupportInterface_out;


            class GripperCommand_Result_DataWriter;

            typedef GripperCommand_Result_DataWriter * GripperCommand_Result_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Result_DataWriter> GripperCommand_Result_DataWriter_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Result_DataWriter> GripperCommand_Result_DataWriter_out;


            class GripperCommand_Result_DataReader;

            typedef GripperCommand_Result_DataReader * GripperCommand_Result_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Result_DataReader> GripperCommand_Result_DataReader_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Result_DataReader> GripperCommand_Result_DataReader_out;


            class GripperCommand_Result_DataReaderView;

            typedef GripperCommand_Result_DataReaderView * GripperCommand_Result_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Result_DataReaderView> GripperCommand_Result_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Result_DataReaderView> GripperCommand_Result_DataReaderView_out;

            struct GripperCommand_Result_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GripperCommand_Result_, struct GripperCommand_Result_Seq_uniq_> GripperCommand_Result_Seq;
            typedef DDS_DCPSSequence_var < GripperCommand_Result_Seq> GripperCommand_Result_Seq_var;
            typedef DDS_DCPSSequence_out < GripperCommand_Result_Seq> GripperCommand_Result_Seq_out;

            class  GripperCommand_Result_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GripperCommand_Result_TypeSupportInterface_ptr _ptr_type;
                typedef GripperCommand_Result_TypeSupportInterface_var _var_type;

                static GripperCommand_Result_TypeSupportInterface_ptr _duplicate (GripperCommand_Result_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Result_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Result_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Result_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Result_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GripperCommand_Result_TypeSupportInterface () {};
                ~GripperCommand_Result_TypeSupportInterface () {};
            private:
                GripperCommand_Result_TypeSupportInterface (const GripperCommand_Result_TypeSupportInterface &);
                GripperCommand_Result_TypeSupportInterface & operator = (const GripperCommand_Result_TypeSupportInterface &);
            };

            class  GripperCommand_Result_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GripperCommand_Result_DataWriter_ptr _ptr_type;
                typedef GripperCommand_Result_DataWriter_var _var_type;

                static GripperCommand_Result_DataWriter_ptr _duplicate (GripperCommand_Result_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Result_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Result_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Result_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Result_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GripperCommand_Result_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GripperCommand_Result_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GripperCommand_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GripperCommand_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GripperCommand_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GripperCommand_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GripperCommand_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GripperCommand_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GripperCommand_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GripperCommand_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GripperCommand_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_Result_& instance_data) = 0;

            protected:
                GripperCommand_Result_DataWriter () {};
                ~GripperCommand_Result_DataWriter () {};
            private:
                GripperCommand_Result_DataWriter (const GripperCommand_Result_DataWriter &);
                GripperCommand_Result_DataWriter & operator = (const GripperCommand_Result_DataWriter &);
            };

            class  GripperCommand_Result_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GripperCommand_Result_DataReader_ptr _ptr_type;
                typedef GripperCommand_Result_DataReader_var _var_type;

                static GripperCommand_Result_DataReader_ptr _duplicate (GripperCommand_Result_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Result_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Result_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Result_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Result_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_Result_& instance) = 0;

            protected:
                GripperCommand_Result_DataReader () {};
                ~GripperCommand_Result_DataReader () {};
            private:
                GripperCommand_Result_DataReader (const GripperCommand_Result_DataReader &);
                GripperCommand_Result_DataReader & operator = (const GripperCommand_Result_DataReader &);
            };

            class  GripperCommand_Result_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GripperCommand_Result_DataReaderView_ptr _ptr_type;
                typedef GripperCommand_Result_DataReaderView_var _var_type;

                static GripperCommand_Result_DataReaderView_ptr _duplicate (GripperCommand_Result_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Result_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Result_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Result_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Result_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_Result_& instance) = 0;

            protected:
                GripperCommand_Result_DataReaderView () {};
                ~GripperCommand_Result_DataReaderView () {};
            private:
                GripperCommand_Result_DataReaderView (const GripperCommand_Result_DataReaderView &);
                GripperCommand_Result_DataReaderView & operator = (const GripperCommand_Result_DataReaderView &);
            };
            class GripperCommand_GetResult_Request_TypeSupportInterface;

            typedef GripperCommand_GetResult_Request_TypeSupportInterface * GripperCommand_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_GetResult_Request_TypeSupportInterface> GripperCommand_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GripperCommand_GetResult_Request_TypeSupportInterface> GripperCommand_GetResult_Request_TypeSupportInterface_out;


            class GripperCommand_GetResult_Request_DataWriter;

            typedef GripperCommand_GetResult_Request_DataWriter * GripperCommand_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_GetResult_Request_DataWriter> GripperCommand_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GripperCommand_GetResult_Request_DataWriter> GripperCommand_GetResult_Request_DataWriter_out;


            class GripperCommand_GetResult_Request_DataReader;

            typedef GripperCommand_GetResult_Request_DataReader * GripperCommand_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_GetResult_Request_DataReader> GripperCommand_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GripperCommand_GetResult_Request_DataReader> GripperCommand_GetResult_Request_DataReader_out;


            class GripperCommand_GetResult_Request_DataReaderView;

            typedef GripperCommand_GetResult_Request_DataReaderView * GripperCommand_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_GetResult_Request_DataReaderView> GripperCommand_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GripperCommand_GetResult_Request_DataReaderView> GripperCommand_GetResult_Request_DataReaderView_out;

            struct GripperCommand_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GripperCommand_GetResult_Request_, struct GripperCommand_GetResult_Request_Seq_uniq_> GripperCommand_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < GripperCommand_GetResult_Request_Seq> GripperCommand_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GripperCommand_GetResult_Request_Seq> GripperCommand_GetResult_Request_Seq_out;

            class  GripperCommand_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GripperCommand_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GripperCommand_GetResult_Request_TypeSupportInterface_var _var_type;

                static GripperCommand_GetResult_Request_TypeSupportInterface_ptr _duplicate (GripperCommand_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GripperCommand_GetResult_Request_TypeSupportInterface () {};
                ~GripperCommand_GetResult_Request_TypeSupportInterface () {};
            private:
                GripperCommand_GetResult_Request_TypeSupportInterface (const GripperCommand_GetResult_Request_TypeSupportInterface &);
                GripperCommand_GetResult_Request_TypeSupportInterface & operator = (const GripperCommand_GetResult_Request_TypeSupportInterface &);
            };

            class  GripperCommand_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GripperCommand_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef GripperCommand_GetResult_Request_DataWriter_var _var_type;

                static GripperCommand_GetResult_Request_DataWriter_ptr _duplicate (GripperCommand_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GripperCommand_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GripperCommand_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GripperCommand_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GripperCommand_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GripperCommand_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GripperCommand_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GripperCommand_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GripperCommand_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GripperCommand_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GripperCommand_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GripperCommand_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_GetResult_Request_& instance_data) = 0;

            protected:
                GripperCommand_GetResult_Request_DataWriter () {};
                ~GripperCommand_GetResult_Request_DataWriter () {};
            private:
                GripperCommand_GetResult_Request_DataWriter (const GripperCommand_GetResult_Request_DataWriter &);
                GripperCommand_GetResult_Request_DataWriter & operator = (const GripperCommand_GetResult_Request_DataWriter &);
            };

            class  GripperCommand_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GripperCommand_GetResult_Request_DataReader_ptr _ptr_type;
                typedef GripperCommand_GetResult_Request_DataReader_var _var_type;

                static GripperCommand_GetResult_Request_DataReader_ptr _duplicate (GripperCommand_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_GetResult_Request_& instance) = 0;

            protected:
                GripperCommand_GetResult_Request_DataReader () {};
                ~GripperCommand_GetResult_Request_DataReader () {};
            private:
                GripperCommand_GetResult_Request_DataReader (const GripperCommand_GetResult_Request_DataReader &);
                GripperCommand_GetResult_Request_DataReader & operator = (const GripperCommand_GetResult_Request_DataReader &);
            };

            class  GripperCommand_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GripperCommand_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef GripperCommand_GetResult_Request_DataReaderView_var _var_type;

                static GripperCommand_GetResult_Request_DataReaderView_ptr _duplicate (GripperCommand_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_GetResult_Request_& instance) = 0;

            protected:
                GripperCommand_GetResult_Request_DataReaderView () {};
                ~GripperCommand_GetResult_Request_DataReaderView () {};
            private:
                GripperCommand_GetResult_Request_DataReaderView (const GripperCommand_GetResult_Request_DataReaderView &);
                GripperCommand_GetResult_Request_DataReaderView & operator = (const GripperCommand_GetResult_Request_DataReaderView &);
            };
            class GripperCommand_GetResult_Response_TypeSupportInterface;

            typedef GripperCommand_GetResult_Response_TypeSupportInterface * GripperCommand_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_GetResult_Response_TypeSupportInterface> GripperCommand_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GripperCommand_GetResult_Response_TypeSupportInterface> GripperCommand_GetResult_Response_TypeSupportInterface_out;


            class GripperCommand_GetResult_Response_DataWriter;

            typedef GripperCommand_GetResult_Response_DataWriter * GripperCommand_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_GetResult_Response_DataWriter> GripperCommand_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GripperCommand_GetResult_Response_DataWriter> GripperCommand_GetResult_Response_DataWriter_out;


            class GripperCommand_GetResult_Response_DataReader;

            typedef GripperCommand_GetResult_Response_DataReader * GripperCommand_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_GetResult_Response_DataReader> GripperCommand_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GripperCommand_GetResult_Response_DataReader> GripperCommand_GetResult_Response_DataReader_out;


            class GripperCommand_GetResult_Response_DataReaderView;

            typedef GripperCommand_GetResult_Response_DataReaderView * GripperCommand_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_GetResult_Response_DataReaderView> GripperCommand_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GripperCommand_GetResult_Response_DataReaderView> GripperCommand_GetResult_Response_DataReaderView_out;

            struct GripperCommand_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GripperCommand_GetResult_Response_, struct GripperCommand_GetResult_Response_Seq_uniq_> GripperCommand_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < GripperCommand_GetResult_Response_Seq> GripperCommand_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GripperCommand_GetResult_Response_Seq> GripperCommand_GetResult_Response_Seq_out;

            class  GripperCommand_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GripperCommand_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GripperCommand_GetResult_Response_TypeSupportInterface_var _var_type;

                static GripperCommand_GetResult_Response_TypeSupportInterface_ptr _duplicate (GripperCommand_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GripperCommand_GetResult_Response_TypeSupportInterface () {};
                ~GripperCommand_GetResult_Response_TypeSupportInterface () {};
            private:
                GripperCommand_GetResult_Response_TypeSupportInterface (const GripperCommand_GetResult_Response_TypeSupportInterface &);
                GripperCommand_GetResult_Response_TypeSupportInterface & operator = (const GripperCommand_GetResult_Response_TypeSupportInterface &);
            };

            class  GripperCommand_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GripperCommand_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef GripperCommand_GetResult_Response_DataWriter_var _var_type;

                static GripperCommand_GetResult_Response_DataWriter_ptr _duplicate (GripperCommand_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GripperCommand_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GripperCommand_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GripperCommand_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GripperCommand_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GripperCommand_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GripperCommand_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GripperCommand_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GripperCommand_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GripperCommand_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GripperCommand_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GripperCommand_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_GetResult_Response_& instance_data) = 0;

            protected:
                GripperCommand_GetResult_Response_DataWriter () {};
                ~GripperCommand_GetResult_Response_DataWriter () {};
            private:
                GripperCommand_GetResult_Response_DataWriter (const GripperCommand_GetResult_Response_DataWriter &);
                GripperCommand_GetResult_Response_DataWriter & operator = (const GripperCommand_GetResult_Response_DataWriter &);
            };

            class  GripperCommand_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GripperCommand_GetResult_Response_DataReader_ptr _ptr_type;
                typedef GripperCommand_GetResult_Response_DataReader_var _var_type;

                static GripperCommand_GetResult_Response_DataReader_ptr _duplicate (GripperCommand_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_GetResult_Response_& instance) = 0;

            protected:
                GripperCommand_GetResult_Response_DataReader () {};
                ~GripperCommand_GetResult_Response_DataReader () {};
            private:
                GripperCommand_GetResult_Response_DataReader (const GripperCommand_GetResult_Response_DataReader &);
                GripperCommand_GetResult_Response_DataReader & operator = (const GripperCommand_GetResult_Response_DataReader &);
            };

            class  GripperCommand_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GripperCommand_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef GripperCommand_GetResult_Response_DataReaderView_var _var_type;

                static GripperCommand_GetResult_Response_DataReaderView_ptr _duplicate (GripperCommand_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_GetResult_Response_& instance) = 0;

            protected:
                GripperCommand_GetResult_Response_DataReaderView () {};
                ~GripperCommand_GetResult_Response_DataReaderView () {};
            private:
                GripperCommand_GetResult_Response_DataReaderView (const GripperCommand_GetResult_Response_DataReaderView &);
                GripperCommand_GetResult_Response_DataReaderView & operator = (const GripperCommand_GetResult_Response_DataReaderView &);
            };
            class Sample_GripperCommand_GetResult_Request_TypeSupportInterface;

            typedef Sample_GripperCommand_GetResult_Request_TypeSupportInterface * Sample_GripperCommand_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GripperCommand_GetResult_Request_TypeSupportInterface> Sample_GripperCommand_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GripperCommand_GetResult_Request_TypeSupportInterface> Sample_GripperCommand_GetResult_Request_TypeSupportInterface_out;


            class Sample_GripperCommand_GetResult_Request_DataWriter;

            typedef Sample_GripperCommand_GetResult_Request_DataWriter * Sample_GripperCommand_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GripperCommand_GetResult_Request_DataWriter> Sample_GripperCommand_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GripperCommand_GetResult_Request_DataWriter> Sample_GripperCommand_GetResult_Request_DataWriter_out;


            class Sample_GripperCommand_GetResult_Request_DataReader;

            typedef Sample_GripperCommand_GetResult_Request_DataReader * Sample_GripperCommand_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GripperCommand_GetResult_Request_DataReader> Sample_GripperCommand_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GripperCommand_GetResult_Request_DataReader> Sample_GripperCommand_GetResult_Request_DataReader_out;


            class Sample_GripperCommand_GetResult_Request_DataReaderView;

            typedef Sample_GripperCommand_GetResult_Request_DataReaderView * Sample_GripperCommand_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GripperCommand_GetResult_Request_DataReaderView> Sample_GripperCommand_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GripperCommand_GetResult_Request_DataReaderView> Sample_GripperCommand_GetResult_Request_DataReaderView_out;

            struct Sample_GripperCommand_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GripperCommand_GetResult_Request_, struct Sample_GripperCommand_GetResult_Request_Seq_uniq_> Sample_GripperCommand_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GripperCommand_GetResult_Request_Seq> Sample_GripperCommand_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GripperCommand_GetResult_Request_Seq> Sample_GripperCommand_GetResult_Request_Seq_out;

            class  Sample_GripperCommand_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GripperCommand_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GripperCommand_GetResult_Request_TypeSupportInterface_var _var_type;

                static Sample_GripperCommand_GetResult_Request_TypeSupportInterface_ptr _duplicate (Sample_GripperCommand_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GripperCommand_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GripperCommand_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GripperCommand_GetResult_Request_TypeSupportInterface () {};
                ~Sample_GripperCommand_GetResult_Request_TypeSupportInterface () {};
            private:
                Sample_GripperCommand_GetResult_Request_TypeSupportInterface (const Sample_GripperCommand_GetResult_Request_TypeSupportInterface &);
                Sample_GripperCommand_GetResult_Request_TypeSupportInterface & operator = (const Sample_GripperCommand_GetResult_Request_TypeSupportInterface &);
            };

            class  Sample_GripperCommand_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GripperCommand_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GripperCommand_GetResult_Request_DataWriter_var _var_type;

                static Sample_GripperCommand_GetResult_Request_DataWriter_ptr _duplicate (Sample_GripperCommand_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GripperCommand_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GripperCommand_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GripperCommand_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GripperCommand_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GripperCommand_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GripperCommand_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GripperCommand_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GripperCommand_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GripperCommand_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GripperCommand_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GripperCommand_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GripperCommand_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GripperCommand_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GripperCommand_GetResult_Request_& instance_data) = 0;

            protected:
                Sample_GripperCommand_GetResult_Request_DataWriter () {};
                ~Sample_GripperCommand_GetResult_Request_DataWriter () {};
            private:
                Sample_GripperCommand_GetResult_Request_DataWriter (const Sample_GripperCommand_GetResult_Request_DataWriter &);
                Sample_GripperCommand_GetResult_Request_DataWriter & operator = (const Sample_GripperCommand_GetResult_Request_DataWriter &);
            };

            class  Sample_GripperCommand_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GripperCommand_GetResult_Request_DataReader_ptr _ptr_type;
                typedef Sample_GripperCommand_GetResult_Request_DataReader_var _var_type;

                static Sample_GripperCommand_GetResult_Request_DataReader_ptr _duplicate (Sample_GripperCommand_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GripperCommand_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GripperCommand_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GripperCommand_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GripperCommand_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GripperCommand_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GripperCommand_GetResult_Request_& instance) = 0;

            protected:
                Sample_GripperCommand_GetResult_Request_DataReader () {};
                ~Sample_GripperCommand_GetResult_Request_DataReader () {};
            private:
                Sample_GripperCommand_GetResult_Request_DataReader (const Sample_GripperCommand_GetResult_Request_DataReader &);
                Sample_GripperCommand_GetResult_Request_DataReader & operator = (const Sample_GripperCommand_GetResult_Request_DataReader &);
            };

            class  Sample_GripperCommand_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GripperCommand_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GripperCommand_GetResult_Request_DataReaderView_var _var_type;

                static Sample_GripperCommand_GetResult_Request_DataReaderView_ptr _duplicate (Sample_GripperCommand_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GripperCommand_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GripperCommand_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GripperCommand_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GripperCommand_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GripperCommand_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GripperCommand_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GripperCommand_GetResult_Request_& instance) = 0;

            protected:
                Sample_GripperCommand_GetResult_Request_DataReaderView () {};
                ~Sample_GripperCommand_GetResult_Request_DataReaderView () {};
            private:
                Sample_GripperCommand_GetResult_Request_DataReaderView (const Sample_GripperCommand_GetResult_Request_DataReaderView &);
                Sample_GripperCommand_GetResult_Request_DataReaderView & operator = (const Sample_GripperCommand_GetResult_Request_DataReaderView &);
            };
            class Sample_GripperCommand_GetResult_Response_TypeSupportInterface;

            typedef Sample_GripperCommand_GetResult_Response_TypeSupportInterface * Sample_GripperCommand_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GripperCommand_GetResult_Response_TypeSupportInterface> Sample_GripperCommand_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GripperCommand_GetResult_Response_TypeSupportInterface> Sample_GripperCommand_GetResult_Response_TypeSupportInterface_out;


            class Sample_GripperCommand_GetResult_Response_DataWriter;

            typedef Sample_GripperCommand_GetResult_Response_DataWriter * Sample_GripperCommand_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GripperCommand_GetResult_Response_DataWriter> Sample_GripperCommand_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GripperCommand_GetResult_Response_DataWriter> Sample_GripperCommand_GetResult_Response_DataWriter_out;


            class Sample_GripperCommand_GetResult_Response_DataReader;

            typedef Sample_GripperCommand_GetResult_Response_DataReader * Sample_GripperCommand_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GripperCommand_GetResult_Response_DataReader> Sample_GripperCommand_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GripperCommand_GetResult_Response_DataReader> Sample_GripperCommand_GetResult_Response_DataReader_out;


            class Sample_GripperCommand_GetResult_Response_DataReaderView;

            typedef Sample_GripperCommand_GetResult_Response_DataReaderView * Sample_GripperCommand_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GripperCommand_GetResult_Response_DataReaderView> Sample_GripperCommand_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GripperCommand_GetResult_Response_DataReaderView> Sample_GripperCommand_GetResult_Response_DataReaderView_out;

            struct Sample_GripperCommand_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GripperCommand_GetResult_Response_, struct Sample_GripperCommand_GetResult_Response_Seq_uniq_> Sample_GripperCommand_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GripperCommand_GetResult_Response_Seq> Sample_GripperCommand_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GripperCommand_GetResult_Response_Seq> Sample_GripperCommand_GetResult_Response_Seq_out;

            class  Sample_GripperCommand_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GripperCommand_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GripperCommand_GetResult_Response_TypeSupportInterface_var _var_type;

                static Sample_GripperCommand_GetResult_Response_TypeSupportInterface_ptr _duplicate (Sample_GripperCommand_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GripperCommand_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GripperCommand_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GripperCommand_GetResult_Response_TypeSupportInterface () {};
                ~Sample_GripperCommand_GetResult_Response_TypeSupportInterface () {};
            private:
                Sample_GripperCommand_GetResult_Response_TypeSupportInterface (const Sample_GripperCommand_GetResult_Response_TypeSupportInterface &);
                Sample_GripperCommand_GetResult_Response_TypeSupportInterface & operator = (const Sample_GripperCommand_GetResult_Response_TypeSupportInterface &);
            };

            class  Sample_GripperCommand_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GripperCommand_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GripperCommand_GetResult_Response_DataWriter_var _var_type;

                static Sample_GripperCommand_GetResult_Response_DataWriter_ptr _duplicate (Sample_GripperCommand_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GripperCommand_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GripperCommand_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GripperCommand_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GripperCommand_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GripperCommand_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GripperCommand_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GripperCommand_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GripperCommand_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GripperCommand_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GripperCommand_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GripperCommand_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GripperCommand_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GripperCommand_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GripperCommand_GetResult_Response_& instance_data) = 0;

            protected:
                Sample_GripperCommand_GetResult_Response_DataWriter () {};
                ~Sample_GripperCommand_GetResult_Response_DataWriter () {};
            private:
                Sample_GripperCommand_GetResult_Response_DataWriter (const Sample_GripperCommand_GetResult_Response_DataWriter &);
                Sample_GripperCommand_GetResult_Response_DataWriter & operator = (const Sample_GripperCommand_GetResult_Response_DataWriter &);
            };

            class  Sample_GripperCommand_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GripperCommand_GetResult_Response_DataReader_ptr _ptr_type;
                typedef Sample_GripperCommand_GetResult_Response_DataReader_var _var_type;

                static Sample_GripperCommand_GetResult_Response_DataReader_ptr _duplicate (Sample_GripperCommand_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GripperCommand_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GripperCommand_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GripperCommand_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GripperCommand_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GripperCommand_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GripperCommand_GetResult_Response_& instance) = 0;

            protected:
                Sample_GripperCommand_GetResult_Response_DataReader () {};
                ~Sample_GripperCommand_GetResult_Response_DataReader () {};
            private:
                Sample_GripperCommand_GetResult_Response_DataReader (const Sample_GripperCommand_GetResult_Response_DataReader &);
                Sample_GripperCommand_GetResult_Response_DataReader & operator = (const Sample_GripperCommand_GetResult_Response_DataReader &);
            };

            class  Sample_GripperCommand_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GripperCommand_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GripperCommand_GetResult_Response_DataReaderView_var _var_type;

                static Sample_GripperCommand_GetResult_Response_DataReaderView_ptr _duplicate (Sample_GripperCommand_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GripperCommand_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GripperCommand_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GripperCommand_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GripperCommand_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GripperCommand_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GripperCommand_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GripperCommand_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GripperCommand_GetResult_Response_& instance) = 0;

            protected:
                Sample_GripperCommand_GetResult_Response_DataReaderView () {};
                ~Sample_GripperCommand_GetResult_Response_DataReaderView () {};
            private:
                Sample_GripperCommand_GetResult_Response_DataReaderView (const Sample_GripperCommand_GetResult_Response_DataReaderView &);
                Sample_GripperCommand_GetResult_Response_DataReaderView & operator = (const Sample_GripperCommand_GetResult_Response_DataReaderView &);
            };
            class GripperCommand_Feedback_TypeSupportInterface;

            typedef GripperCommand_Feedback_TypeSupportInterface * GripperCommand_Feedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Feedback_TypeSupportInterface> GripperCommand_Feedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Feedback_TypeSupportInterface> GripperCommand_Feedback_TypeSupportInterface_out;


            class GripperCommand_Feedback_DataWriter;

            typedef GripperCommand_Feedback_DataWriter * GripperCommand_Feedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Feedback_DataWriter> GripperCommand_Feedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Feedback_DataWriter> GripperCommand_Feedback_DataWriter_out;


            class GripperCommand_Feedback_DataReader;

            typedef GripperCommand_Feedback_DataReader * GripperCommand_Feedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Feedback_DataReader> GripperCommand_Feedback_DataReader_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Feedback_DataReader> GripperCommand_Feedback_DataReader_out;


            class GripperCommand_Feedback_DataReaderView;

            typedef GripperCommand_Feedback_DataReaderView * GripperCommand_Feedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_Feedback_DataReaderView> GripperCommand_Feedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GripperCommand_Feedback_DataReaderView> GripperCommand_Feedback_DataReaderView_out;

            struct GripperCommand_Feedback_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GripperCommand_Feedback_, struct GripperCommand_Feedback_Seq_uniq_> GripperCommand_Feedback_Seq;
            typedef DDS_DCPSSequence_var < GripperCommand_Feedback_Seq> GripperCommand_Feedback_Seq_var;
            typedef DDS_DCPSSequence_out < GripperCommand_Feedback_Seq> GripperCommand_Feedback_Seq_out;

            class  GripperCommand_Feedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GripperCommand_Feedback_TypeSupportInterface_ptr _ptr_type;
                typedef GripperCommand_Feedback_TypeSupportInterface_var _var_type;

                static GripperCommand_Feedback_TypeSupportInterface_ptr _duplicate (GripperCommand_Feedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Feedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Feedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Feedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Feedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GripperCommand_Feedback_TypeSupportInterface () {};
                ~GripperCommand_Feedback_TypeSupportInterface () {};
            private:
                GripperCommand_Feedback_TypeSupportInterface (const GripperCommand_Feedback_TypeSupportInterface &);
                GripperCommand_Feedback_TypeSupportInterface & operator = (const GripperCommand_Feedback_TypeSupportInterface &);
            };

            class  GripperCommand_Feedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GripperCommand_Feedback_DataWriter_ptr _ptr_type;
                typedef GripperCommand_Feedback_DataWriter_var _var_type;

                static GripperCommand_Feedback_DataWriter_ptr _duplicate (GripperCommand_Feedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Feedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Feedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Feedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Feedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GripperCommand_Feedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GripperCommand_Feedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GripperCommand_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GripperCommand_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GripperCommand_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GripperCommand_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GripperCommand_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GripperCommand_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GripperCommand_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GripperCommand_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GripperCommand_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_Feedback_& instance_data) = 0;

            protected:
                GripperCommand_Feedback_DataWriter () {};
                ~GripperCommand_Feedback_DataWriter () {};
            private:
                GripperCommand_Feedback_DataWriter (const GripperCommand_Feedback_DataWriter &);
                GripperCommand_Feedback_DataWriter & operator = (const GripperCommand_Feedback_DataWriter &);
            };

            class  GripperCommand_Feedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GripperCommand_Feedback_DataReader_ptr _ptr_type;
                typedef GripperCommand_Feedback_DataReader_var _var_type;

                static GripperCommand_Feedback_DataReader_ptr _duplicate (GripperCommand_Feedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Feedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Feedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Feedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Feedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_Feedback_& instance) = 0;

            protected:
                GripperCommand_Feedback_DataReader () {};
                ~GripperCommand_Feedback_DataReader () {};
            private:
                GripperCommand_Feedback_DataReader (const GripperCommand_Feedback_DataReader &);
                GripperCommand_Feedback_DataReader & operator = (const GripperCommand_Feedback_DataReader &);
            };

            class  GripperCommand_Feedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GripperCommand_Feedback_DataReaderView_ptr _ptr_type;
                typedef GripperCommand_Feedback_DataReaderView_var _var_type;

                static GripperCommand_Feedback_DataReaderView_ptr _duplicate (GripperCommand_Feedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_Feedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_Feedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_Feedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_Feedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_Feedback_& instance) = 0;

            protected:
                GripperCommand_Feedback_DataReaderView () {};
                ~GripperCommand_Feedback_DataReaderView () {};
            private:
                GripperCommand_Feedback_DataReaderView (const GripperCommand_Feedback_DataReaderView &);
                GripperCommand_Feedback_DataReaderView & operator = (const GripperCommand_Feedback_DataReaderView &);
            };
            class GripperCommand_FeedbackMessage_TypeSupportInterface;

            typedef GripperCommand_FeedbackMessage_TypeSupportInterface * GripperCommand_FeedbackMessage_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_FeedbackMessage_TypeSupportInterface> GripperCommand_FeedbackMessage_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GripperCommand_FeedbackMessage_TypeSupportInterface> GripperCommand_FeedbackMessage_TypeSupportInterface_out;


            class GripperCommand_FeedbackMessage_DataWriter;

            typedef GripperCommand_FeedbackMessage_DataWriter * GripperCommand_FeedbackMessage_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_FeedbackMessage_DataWriter> GripperCommand_FeedbackMessage_DataWriter_var;
            typedef DDS_DCPSInterface_out < GripperCommand_FeedbackMessage_DataWriter> GripperCommand_FeedbackMessage_DataWriter_out;


            class GripperCommand_FeedbackMessage_DataReader;

            typedef GripperCommand_FeedbackMessage_DataReader * GripperCommand_FeedbackMessage_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_FeedbackMessage_DataReader> GripperCommand_FeedbackMessage_DataReader_var;
            typedef DDS_DCPSInterface_out < GripperCommand_FeedbackMessage_DataReader> GripperCommand_FeedbackMessage_DataReader_out;


            class GripperCommand_FeedbackMessage_DataReaderView;

            typedef GripperCommand_FeedbackMessage_DataReaderView * GripperCommand_FeedbackMessage_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GripperCommand_FeedbackMessage_DataReaderView> GripperCommand_FeedbackMessage_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GripperCommand_FeedbackMessage_DataReaderView> GripperCommand_FeedbackMessage_DataReaderView_out;

            struct GripperCommand_FeedbackMessage_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GripperCommand_FeedbackMessage_, struct GripperCommand_FeedbackMessage_Seq_uniq_> GripperCommand_FeedbackMessage_Seq;
            typedef DDS_DCPSSequence_var < GripperCommand_FeedbackMessage_Seq> GripperCommand_FeedbackMessage_Seq_var;
            typedef DDS_DCPSSequence_out < GripperCommand_FeedbackMessage_Seq> GripperCommand_FeedbackMessage_Seq_out;

            class  GripperCommand_FeedbackMessage_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GripperCommand_FeedbackMessage_TypeSupportInterface_ptr _ptr_type;
                typedef GripperCommand_FeedbackMessage_TypeSupportInterface_var _var_type;

                static GripperCommand_FeedbackMessage_TypeSupportInterface_ptr _duplicate (GripperCommand_FeedbackMessage_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_FeedbackMessage_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_FeedbackMessage_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_FeedbackMessage_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_FeedbackMessage_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GripperCommand_FeedbackMessage_TypeSupportInterface () {};
                ~GripperCommand_FeedbackMessage_TypeSupportInterface () {};
            private:
                GripperCommand_FeedbackMessage_TypeSupportInterface (const GripperCommand_FeedbackMessage_TypeSupportInterface &);
                GripperCommand_FeedbackMessage_TypeSupportInterface & operator = (const GripperCommand_FeedbackMessage_TypeSupportInterface &);
            };

            class  GripperCommand_FeedbackMessage_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GripperCommand_FeedbackMessage_DataWriter_ptr _ptr_type;
                typedef GripperCommand_FeedbackMessage_DataWriter_var _var_type;

                static GripperCommand_FeedbackMessage_DataWriter_ptr _duplicate (GripperCommand_FeedbackMessage_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_FeedbackMessage_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_FeedbackMessage_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_FeedbackMessage_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_FeedbackMessage_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GripperCommand_FeedbackMessage_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GripperCommand_FeedbackMessage_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GripperCommand_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GripperCommand_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GripperCommand_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GripperCommand_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GripperCommand_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GripperCommand_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GripperCommand_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GripperCommand_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GripperCommand_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_FeedbackMessage_& instance_data) = 0;

            protected:
                GripperCommand_FeedbackMessage_DataWriter () {};
                ~GripperCommand_FeedbackMessage_DataWriter () {};
            private:
                GripperCommand_FeedbackMessage_DataWriter (const GripperCommand_FeedbackMessage_DataWriter &);
                GripperCommand_FeedbackMessage_DataWriter & operator = (const GripperCommand_FeedbackMessage_DataWriter &);
            };

            class  GripperCommand_FeedbackMessage_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GripperCommand_FeedbackMessage_DataReader_ptr _ptr_type;
                typedef GripperCommand_FeedbackMessage_DataReader_var _var_type;

                static GripperCommand_FeedbackMessage_DataReader_ptr _duplicate (GripperCommand_FeedbackMessage_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_FeedbackMessage_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_FeedbackMessage_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_FeedbackMessage_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_FeedbackMessage_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_FeedbackMessage_& instance) = 0;

            protected:
                GripperCommand_FeedbackMessage_DataReader () {};
                ~GripperCommand_FeedbackMessage_DataReader () {};
            private:
                GripperCommand_FeedbackMessage_DataReader (const GripperCommand_FeedbackMessage_DataReader &);
                GripperCommand_FeedbackMessage_DataReader & operator = (const GripperCommand_FeedbackMessage_DataReader &);
            };

            class  GripperCommand_FeedbackMessage_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GripperCommand_FeedbackMessage_DataReaderView_ptr _ptr_type;
                typedef GripperCommand_FeedbackMessage_DataReaderView_var _var_type;

                static GripperCommand_FeedbackMessage_DataReaderView_ptr _duplicate (GripperCommand_FeedbackMessage_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GripperCommand_FeedbackMessage_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GripperCommand_FeedbackMessage_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GripperCommand_FeedbackMessage_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GripperCommand_FeedbackMessage_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GripperCommand_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GripperCommand_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GripperCommand_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GripperCommand_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GripperCommand_FeedbackMessage_& instance) = 0;

            protected:
                GripperCommand_FeedbackMessage_DataReaderView () {};
                ~GripperCommand_FeedbackMessage_DataReaderView () {};
            private:
                GripperCommand_FeedbackMessage_DataReaderView (const GripperCommand_FeedbackMessage_DataReaderView &);
                GripperCommand_FeedbackMessage_DataReaderView & operator = (const GripperCommand_FeedbackMessage_DataReaderView &);
            };
        }

    }

}

#endif
