#ifndef H_D614B7422DE138DD288258079F70F914_GripperCommand_SPLTYPES_H
#define H_D614B7422DE138DD288258079F70F914_GripperCommand_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_GripperCommand_.h"
#include "control_msgs/msg/dds_opensplice/GripperCommand_SplDcps.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_SplDcps.h"



extern c_metaObject __GripperCommand__control_msgs__load (c_base base);

extern c_metaObject __GripperCommand__control_msgs_action__load (c_base base);

extern c_metaObject __GripperCommand__control_msgs_action_dds___load (c_base base);

extern const char *control_msgs_action_dds__GripperCommand_Goal__metaDescriptor[];
extern const int control_msgs_action_dds__GripperCommand_Goal__metaDescriptorArrLength;
extern const int control_msgs_action_dds__GripperCommand_Goal__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__GripperCommand_Goal___load (c_base base);
struct _control_msgs_action_dds__GripperCommand_Goal_ ;
extern  v_copyin_result __control_msgs_action_dds__GripperCommand_Goal___copyIn(c_base base, const struct control_msgs::action::dds_::GripperCommand_Goal_ *from, struct _control_msgs_action_dds__GripperCommand_Goal_ *to);
extern  void __control_msgs_action_dds__GripperCommand_Goal___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__GripperCommand_Goal_ {
    struct _control_msgs_msg_dds__GripperCommand_ command_;
};

extern const char *control_msgs_action_dds__GripperCommand_SendGoal_Request__metaDescriptor[];
extern const int control_msgs_action_dds__GripperCommand_SendGoal_Request__metaDescriptorArrLength;
extern const int control_msgs_action_dds__GripperCommand_SendGoal_Request__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__GripperCommand_SendGoal_Request___load (c_base base);
struct _control_msgs_action_dds__GripperCommand_SendGoal_Request_ ;
extern  v_copyin_result __control_msgs_action_dds__GripperCommand_SendGoal_Request___copyIn(c_base base, const struct control_msgs::action::dds_::GripperCommand_SendGoal_Request_ *from, struct _control_msgs_action_dds__GripperCommand_SendGoal_Request_ *to);
extern  void __control_msgs_action_dds__GripperCommand_SendGoal_Request___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__GripperCommand_SendGoal_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
    struct _control_msgs_action_dds__GripperCommand_Goal_ goal_;
};

extern const char *control_msgs_action_dds__GripperCommand_SendGoal_Response__metaDescriptor[];
extern const int control_msgs_action_dds__GripperCommand_SendGoal_Response__metaDescriptorArrLength;
extern const int control_msgs_action_dds__GripperCommand_SendGoal_Response__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__GripperCommand_SendGoal_Response___load (c_base base);
struct _control_msgs_action_dds__GripperCommand_SendGoal_Response_ ;
extern  v_copyin_result __control_msgs_action_dds__GripperCommand_SendGoal_Response___copyIn(c_base base, const struct control_msgs::action::dds_::GripperCommand_SendGoal_Response_ *from, struct _control_msgs_action_dds__GripperCommand_SendGoal_Response_ *to);
extern  void __control_msgs_action_dds__GripperCommand_SendGoal_Response___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__GripperCommand_SendGoal_Response_ {
    c_bool accepted_;
    struct _builtin_interfaces_msg_dds__Time_ stamp_;
};

extern const char *control_msgs_action_dds__Sample_GripperCommand_SendGoal_Request__metaDescriptor[];
extern const int control_msgs_action_dds__Sample_GripperCommand_SendGoal_Request__metaDescriptorArrLength;
extern const int control_msgs_action_dds__Sample_GripperCommand_SendGoal_Request__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__Sample_GripperCommand_SendGoal_Request___load (c_base base);
struct _control_msgs_action_dds__Sample_GripperCommand_SendGoal_Request_ ;
extern  v_copyin_result __control_msgs_action_dds__Sample_GripperCommand_SendGoal_Request___copyIn(c_base base, const struct control_msgs::action::dds_::Sample_GripperCommand_SendGoal_Request_ *from, struct _control_msgs_action_dds__Sample_GripperCommand_SendGoal_Request_ *to);
extern  void __control_msgs_action_dds__Sample_GripperCommand_SendGoal_Request___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__Sample_GripperCommand_SendGoal_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _control_msgs_action_dds__GripperCommand_SendGoal_Request_ request_;
};

extern const char *control_msgs_action_dds__Sample_GripperCommand_SendGoal_Response__metaDescriptor[];
extern const int control_msgs_action_dds__Sample_GripperCommand_SendGoal_Response__metaDescriptorArrLength;
extern const int control_msgs_action_dds__Sample_GripperCommand_SendGoal_Response__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__Sample_GripperCommand_SendGoal_Response___load (c_base base);
struct _control_msgs_action_dds__Sample_GripperCommand_SendGoal_Response_ ;
extern  v_copyin_result __control_msgs_action_dds__Sample_GripperCommand_SendGoal_Response___copyIn(c_base base, const struct control_msgs::action::dds_::Sample_GripperCommand_SendGoal_Response_ *from, struct _control_msgs_action_dds__Sample_GripperCommand_SendGoal_Response_ *to);
extern  void __control_msgs_action_dds__Sample_GripperCommand_SendGoal_Response___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__Sample_GripperCommand_SendGoal_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _control_msgs_action_dds__GripperCommand_SendGoal_Response_ response_;
};

extern const char *control_msgs_action_dds__GripperCommand_Result__metaDescriptor[];
extern const int control_msgs_action_dds__GripperCommand_Result__metaDescriptorArrLength;
extern const int control_msgs_action_dds__GripperCommand_Result__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__GripperCommand_Result___load (c_base base);
struct _control_msgs_action_dds__GripperCommand_Result_ ;
extern  v_copyin_result __control_msgs_action_dds__GripperCommand_Result___copyIn(c_base base, const struct control_msgs::action::dds_::GripperCommand_Result_ *from, struct _control_msgs_action_dds__GripperCommand_Result_ *to);
extern  void __control_msgs_action_dds__GripperCommand_Result___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__GripperCommand_Result_ {
    c_double position_;
    c_double effort_;
    c_bool stalled_;
    c_bool reached_goal_;
};

extern const char *control_msgs_action_dds__GripperCommand_GetResult_Request__metaDescriptor[];
extern const int control_msgs_action_dds__GripperCommand_GetResult_Request__metaDescriptorArrLength;
extern const int control_msgs_action_dds__GripperCommand_GetResult_Request__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__GripperCommand_GetResult_Request___load (c_base base);
struct _control_msgs_action_dds__GripperCommand_GetResult_Request_ ;
extern  v_copyin_result __control_msgs_action_dds__GripperCommand_GetResult_Request___copyIn(c_base base, const struct control_msgs::action::dds_::GripperCommand_GetResult_Request_ *from, struct _control_msgs_action_dds__GripperCommand_GetResult_Request_ *to);
extern  void __control_msgs_action_dds__GripperCommand_GetResult_Request___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__GripperCommand_GetResult_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
};

extern const char *control_msgs_action_dds__GripperCommand_GetResult_Response__metaDescriptor[];
extern const int control_msgs_action_dds__GripperCommand_GetResult_Response__metaDescriptorArrLength;
extern const int control_msgs_action_dds__GripperCommand_GetResult_Response__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__GripperCommand_GetResult_Response___load (c_base base);
struct _control_msgs_action_dds__GripperCommand_GetResult_Response_ ;
extern  v_copyin_result __control_msgs_action_dds__GripperCommand_GetResult_Response___copyIn(c_base base, const struct control_msgs::action::dds_::GripperCommand_GetResult_Response_ *from, struct _control_msgs_action_dds__GripperCommand_GetResult_Response_ *to);
extern  void __control_msgs_action_dds__GripperCommand_GetResult_Response___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__GripperCommand_GetResult_Response_ {
    c_octet status_;
    struct _control_msgs_action_dds__GripperCommand_Result_ result_;
};

extern const char *control_msgs_action_dds__Sample_GripperCommand_GetResult_Request__metaDescriptor[];
extern const int control_msgs_action_dds__Sample_GripperCommand_GetResult_Request__metaDescriptorArrLength;
extern const int control_msgs_action_dds__Sample_GripperCommand_GetResult_Request__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__Sample_GripperCommand_GetResult_Request___load (c_base base);
struct _control_msgs_action_dds__Sample_GripperCommand_GetResult_Request_ ;
extern  v_copyin_result __control_msgs_action_dds__Sample_GripperCommand_GetResult_Request___copyIn(c_base base, const struct control_msgs::action::dds_::Sample_GripperCommand_GetResult_Request_ *from, struct _control_msgs_action_dds__Sample_GripperCommand_GetResult_Request_ *to);
extern  void __control_msgs_action_dds__Sample_GripperCommand_GetResult_Request___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__Sample_GripperCommand_GetResult_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _control_msgs_action_dds__GripperCommand_GetResult_Request_ request_;
};

extern const char *control_msgs_action_dds__Sample_GripperCommand_GetResult_Response__metaDescriptor[];
extern const int control_msgs_action_dds__Sample_GripperCommand_GetResult_Response__metaDescriptorArrLength;
extern const int control_msgs_action_dds__Sample_GripperCommand_GetResult_Response__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__Sample_GripperCommand_GetResult_Response___load (c_base base);
struct _control_msgs_action_dds__Sample_GripperCommand_GetResult_Response_ ;
extern  v_copyin_result __control_msgs_action_dds__Sample_GripperCommand_GetResult_Response___copyIn(c_base base, const struct control_msgs::action::dds_::Sample_GripperCommand_GetResult_Response_ *from, struct _control_msgs_action_dds__Sample_GripperCommand_GetResult_Response_ *to);
extern  void __control_msgs_action_dds__Sample_GripperCommand_GetResult_Response___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__Sample_GripperCommand_GetResult_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _control_msgs_action_dds__GripperCommand_GetResult_Response_ response_;
};

extern const char *control_msgs_action_dds__GripperCommand_Feedback__metaDescriptor[];
extern const int control_msgs_action_dds__GripperCommand_Feedback__metaDescriptorArrLength;
extern const int control_msgs_action_dds__GripperCommand_Feedback__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__GripperCommand_Feedback___load (c_base base);
struct _control_msgs_action_dds__GripperCommand_Feedback_ ;
extern  v_copyin_result __control_msgs_action_dds__GripperCommand_Feedback___copyIn(c_base base, const struct control_msgs::action::dds_::GripperCommand_Feedback_ *from, struct _control_msgs_action_dds__GripperCommand_Feedback_ *to);
extern  void __control_msgs_action_dds__GripperCommand_Feedback___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__GripperCommand_Feedback_ {
    c_double position_;
    c_double effort_;
    c_bool stalled_;
    c_bool reached_goal_;
};

extern const char *control_msgs_action_dds__GripperCommand_FeedbackMessage__metaDescriptor[];
extern const int control_msgs_action_dds__GripperCommand_FeedbackMessage__metaDescriptorArrLength;
extern const int control_msgs_action_dds__GripperCommand_FeedbackMessage__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__GripperCommand_FeedbackMessage___load (c_base base);
struct _control_msgs_action_dds__GripperCommand_FeedbackMessage_ ;
extern  v_copyin_result __control_msgs_action_dds__GripperCommand_FeedbackMessage___copyIn(c_base base, const struct control_msgs::action::dds_::GripperCommand_FeedbackMessage_ *from, struct _control_msgs_action_dds__GripperCommand_FeedbackMessage_ *to);
extern  void __control_msgs_action_dds__GripperCommand_FeedbackMessage___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__GripperCommand_FeedbackMessage_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
    struct _control_msgs_action_dds__GripperCommand_Feedback_ feedback_;
};

#undef OS_API
#endif
