#ifndef _H_4901CBACB39B6799D77812F213CFEF19_PointHead_DCPS_H_
#define _H_4901CBACB39B6799D77812F213CFEF19_PointHead_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PointHead_.h"


namespace control_msgs
{
    namespace action
    {
        namespace dds_
        {
            class PointHead_Goal_TypeSupportInterface;

            typedef PointHead_Goal_TypeSupportInterface * PointHead_Goal_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PointHead_Goal_TypeSupportInterface> PointHead_Goal_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PointHead_Goal_TypeSupportInterface> PointHead_Goal_TypeSupportInterface_out;


            class PointHead_Goal_DataWriter;

            typedef PointHead_Goal_DataWriter * PointHead_Goal_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PointHead_Goal_DataWriter> PointHead_Goal_DataWriter_var;
            typedef DDS_DCPSInterface_out < PointHead_Goal_DataWriter> PointHead_Goal_DataWriter_out;


            class PointHead_Goal_DataReader;

            typedef PointHead_Goal_DataReader * PointHead_Goal_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PointHead_Goal_DataReader> PointHead_Goal_DataReader_var;
            typedef DDS_DCPSInterface_out < PointHead_Goal_DataReader> PointHead_Goal_DataReader_out;


            class PointHead_Goal_DataReaderView;

            typedef PointHead_Goal_DataReaderView * PointHead_Goal_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PointHead_Goal_DataReaderView> PointHead_Goal_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PointHead_Goal_DataReaderView> PointHead_Goal_DataReaderView_out;

            struct PointHead_Goal_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PointHead_Goal_, struct PointHead_Goal_Seq_uniq_> PointHead_Goal_Seq;
            typedef DDS_DCPSSequence_var < PointHead_Goal_Seq> PointHead_Goal_Seq_var;
            typedef DDS_DCPSSequence_out < PointHead_Goal_Seq> PointHead_Goal_Seq_out;

            class  PointHead_Goal_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PointHead_Goal_TypeSupportInterface_ptr _ptr_type;
                typedef PointHead_Goal_TypeSupportInterface_var _var_type;

                static PointHead_Goal_TypeSupportInterface_ptr _duplicate (PointHead_Goal_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_Goal_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_Goal_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_Goal_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_Goal_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PointHead_Goal_TypeSupportInterface () {};
                ~PointHead_Goal_TypeSupportInterface () {};
            private:
                PointHead_Goal_TypeSupportInterface (const PointHead_Goal_TypeSupportInterface &);
                PointHead_Goal_TypeSupportInterface & operator = (const PointHead_Goal_TypeSupportInterface &);
            };

            class  PointHead_Goal_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PointHead_Goal_DataWriter_ptr _ptr_type;
                typedef PointHead_Goal_DataWriter_var _var_type;

                static PointHead_Goal_DataWriter_ptr _duplicate (PointHead_Goal_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_Goal_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_Goal_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_Goal_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_Goal_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PointHead_Goal_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PointHead_Goal_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PointHead_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PointHead_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PointHead_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PointHead_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PointHead_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PointHead_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PointHead_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PointHead_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PointHead_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_Goal_& instance_data) = 0;

            protected:
                PointHead_Goal_DataWriter () {};
                ~PointHead_Goal_DataWriter () {};
            private:
                PointHead_Goal_DataWriter (const PointHead_Goal_DataWriter &);
                PointHead_Goal_DataWriter & operator = (const PointHead_Goal_DataWriter &);
            };

            class  PointHead_Goal_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PointHead_Goal_DataReader_ptr _ptr_type;
                typedef PointHead_Goal_DataReader_var _var_type;

                static PointHead_Goal_DataReader_ptr _duplicate (PointHead_Goal_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_Goal_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_Goal_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_Goal_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_Goal_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointHead_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointHead_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointHead_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_Goal_& instance) = 0;

            protected:
                PointHead_Goal_DataReader () {};
                ~PointHead_Goal_DataReader () {};
            private:
                PointHead_Goal_DataReader (const PointHead_Goal_DataReader &);
                PointHead_Goal_DataReader & operator = (const PointHead_Goal_DataReader &);
            };

            class  PointHead_Goal_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PointHead_Goal_DataReaderView_ptr _ptr_type;
                typedef PointHead_Goal_DataReaderView_var _var_type;

                static PointHead_Goal_DataReaderView_ptr _duplicate (PointHead_Goal_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_Goal_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_Goal_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_Goal_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_Goal_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointHead_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointHead_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointHead_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointHead_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_Goal_& instance) = 0;

            protected:
                PointHead_Goal_DataReaderView () {};
                ~PointHead_Goal_DataReaderView () {};
            private:
                PointHead_Goal_DataReaderView (const PointHead_Goal_DataReaderView &);
                PointHead_Goal_DataReaderView & operator = (const PointHead_Goal_DataReaderView &);
            };
            class PointHead_SendGoal_Request_TypeSupportInterface;

            typedef PointHead_SendGoal_Request_TypeSupportInterface * PointHead_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PointHead_SendGoal_Request_TypeSupportInterface> PointHead_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PointHead_SendGoal_Request_TypeSupportInterface> PointHead_SendGoal_Request_TypeSupportInterface_out;


            class PointHead_SendGoal_Request_DataWriter;

            typedef PointHead_SendGoal_Request_DataWriter * PointHead_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PointHead_SendGoal_Request_DataWriter> PointHead_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < PointHead_SendGoal_Request_DataWriter> PointHead_SendGoal_Request_DataWriter_out;


            class PointHead_SendGoal_Request_DataReader;

            typedef PointHead_SendGoal_Request_DataReader * PointHead_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PointHead_SendGoal_Request_DataReader> PointHead_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < PointHead_SendGoal_Request_DataReader> PointHead_SendGoal_Request_DataReader_out;


            class PointHead_SendGoal_Request_DataReaderView;

            typedef PointHead_SendGoal_Request_DataReaderView * PointHead_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PointHead_SendGoal_Request_DataReaderView> PointHead_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PointHead_SendGoal_Request_DataReaderView> PointHead_SendGoal_Request_DataReaderView_out;

            struct PointHead_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PointHead_SendGoal_Request_, struct PointHead_SendGoal_Request_Seq_uniq_> PointHead_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < PointHead_SendGoal_Request_Seq> PointHead_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < PointHead_SendGoal_Request_Seq> PointHead_SendGoal_Request_Seq_out;

            class  PointHead_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PointHead_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef PointHead_SendGoal_Request_TypeSupportInterface_var _var_type;

                static PointHead_SendGoal_Request_TypeSupportInterface_ptr _duplicate (PointHead_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PointHead_SendGoal_Request_TypeSupportInterface () {};
                ~PointHead_SendGoal_Request_TypeSupportInterface () {};
            private:
                PointHead_SendGoal_Request_TypeSupportInterface (const PointHead_SendGoal_Request_TypeSupportInterface &);
                PointHead_SendGoal_Request_TypeSupportInterface & operator = (const PointHead_SendGoal_Request_TypeSupportInterface &);
            };

            class  PointHead_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PointHead_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef PointHead_SendGoal_Request_DataWriter_var _var_type;

                static PointHead_SendGoal_Request_DataWriter_ptr _duplicate (PointHead_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PointHead_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PointHead_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PointHead_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PointHead_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PointHead_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PointHead_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PointHead_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PointHead_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PointHead_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PointHead_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PointHead_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_SendGoal_Request_& instance_data) = 0;

            protected:
                PointHead_SendGoal_Request_DataWriter () {};
                ~PointHead_SendGoal_Request_DataWriter () {};
            private:
                PointHead_SendGoal_Request_DataWriter (const PointHead_SendGoal_Request_DataWriter &);
                PointHead_SendGoal_Request_DataWriter & operator = (const PointHead_SendGoal_Request_DataWriter &);
            };

            class  PointHead_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PointHead_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef PointHead_SendGoal_Request_DataReader_var _var_type;

                static PointHead_SendGoal_Request_DataReader_ptr _duplicate (PointHead_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointHead_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointHead_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointHead_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_SendGoal_Request_& instance) = 0;

            protected:
                PointHead_SendGoal_Request_DataReader () {};
                ~PointHead_SendGoal_Request_DataReader () {};
            private:
                PointHead_SendGoal_Request_DataReader (const PointHead_SendGoal_Request_DataReader &);
                PointHead_SendGoal_Request_DataReader & operator = (const PointHead_SendGoal_Request_DataReader &);
            };

            class  PointHead_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PointHead_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef PointHead_SendGoal_Request_DataReaderView_var _var_type;

                static PointHead_SendGoal_Request_DataReaderView_ptr _duplicate (PointHead_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointHead_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointHead_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointHead_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_SendGoal_Request_& instance) = 0;

            protected:
                PointHead_SendGoal_Request_DataReaderView () {};
                ~PointHead_SendGoal_Request_DataReaderView () {};
            private:
                PointHead_SendGoal_Request_DataReaderView (const PointHead_SendGoal_Request_DataReaderView &);
                PointHead_SendGoal_Request_DataReaderView & operator = (const PointHead_SendGoal_Request_DataReaderView &);
            };
            class PointHead_SendGoal_Response_TypeSupportInterface;

            typedef PointHead_SendGoal_Response_TypeSupportInterface * PointHead_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PointHead_SendGoal_Response_TypeSupportInterface> PointHead_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PointHead_SendGoal_Response_TypeSupportInterface> PointHead_SendGoal_Response_TypeSupportInterface_out;


            class PointHead_SendGoal_Response_DataWriter;

            typedef PointHead_SendGoal_Response_DataWriter * PointHead_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PointHead_SendGoal_Response_DataWriter> PointHead_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < PointHead_SendGoal_Response_DataWriter> PointHead_SendGoal_Response_DataWriter_out;


            class PointHead_SendGoal_Response_DataReader;

            typedef PointHead_SendGoal_Response_DataReader * PointHead_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PointHead_SendGoal_Response_DataReader> PointHead_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < PointHead_SendGoal_Response_DataReader> PointHead_SendGoal_Response_DataReader_out;


            class PointHead_SendGoal_Response_DataReaderView;

            typedef PointHead_SendGoal_Response_DataReaderView * PointHead_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PointHead_SendGoal_Response_DataReaderView> PointHead_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PointHead_SendGoal_Response_DataReaderView> PointHead_SendGoal_Response_DataReaderView_out;

            struct PointHead_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < PointHead_SendGoal_Response_, struct PointHead_SendGoal_Response_Seq_uniq_> PointHead_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < PointHead_SendGoal_Response_Seq> PointHead_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < PointHead_SendGoal_Response_Seq> PointHead_SendGoal_Response_Seq_out;

            class  PointHead_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PointHead_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef PointHead_SendGoal_Response_TypeSupportInterface_var _var_type;

                static PointHead_SendGoal_Response_TypeSupportInterface_ptr _duplicate (PointHead_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PointHead_SendGoal_Response_TypeSupportInterface () {};
                ~PointHead_SendGoal_Response_TypeSupportInterface () {};
            private:
                PointHead_SendGoal_Response_TypeSupportInterface (const PointHead_SendGoal_Response_TypeSupportInterface &);
                PointHead_SendGoal_Response_TypeSupportInterface & operator = (const PointHead_SendGoal_Response_TypeSupportInterface &);
            };

            class  PointHead_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PointHead_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef PointHead_SendGoal_Response_DataWriter_var _var_type;

                static PointHead_SendGoal_Response_DataWriter_ptr _duplicate (PointHead_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PointHead_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PointHead_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PointHead_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PointHead_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PointHead_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PointHead_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PointHead_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PointHead_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PointHead_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PointHead_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PointHead_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_SendGoal_Response_& instance_data) = 0;

            protected:
                PointHead_SendGoal_Response_DataWriter () {};
                ~PointHead_SendGoal_Response_DataWriter () {};
            private:
                PointHead_SendGoal_Response_DataWriter (const PointHead_SendGoal_Response_DataWriter &);
                PointHead_SendGoal_Response_DataWriter & operator = (const PointHead_SendGoal_Response_DataWriter &);
            };

            class  PointHead_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PointHead_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef PointHead_SendGoal_Response_DataReader_var _var_type;

                static PointHead_SendGoal_Response_DataReader_ptr _duplicate (PointHead_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointHead_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointHead_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointHead_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_SendGoal_Response_& instance) = 0;

            protected:
                PointHead_SendGoal_Response_DataReader () {};
                ~PointHead_SendGoal_Response_DataReader () {};
            private:
                PointHead_SendGoal_Response_DataReader (const PointHead_SendGoal_Response_DataReader &);
                PointHead_SendGoal_Response_DataReader & operator = (const PointHead_SendGoal_Response_DataReader &);
            };

            class  PointHead_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PointHead_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef PointHead_SendGoal_Response_DataReaderView_var _var_type;

                static PointHead_SendGoal_Response_DataReaderView_ptr _duplicate (PointHead_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointHead_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointHead_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointHead_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_SendGoal_Response_& instance) = 0;

            protected:
                PointHead_SendGoal_Response_DataReaderView () {};
                ~PointHead_SendGoal_Response_DataReaderView () {};
            private:
                PointHead_SendGoal_Response_DataReaderView (const PointHead_SendGoal_Response_DataReaderView &);
                PointHead_SendGoal_Response_DataReaderView & operator = (const PointHead_SendGoal_Response_DataReaderView &);
            };
            class Sample_PointHead_SendGoal_Request_TypeSupportInterface;

            typedef Sample_PointHead_SendGoal_Request_TypeSupportInterface * Sample_PointHead_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_PointHead_SendGoal_Request_TypeSupportInterface> Sample_PointHead_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_PointHead_SendGoal_Request_TypeSupportInterface> Sample_PointHead_SendGoal_Request_TypeSupportInterface_out;


            class Sample_PointHead_SendGoal_Request_DataWriter;

            typedef Sample_PointHead_SendGoal_Request_DataWriter * Sample_PointHead_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_PointHead_SendGoal_Request_DataWriter> Sample_PointHead_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_PointHead_SendGoal_Request_DataWriter> Sample_PointHead_SendGoal_Request_DataWriter_out;


            class Sample_PointHead_SendGoal_Request_DataReader;

            typedef Sample_PointHead_SendGoal_Request_DataReader * Sample_PointHead_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_PointHead_SendGoal_Request_DataReader> Sample_PointHead_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_PointHead_SendGoal_Request_DataReader> Sample_PointHead_SendGoal_Request_DataReader_out;


            class Sample_PointHead_SendGoal_Request_DataReaderView;

            typedef Sample_PointHead_SendGoal_Request_DataReaderView * Sample_PointHead_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_PointHead_SendGoal_Request_DataReaderView> Sample_PointHead_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_PointHead_SendGoal_Request_DataReaderView> Sample_PointHead_SendGoal_Request_DataReaderView_out;

            struct Sample_PointHead_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_PointHead_SendGoal_Request_, struct Sample_PointHead_SendGoal_Request_Seq_uniq_> Sample_PointHead_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_PointHead_SendGoal_Request_Seq> Sample_PointHead_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_PointHead_SendGoal_Request_Seq> Sample_PointHead_SendGoal_Request_Seq_out;

            class  Sample_PointHead_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_PointHead_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_PointHead_SendGoal_Request_TypeSupportInterface_var _var_type;

                static Sample_PointHead_SendGoal_Request_TypeSupportInterface_ptr _duplicate (Sample_PointHead_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PointHead_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PointHead_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PointHead_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PointHead_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_PointHead_SendGoal_Request_TypeSupportInterface () {};
                ~Sample_PointHead_SendGoal_Request_TypeSupportInterface () {};
            private:
                Sample_PointHead_SendGoal_Request_TypeSupportInterface (const Sample_PointHead_SendGoal_Request_TypeSupportInterface &);
                Sample_PointHead_SendGoal_Request_TypeSupportInterface & operator = (const Sample_PointHead_SendGoal_Request_TypeSupportInterface &);
            };

            class  Sample_PointHead_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_PointHead_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef Sample_PointHead_SendGoal_Request_DataWriter_var _var_type;

                static Sample_PointHead_SendGoal_Request_DataWriter_ptr _duplicate (Sample_PointHead_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PointHead_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PointHead_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PointHead_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PointHead_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_PointHead_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_PointHead_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_PointHead_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_PointHead_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_PointHead_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_PointHead_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_PointHead_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_PointHead_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_PointHead_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_PointHead_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_PointHead_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_PointHead_SendGoal_Request_& instance_data) = 0;

            protected:
                Sample_PointHead_SendGoal_Request_DataWriter () {};
                ~Sample_PointHead_SendGoal_Request_DataWriter () {};
            private:
                Sample_PointHead_SendGoal_Request_DataWriter (const Sample_PointHead_SendGoal_Request_DataWriter &);
                Sample_PointHead_SendGoal_Request_DataWriter & operator = (const Sample_PointHead_SendGoal_Request_DataWriter &);
            };

            class  Sample_PointHead_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_PointHead_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef Sample_PointHead_SendGoal_Request_DataReader_var _var_type;

                static Sample_PointHead_SendGoal_Request_DataReader_ptr _duplicate (Sample_PointHead_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PointHead_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PointHead_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PointHead_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PointHead_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_PointHead_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_PointHead_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_PointHead_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_PointHead_SendGoal_Request_& instance) = 0;

            protected:
                Sample_PointHead_SendGoal_Request_DataReader () {};
                ~Sample_PointHead_SendGoal_Request_DataReader () {};
            private:
                Sample_PointHead_SendGoal_Request_DataReader (const Sample_PointHead_SendGoal_Request_DataReader &);
                Sample_PointHead_SendGoal_Request_DataReader & operator = (const Sample_PointHead_SendGoal_Request_DataReader &);
            };

            class  Sample_PointHead_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_PointHead_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_PointHead_SendGoal_Request_DataReaderView_var _var_type;

                static Sample_PointHead_SendGoal_Request_DataReaderView_ptr _duplicate (Sample_PointHead_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PointHead_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PointHead_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PointHead_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PointHead_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_PointHead_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_PointHead_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_PointHead_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_PointHead_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_PointHead_SendGoal_Request_& instance) = 0;

            protected:
                Sample_PointHead_SendGoal_Request_DataReaderView () {};
                ~Sample_PointHead_SendGoal_Request_DataReaderView () {};
            private:
                Sample_PointHead_SendGoal_Request_DataReaderView (const Sample_PointHead_SendGoal_Request_DataReaderView &);
                Sample_PointHead_SendGoal_Request_DataReaderView & operator = (const Sample_PointHead_SendGoal_Request_DataReaderView &);
            };
            class Sample_PointHead_SendGoal_Response_TypeSupportInterface;

            typedef Sample_PointHead_SendGoal_Response_TypeSupportInterface * Sample_PointHead_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_PointHead_SendGoal_Response_TypeSupportInterface> Sample_PointHead_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_PointHead_SendGoal_Response_TypeSupportInterface> Sample_PointHead_SendGoal_Response_TypeSupportInterface_out;


            class Sample_PointHead_SendGoal_Response_DataWriter;

            typedef Sample_PointHead_SendGoal_Response_DataWriter * Sample_PointHead_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_PointHead_SendGoal_Response_DataWriter> Sample_PointHead_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_PointHead_SendGoal_Response_DataWriter> Sample_PointHead_SendGoal_Response_DataWriter_out;


            class Sample_PointHead_SendGoal_Response_DataReader;

            typedef Sample_PointHead_SendGoal_Response_DataReader * Sample_PointHead_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_PointHead_SendGoal_Response_DataReader> Sample_PointHead_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_PointHead_SendGoal_Response_DataReader> Sample_PointHead_SendGoal_Response_DataReader_out;


            class Sample_PointHead_SendGoal_Response_DataReaderView;

            typedef Sample_PointHead_SendGoal_Response_DataReaderView * Sample_PointHead_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_PointHead_SendGoal_Response_DataReaderView> Sample_PointHead_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_PointHead_SendGoal_Response_DataReaderView> Sample_PointHead_SendGoal_Response_DataReaderView_out;

            struct Sample_PointHead_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_PointHead_SendGoal_Response_, struct Sample_PointHead_SendGoal_Response_Seq_uniq_> Sample_PointHead_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_PointHead_SendGoal_Response_Seq> Sample_PointHead_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_PointHead_SendGoal_Response_Seq> Sample_PointHead_SendGoal_Response_Seq_out;

            class  Sample_PointHead_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_PointHead_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_PointHead_SendGoal_Response_TypeSupportInterface_var _var_type;

                static Sample_PointHead_SendGoal_Response_TypeSupportInterface_ptr _duplicate (Sample_PointHead_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PointHead_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PointHead_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PointHead_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PointHead_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_PointHead_SendGoal_Response_TypeSupportInterface () {};
                ~Sample_PointHead_SendGoal_Response_TypeSupportInterface () {};
            private:
                Sample_PointHead_SendGoal_Response_TypeSupportInterface (const Sample_PointHead_SendGoal_Response_TypeSupportInterface &);
                Sample_PointHead_SendGoal_Response_TypeSupportInterface & operator = (const Sample_PointHead_SendGoal_Response_TypeSupportInterface &);
            };

            class  Sample_PointHead_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_PointHead_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef Sample_PointHead_SendGoal_Response_DataWriter_var _var_type;

                static Sample_PointHead_SendGoal_Response_DataWriter_ptr _duplicate (Sample_PointHead_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PointHead_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PointHead_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PointHead_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PointHead_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_PointHead_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_PointHead_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_PointHead_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_PointHead_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_PointHead_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_PointHead_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_PointHead_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_PointHead_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_PointHead_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_PointHead_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_PointHead_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_PointHead_SendGoal_Response_& instance_data) = 0;

            protected:
                Sample_PointHead_SendGoal_Response_DataWriter () {};
                ~Sample_PointHead_SendGoal_Response_DataWriter () {};
            private:
                Sample_PointHead_SendGoal_Response_DataWriter (const Sample_PointHead_SendGoal_Response_DataWriter &);
                Sample_PointHead_SendGoal_Response_DataWriter & operator = (const Sample_PointHead_SendGoal_Response_DataWriter &);
            };

            class  Sample_PointHead_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_PointHead_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef Sample_PointHead_SendGoal_Response_DataReader_var _var_type;

                static Sample_PointHead_SendGoal_Response_DataReader_ptr _duplicate (Sample_PointHead_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PointHead_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PointHead_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PointHead_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PointHead_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_PointHead_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_PointHead_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_PointHead_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_PointHead_SendGoal_Response_& instance) = 0;

            protected:
                Sample_PointHead_SendGoal_Response_DataReader () {};
                ~Sample_PointHead_SendGoal_Response_DataReader () {};
            private:
                Sample_PointHead_SendGoal_Response_DataReader (const Sample_PointHead_SendGoal_Response_DataReader &);
                Sample_PointHead_SendGoal_Response_DataReader & operator = (const Sample_PointHead_SendGoal_Response_DataReader &);
            };

            class  Sample_PointHead_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_PointHead_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_PointHead_SendGoal_Response_DataReaderView_var _var_type;

                static Sample_PointHead_SendGoal_Response_DataReaderView_ptr _duplicate (Sample_PointHead_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PointHead_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PointHead_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PointHead_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PointHead_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_PointHead_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_PointHead_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_PointHead_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_PointHead_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_PointHead_SendGoal_Response_& instance) = 0;

            protected:
                Sample_PointHead_SendGoal_Response_DataReaderView () {};
                ~Sample_PointHead_SendGoal_Response_DataReaderView () {};
            private:
                Sample_PointHead_SendGoal_Response_DataReaderView (const Sample_PointHead_SendGoal_Response_DataReaderView &);
                Sample_PointHead_SendGoal_Response_DataReaderView & operator = (const Sample_PointHead_SendGoal_Response_DataReaderView &);
            };
            class PointHead_Result_TypeSupportInterface;

            typedef PointHead_Result_TypeSupportInterface * PointHead_Result_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PointHead_Result_TypeSupportInterface> PointHead_Result_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PointHead_Result_TypeSupportInterface> PointHead_Result_TypeSupportInterface_out;


            class PointHead_Result_DataWriter;

            typedef PointHead_Result_DataWriter * PointHead_Result_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PointHead_Result_DataWriter> PointHead_Result_DataWriter_var;
            typedef DDS_DCPSInterface_out < PointHead_Result_DataWriter> PointHead_Result_DataWriter_out;


            class PointHead_Result_DataReader;

            typedef PointHead_Result_DataReader * PointHead_Result_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PointHead_Result_DataReader> PointHead_Result_DataReader_var;
            typedef DDS_DCPSInterface_out < PointHead_Result_DataReader> PointHead_Result_DataReader_out;


            class PointHead_Result_DataReaderView;

            typedef PointHead_Result_DataReaderView * PointHead_Result_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PointHead_Result_DataReaderView> PointHead_Result_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PointHead_Result_DataReaderView> PointHead_Result_DataReaderView_out;

            struct PointHead_Result_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < PointHead_Result_, struct PointHead_Result_Seq_uniq_> PointHead_Result_Seq;
            typedef DDS_DCPSSequence_var < PointHead_Result_Seq> PointHead_Result_Seq_var;
            typedef DDS_DCPSSequence_out < PointHead_Result_Seq> PointHead_Result_Seq_out;

            class  PointHead_Result_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PointHead_Result_TypeSupportInterface_ptr _ptr_type;
                typedef PointHead_Result_TypeSupportInterface_var _var_type;

                static PointHead_Result_TypeSupportInterface_ptr _duplicate (PointHead_Result_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_Result_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_Result_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_Result_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_Result_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PointHead_Result_TypeSupportInterface () {};
                ~PointHead_Result_TypeSupportInterface () {};
            private:
                PointHead_Result_TypeSupportInterface (const PointHead_Result_TypeSupportInterface &);
                PointHead_Result_TypeSupportInterface & operator = (const PointHead_Result_TypeSupportInterface &);
            };

            class  PointHead_Result_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PointHead_Result_DataWriter_ptr _ptr_type;
                typedef PointHead_Result_DataWriter_var _var_type;

                static PointHead_Result_DataWriter_ptr _duplicate (PointHead_Result_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_Result_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_Result_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_Result_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_Result_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PointHead_Result_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PointHead_Result_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PointHead_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PointHead_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PointHead_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PointHead_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PointHead_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PointHead_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PointHead_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PointHead_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PointHead_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_Result_& instance_data) = 0;

            protected:
                PointHead_Result_DataWriter () {};
                ~PointHead_Result_DataWriter () {};
            private:
                PointHead_Result_DataWriter (const PointHead_Result_DataWriter &);
                PointHead_Result_DataWriter & operator = (const PointHead_Result_DataWriter &);
            };

            class  PointHead_Result_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PointHead_Result_DataReader_ptr _ptr_type;
                typedef PointHead_Result_DataReader_var _var_type;

                static PointHead_Result_DataReader_ptr _duplicate (PointHead_Result_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_Result_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_Result_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_Result_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_Result_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointHead_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointHead_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointHead_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_Result_& instance) = 0;

            protected:
                PointHead_Result_DataReader () {};
                ~PointHead_Result_DataReader () {};
            private:
                PointHead_Result_DataReader (const PointHead_Result_DataReader &);
                PointHead_Result_DataReader & operator = (const PointHead_Result_DataReader &);
            };

            class  PointHead_Result_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PointHead_Result_DataReaderView_ptr _ptr_type;
                typedef PointHead_Result_DataReaderView_var _var_type;

                static PointHead_Result_DataReaderView_ptr _duplicate (PointHead_Result_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_Result_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_Result_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_Result_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_Result_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointHead_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointHead_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointHead_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointHead_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_Result_& instance) = 0;

            protected:
                PointHead_Result_DataReaderView () {};
                ~PointHead_Result_DataReaderView () {};
            private:
                PointHead_Result_DataReaderView (const PointHead_Result_DataReaderView &);
                PointHead_Result_DataReaderView & operator = (const PointHead_Result_DataReaderView &);
            };
            class PointHead_GetResult_Request_TypeSupportInterface;

            typedef PointHead_GetResult_Request_TypeSupportInterface * PointHead_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PointHead_GetResult_Request_TypeSupportInterface> PointHead_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PointHead_GetResult_Request_TypeSupportInterface> PointHead_GetResult_Request_TypeSupportInterface_out;


            class PointHead_GetResult_Request_DataWriter;

            typedef PointHead_GetResult_Request_DataWriter * PointHead_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PointHead_GetResult_Request_DataWriter> PointHead_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < PointHead_GetResult_Request_DataWriter> PointHead_GetResult_Request_DataWriter_out;


            class PointHead_GetResult_Request_DataReader;

            typedef PointHead_GetResult_Request_DataReader * PointHead_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PointHead_GetResult_Request_DataReader> PointHead_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < PointHead_GetResult_Request_DataReader> PointHead_GetResult_Request_DataReader_out;


            class PointHead_GetResult_Request_DataReaderView;

            typedef PointHead_GetResult_Request_DataReaderView * PointHead_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PointHead_GetResult_Request_DataReaderView> PointHead_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PointHead_GetResult_Request_DataReaderView> PointHead_GetResult_Request_DataReaderView_out;

            struct PointHead_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < PointHead_GetResult_Request_, struct PointHead_GetResult_Request_Seq_uniq_> PointHead_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < PointHead_GetResult_Request_Seq> PointHead_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < PointHead_GetResult_Request_Seq> PointHead_GetResult_Request_Seq_out;

            class  PointHead_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PointHead_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef PointHead_GetResult_Request_TypeSupportInterface_var _var_type;

                static PointHead_GetResult_Request_TypeSupportInterface_ptr _duplicate (PointHead_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PointHead_GetResult_Request_TypeSupportInterface () {};
                ~PointHead_GetResult_Request_TypeSupportInterface () {};
            private:
                PointHead_GetResult_Request_TypeSupportInterface (const PointHead_GetResult_Request_TypeSupportInterface &);
                PointHead_GetResult_Request_TypeSupportInterface & operator = (const PointHead_GetResult_Request_TypeSupportInterface &);
            };

            class  PointHead_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PointHead_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef PointHead_GetResult_Request_DataWriter_var _var_type;

                static PointHead_GetResult_Request_DataWriter_ptr _duplicate (PointHead_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PointHead_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PointHead_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PointHead_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PointHead_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PointHead_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PointHead_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PointHead_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PointHead_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PointHead_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PointHead_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PointHead_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_GetResult_Request_& instance_data) = 0;

            protected:
                PointHead_GetResult_Request_DataWriter () {};
                ~PointHead_GetResult_Request_DataWriter () {};
            private:
                PointHead_GetResult_Request_DataWriter (const PointHead_GetResult_Request_DataWriter &);
                PointHead_GetResult_Request_DataWriter & operator = (const PointHead_GetResult_Request_DataWriter &);
            };

            class  PointHead_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PointHead_GetResult_Request_DataReader_ptr _ptr_type;
                typedef PointHead_GetResult_Request_DataReader_var _var_type;

                static PointHead_GetResult_Request_DataReader_ptr _duplicate (PointHead_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointHead_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointHead_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointHead_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_GetResult_Request_& instance) = 0;

            protected:
                PointHead_GetResult_Request_DataReader () {};
                ~PointHead_GetResult_Request_DataReader () {};
            private:
                PointHead_GetResult_Request_DataReader (const PointHead_GetResult_Request_DataReader &);
                PointHead_GetResult_Request_DataReader & operator = (const PointHead_GetResult_Request_DataReader &);
            };

            class  PointHead_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PointHead_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef PointHead_GetResult_Request_DataReaderView_var _var_type;

                static PointHead_GetResult_Request_DataReaderView_ptr _duplicate (PointHead_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointHead_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointHead_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointHead_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_GetResult_Request_& instance) = 0;

            protected:
                PointHead_GetResult_Request_DataReaderView () {};
                ~PointHead_GetResult_Request_DataReaderView () {};
            private:
                PointHead_GetResult_Request_DataReaderView (const PointHead_GetResult_Request_DataReaderView &);
                PointHead_GetResult_Request_DataReaderView & operator = (const PointHead_GetResult_Request_DataReaderView &);
            };
            class PointHead_GetResult_Response_TypeSupportInterface;

            typedef PointHead_GetResult_Response_TypeSupportInterface * PointHead_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PointHead_GetResult_Response_TypeSupportInterface> PointHead_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PointHead_GetResult_Response_TypeSupportInterface> PointHead_GetResult_Response_TypeSupportInterface_out;


            class PointHead_GetResult_Response_DataWriter;

            typedef PointHead_GetResult_Response_DataWriter * PointHead_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PointHead_GetResult_Response_DataWriter> PointHead_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < PointHead_GetResult_Response_DataWriter> PointHead_GetResult_Response_DataWriter_out;


            class PointHead_GetResult_Response_DataReader;

            typedef PointHead_GetResult_Response_DataReader * PointHead_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PointHead_GetResult_Response_DataReader> PointHead_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < PointHead_GetResult_Response_DataReader> PointHead_GetResult_Response_DataReader_out;


            class PointHead_GetResult_Response_DataReaderView;

            typedef PointHead_GetResult_Response_DataReaderView * PointHead_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PointHead_GetResult_Response_DataReaderView> PointHead_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PointHead_GetResult_Response_DataReaderView> PointHead_GetResult_Response_DataReaderView_out;

            struct PointHead_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < PointHead_GetResult_Response_, struct PointHead_GetResult_Response_Seq_uniq_> PointHead_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < PointHead_GetResult_Response_Seq> PointHead_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < PointHead_GetResult_Response_Seq> PointHead_GetResult_Response_Seq_out;

            class  PointHead_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PointHead_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef PointHead_GetResult_Response_TypeSupportInterface_var _var_type;

                static PointHead_GetResult_Response_TypeSupportInterface_ptr _duplicate (PointHead_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PointHead_GetResult_Response_TypeSupportInterface () {};
                ~PointHead_GetResult_Response_TypeSupportInterface () {};
            private:
                PointHead_GetResult_Response_TypeSupportInterface (const PointHead_GetResult_Response_TypeSupportInterface &);
                PointHead_GetResult_Response_TypeSupportInterface & operator = (const PointHead_GetResult_Response_TypeSupportInterface &);
            };

            class  PointHead_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PointHead_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef PointHead_GetResult_Response_DataWriter_var _var_type;

                static PointHead_GetResult_Response_DataWriter_ptr _duplicate (PointHead_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PointHead_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PointHead_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PointHead_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PointHead_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PointHead_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PointHead_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PointHead_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PointHead_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PointHead_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PointHead_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PointHead_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_GetResult_Response_& instance_data) = 0;

            protected:
                PointHead_GetResult_Response_DataWriter () {};
                ~PointHead_GetResult_Response_DataWriter () {};
            private:
                PointHead_GetResult_Response_DataWriter (const PointHead_GetResult_Response_DataWriter &);
                PointHead_GetResult_Response_DataWriter & operator = (const PointHead_GetResult_Response_DataWriter &);
            };

            class  PointHead_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PointHead_GetResult_Response_DataReader_ptr _ptr_type;
                typedef PointHead_GetResult_Response_DataReader_var _var_type;

                static PointHead_GetResult_Response_DataReader_ptr _duplicate (PointHead_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointHead_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointHead_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointHead_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_GetResult_Response_& instance) = 0;

            protected:
                PointHead_GetResult_Response_DataReader () {};
                ~PointHead_GetResult_Response_DataReader () {};
            private:
                PointHead_GetResult_Response_DataReader (const PointHead_GetResult_Response_DataReader &);
                PointHead_GetResult_Response_DataReader & operator = (const PointHead_GetResult_Response_DataReader &);
            };

            class  PointHead_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PointHead_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef PointHead_GetResult_Response_DataReaderView_var _var_type;

                static PointHead_GetResult_Response_DataReaderView_ptr _duplicate (PointHead_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointHead_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointHead_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointHead_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_GetResult_Response_& instance) = 0;

            protected:
                PointHead_GetResult_Response_DataReaderView () {};
                ~PointHead_GetResult_Response_DataReaderView () {};
            private:
                PointHead_GetResult_Response_DataReaderView (const PointHead_GetResult_Response_DataReaderView &);
                PointHead_GetResult_Response_DataReaderView & operator = (const PointHead_GetResult_Response_DataReaderView &);
            };
            class Sample_PointHead_GetResult_Request_TypeSupportInterface;

            typedef Sample_PointHead_GetResult_Request_TypeSupportInterface * Sample_PointHead_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_PointHead_GetResult_Request_TypeSupportInterface> Sample_PointHead_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_PointHead_GetResult_Request_TypeSupportInterface> Sample_PointHead_GetResult_Request_TypeSupportInterface_out;


            class Sample_PointHead_GetResult_Request_DataWriter;

            typedef Sample_PointHead_GetResult_Request_DataWriter * Sample_PointHead_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_PointHead_GetResult_Request_DataWriter> Sample_PointHead_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_PointHead_GetResult_Request_DataWriter> Sample_PointHead_GetResult_Request_DataWriter_out;


            class Sample_PointHead_GetResult_Request_DataReader;

            typedef Sample_PointHead_GetResult_Request_DataReader * Sample_PointHead_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_PointHead_GetResult_Request_DataReader> Sample_PointHead_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_PointHead_GetResult_Request_DataReader> Sample_PointHead_GetResult_Request_DataReader_out;


            class Sample_PointHead_GetResult_Request_DataReaderView;

            typedef Sample_PointHead_GetResult_Request_DataReaderView * Sample_PointHead_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_PointHead_GetResult_Request_DataReaderView> Sample_PointHead_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_PointHead_GetResult_Request_DataReaderView> Sample_PointHead_GetResult_Request_DataReaderView_out;

            struct Sample_PointHead_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_PointHead_GetResult_Request_, struct Sample_PointHead_GetResult_Request_Seq_uniq_> Sample_PointHead_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_PointHead_GetResult_Request_Seq> Sample_PointHead_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_PointHead_GetResult_Request_Seq> Sample_PointHead_GetResult_Request_Seq_out;

            class  Sample_PointHead_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_PointHead_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_PointHead_GetResult_Request_TypeSupportInterface_var _var_type;

                static Sample_PointHead_GetResult_Request_TypeSupportInterface_ptr _duplicate (Sample_PointHead_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PointHead_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PointHead_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PointHead_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PointHead_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_PointHead_GetResult_Request_TypeSupportInterface () {};
                ~Sample_PointHead_GetResult_Request_TypeSupportInterface () {};
            private:
                Sample_PointHead_GetResult_Request_TypeSupportInterface (const Sample_PointHead_GetResult_Request_TypeSupportInterface &);
                Sample_PointHead_GetResult_Request_TypeSupportInterface & operator = (const Sample_PointHead_GetResult_Request_TypeSupportInterface &);
            };

            class  Sample_PointHead_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_PointHead_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef Sample_PointHead_GetResult_Request_DataWriter_var _var_type;

                static Sample_PointHead_GetResult_Request_DataWriter_ptr _duplicate (Sample_PointHead_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PointHead_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PointHead_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PointHead_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PointHead_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_PointHead_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_PointHead_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_PointHead_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_PointHead_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_PointHead_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_PointHead_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_PointHead_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_PointHead_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_PointHead_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_PointHead_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_PointHead_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_PointHead_GetResult_Request_& instance_data) = 0;

            protected:
                Sample_PointHead_GetResult_Request_DataWriter () {};
                ~Sample_PointHead_GetResult_Request_DataWriter () {};
            private:
                Sample_PointHead_GetResult_Request_DataWriter (const Sample_PointHead_GetResult_Request_DataWriter &);
                Sample_PointHead_GetResult_Request_DataWriter & operator = (const Sample_PointHead_GetResult_Request_DataWriter &);
            };

            class  Sample_PointHead_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_PointHead_GetResult_Request_DataReader_ptr _ptr_type;
                typedef Sample_PointHead_GetResult_Request_DataReader_var _var_type;

                static Sample_PointHead_GetResult_Request_DataReader_ptr _duplicate (Sample_PointHead_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PointHead_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PointHead_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PointHead_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PointHead_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_PointHead_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_PointHead_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_PointHead_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_PointHead_GetResult_Request_& instance) = 0;

            protected:
                Sample_PointHead_GetResult_Request_DataReader () {};
                ~Sample_PointHead_GetResult_Request_DataReader () {};
            private:
                Sample_PointHead_GetResult_Request_DataReader (const Sample_PointHead_GetResult_Request_DataReader &);
                Sample_PointHead_GetResult_Request_DataReader & operator = (const Sample_PointHead_GetResult_Request_DataReader &);
            };

            class  Sample_PointHead_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_PointHead_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_PointHead_GetResult_Request_DataReaderView_var _var_type;

                static Sample_PointHead_GetResult_Request_DataReaderView_ptr _duplicate (Sample_PointHead_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PointHead_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PointHead_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PointHead_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PointHead_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_PointHead_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_PointHead_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_PointHead_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_PointHead_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_PointHead_GetResult_Request_& instance) = 0;

            protected:
                Sample_PointHead_GetResult_Request_DataReaderView () {};
                ~Sample_PointHead_GetResult_Request_DataReaderView () {};
            private:
                Sample_PointHead_GetResult_Request_DataReaderView (const Sample_PointHead_GetResult_Request_DataReaderView &);
                Sample_PointHead_GetResult_Request_DataReaderView & operator = (const Sample_PointHead_GetResult_Request_DataReaderView &);
            };
            class Sample_PointHead_GetResult_Response_TypeSupportInterface;

            typedef Sample_PointHead_GetResult_Response_TypeSupportInterface * Sample_PointHead_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_PointHead_GetResult_Response_TypeSupportInterface> Sample_PointHead_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_PointHead_GetResult_Response_TypeSupportInterface> Sample_PointHead_GetResult_Response_TypeSupportInterface_out;


            class Sample_PointHead_GetResult_Response_DataWriter;

            typedef Sample_PointHead_GetResult_Response_DataWriter * Sample_PointHead_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_PointHead_GetResult_Response_DataWriter> Sample_PointHead_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_PointHead_GetResult_Response_DataWriter> Sample_PointHead_GetResult_Response_DataWriter_out;


            class Sample_PointHead_GetResult_Response_DataReader;

            typedef Sample_PointHead_GetResult_Response_DataReader * Sample_PointHead_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_PointHead_GetResult_Response_DataReader> Sample_PointHead_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_PointHead_GetResult_Response_DataReader> Sample_PointHead_GetResult_Response_DataReader_out;


            class Sample_PointHead_GetResult_Response_DataReaderView;

            typedef Sample_PointHead_GetResult_Response_DataReaderView * Sample_PointHead_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_PointHead_GetResult_Response_DataReaderView> Sample_PointHead_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_PointHead_GetResult_Response_DataReaderView> Sample_PointHead_GetResult_Response_DataReaderView_out;

            struct Sample_PointHead_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_PointHead_GetResult_Response_, struct Sample_PointHead_GetResult_Response_Seq_uniq_> Sample_PointHead_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_PointHead_GetResult_Response_Seq> Sample_PointHead_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_PointHead_GetResult_Response_Seq> Sample_PointHead_GetResult_Response_Seq_out;

            class  Sample_PointHead_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_PointHead_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_PointHead_GetResult_Response_TypeSupportInterface_var _var_type;

                static Sample_PointHead_GetResult_Response_TypeSupportInterface_ptr _duplicate (Sample_PointHead_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PointHead_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PointHead_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PointHead_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PointHead_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_PointHead_GetResult_Response_TypeSupportInterface () {};
                ~Sample_PointHead_GetResult_Response_TypeSupportInterface () {};
            private:
                Sample_PointHead_GetResult_Response_TypeSupportInterface (const Sample_PointHead_GetResult_Response_TypeSupportInterface &);
                Sample_PointHead_GetResult_Response_TypeSupportInterface & operator = (const Sample_PointHead_GetResult_Response_TypeSupportInterface &);
            };

            class  Sample_PointHead_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_PointHead_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef Sample_PointHead_GetResult_Response_DataWriter_var _var_type;

                static Sample_PointHead_GetResult_Response_DataWriter_ptr _duplicate (Sample_PointHead_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PointHead_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PointHead_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PointHead_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PointHead_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_PointHead_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_PointHead_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_PointHead_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_PointHead_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_PointHead_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_PointHead_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_PointHead_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_PointHead_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_PointHead_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_PointHead_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_PointHead_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_PointHead_GetResult_Response_& instance_data) = 0;

            protected:
                Sample_PointHead_GetResult_Response_DataWriter () {};
                ~Sample_PointHead_GetResult_Response_DataWriter () {};
            private:
                Sample_PointHead_GetResult_Response_DataWriter (const Sample_PointHead_GetResult_Response_DataWriter &);
                Sample_PointHead_GetResult_Response_DataWriter & operator = (const Sample_PointHead_GetResult_Response_DataWriter &);
            };

            class  Sample_PointHead_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_PointHead_GetResult_Response_DataReader_ptr _ptr_type;
                typedef Sample_PointHead_GetResult_Response_DataReader_var _var_type;

                static Sample_PointHead_GetResult_Response_DataReader_ptr _duplicate (Sample_PointHead_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PointHead_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PointHead_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PointHead_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PointHead_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_PointHead_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_PointHead_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_PointHead_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_PointHead_GetResult_Response_& instance) = 0;

            protected:
                Sample_PointHead_GetResult_Response_DataReader () {};
                ~Sample_PointHead_GetResult_Response_DataReader () {};
            private:
                Sample_PointHead_GetResult_Response_DataReader (const Sample_PointHead_GetResult_Response_DataReader &);
                Sample_PointHead_GetResult_Response_DataReader & operator = (const Sample_PointHead_GetResult_Response_DataReader &);
            };

            class  Sample_PointHead_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_PointHead_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_PointHead_GetResult_Response_DataReaderView_var _var_type;

                static Sample_PointHead_GetResult_Response_DataReaderView_ptr _duplicate (Sample_PointHead_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_PointHead_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_PointHead_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_PointHead_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_PointHead_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_PointHead_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_PointHead_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_PointHead_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_PointHead_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_PointHead_GetResult_Response_& instance) = 0;

            protected:
                Sample_PointHead_GetResult_Response_DataReaderView () {};
                ~Sample_PointHead_GetResult_Response_DataReaderView () {};
            private:
                Sample_PointHead_GetResult_Response_DataReaderView (const Sample_PointHead_GetResult_Response_DataReaderView &);
                Sample_PointHead_GetResult_Response_DataReaderView & operator = (const Sample_PointHead_GetResult_Response_DataReaderView &);
            };
            class PointHead_Feedback_TypeSupportInterface;

            typedef PointHead_Feedback_TypeSupportInterface * PointHead_Feedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PointHead_Feedback_TypeSupportInterface> PointHead_Feedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PointHead_Feedback_TypeSupportInterface> PointHead_Feedback_TypeSupportInterface_out;


            class PointHead_Feedback_DataWriter;

            typedef PointHead_Feedback_DataWriter * PointHead_Feedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PointHead_Feedback_DataWriter> PointHead_Feedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < PointHead_Feedback_DataWriter> PointHead_Feedback_DataWriter_out;


            class PointHead_Feedback_DataReader;

            typedef PointHead_Feedback_DataReader * PointHead_Feedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PointHead_Feedback_DataReader> PointHead_Feedback_DataReader_var;
            typedef DDS_DCPSInterface_out < PointHead_Feedback_DataReader> PointHead_Feedback_DataReader_out;


            class PointHead_Feedback_DataReaderView;

            typedef PointHead_Feedback_DataReaderView * PointHead_Feedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PointHead_Feedback_DataReaderView> PointHead_Feedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PointHead_Feedback_DataReaderView> PointHead_Feedback_DataReaderView_out;

            struct PointHead_Feedback_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < PointHead_Feedback_, struct PointHead_Feedback_Seq_uniq_> PointHead_Feedback_Seq;
            typedef DDS_DCPSSequence_var < PointHead_Feedback_Seq> PointHead_Feedback_Seq_var;
            typedef DDS_DCPSSequence_out < PointHead_Feedback_Seq> PointHead_Feedback_Seq_out;

            class  PointHead_Feedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PointHead_Feedback_TypeSupportInterface_ptr _ptr_type;
                typedef PointHead_Feedback_TypeSupportInterface_var _var_type;

                static PointHead_Feedback_TypeSupportInterface_ptr _duplicate (PointHead_Feedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_Feedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_Feedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_Feedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_Feedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PointHead_Feedback_TypeSupportInterface () {};
                ~PointHead_Feedback_TypeSupportInterface () {};
            private:
                PointHead_Feedback_TypeSupportInterface (const PointHead_Feedback_TypeSupportInterface &);
                PointHead_Feedback_TypeSupportInterface & operator = (const PointHead_Feedback_TypeSupportInterface &);
            };

            class  PointHead_Feedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PointHead_Feedback_DataWriter_ptr _ptr_type;
                typedef PointHead_Feedback_DataWriter_var _var_type;

                static PointHead_Feedback_DataWriter_ptr _duplicate (PointHead_Feedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_Feedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_Feedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_Feedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_Feedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PointHead_Feedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PointHead_Feedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PointHead_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PointHead_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PointHead_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PointHead_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PointHead_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PointHead_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PointHead_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PointHead_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PointHead_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_Feedback_& instance_data) = 0;

            protected:
                PointHead_Feedback_DataWriter () {};
                ~PointHead_Feedback_DataWriter () {};
            private:
                PointHead_Feedback_DataWriter (const PointHead_Feedback_DataWriter &);
                PointHead_Feedback_DataWriter & operator = (const PointHead_Feedback_DataWriter &);
            };

            class  PointHead_Feedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PointHead_Feedback_DataReader_ptr _ptr_type;
                typedef PointHead_Feedback_DataReader_var _var_type;

                static PointHead_Feedback_DataReader_ptr _duplicate (PointHead_Feedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_Feedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_Feedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_Feedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_Feedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointHead_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointHead_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointHead_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_Feedback_& instance) = 0;

            protected:
                PointHead_Feedback_DataReader () {};
                ~PointHead_Feedback_DataReader () {};
            private:
                PointHead_Feedback_DataReader (const PointHead_Feedback_DataReader &);
                PointHead_Feedback_DataReader & operator = (const PointHead_Feedback_DataReader &);
            };

            class  PointHead_Feedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PointHead_Feedback_DataReaderView_ptr _ptr_type;
                typedef PointHead_Feedback_DataReaderView_var _var_type;

                static PointHead_Feedback_DataReaderView_ptr _duplicate (PointHead_Feedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_Feedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_Feedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_Feedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_Feedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointHead_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointHead_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointHead_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointHead_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_Feedback_& instance) = 0;

            protected:
                PointHead_Feedback_DataReaderView () {};
                ~PointHead_Feedback_DataReaderView () {};
            private:
                PointHead_Feedback_DataReaderView (const PointHead_Feedback_DataReaderView &);
                PointHead_Feedback_DataReaderView & operator = (const PointHead_Feedback_DataReaderView &);
            };
            class PointHead_FeedbackMessage_TypeSupportInterface;

            typedef PointHead_FeedbackMessage_TypeSupportInterface * PointHead_FeedbackMessage_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PointHead_FeedbackMessage_TypeSupportInterface> PointHead_FeedbackMessage_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PointHead_FeedbackMessage_TypeSupportInterface> PointHead_FeedbackMessage_TypeSupportInterface_out;


            class PointHead_FeedbackMessage_DataWriter;

            typedef PointHead_FeedbackMessage_DataWriter * PointHead_FeedbackMessage_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PointHead_FeedbackMessage_DataWriter> PointHead_FeedbackMessage_DataWriter_var;
            typedef DDS_DCPSInterface_out < PointHead_FeedbackMessage_DataWriter> PointHead_FeedbackMessage_DataWriter_out;


            class PointHead_FeedbackMessage_DataReader;

            typedef PointHead_FeedbackMessage_DataReader * PointHead_FeedbackMessage_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PointHead_FeedbackMessage_DataReader> PointHead_FeedbackMessage_DataReader_var;
            typedef DDS_DCPSInterface_out < PointHead_FeedbackMessage_DataReader> PointHead_FeedbackMessage_DataReader_out;


            class PointHead_FeedbackMessage_DataReaderView;

            typedef PointHead_FeedbackMessage_DataReaderView * PointHead_FeedbackMessage_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PointHead_FeedbackMessage_DataReaderView> PointHead_FeedbackMessage_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PointHead_FeedbackMessage_DataReaderView> PointHead_FeedbackMessage_DataReaderView_out;

            struct PointHead_FeedbackMessage_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < PointHead_FeedbackMessage_, struct PointHead_FeedbackMessage_Seq_uniq_> PointHead_FeedbackMessage_Seq;
            typedef DDS_DCPSSequence_var < PointHead_FeedbackMessage_Seq> PointHead_FeedbackMessage_Seq_var;
            typedef DDS_DCPSSequence_out < PointHead_FeedbackMessage_Seq> PointHead_FeedbackMessage_Seq_out;

            class  PointHead_FeedbackMessage_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PointHead_FeedbackMessage_TypeSupportInterface_ptr _ptr_type;
                typedef PointHead_FeedbackMessage_TypeSupportInterface_var _var_type;

                static PointHead_FeedbackMessage_TypeSupportInterface_ptr _duplicate (PointHead_FeedbackMessage_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_FeedbackMessage_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_FeedbackMessage_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_FeedbackMessage_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_FeedbackMessage_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PointHead_FeedbackMessage_TypeSupportInterface () {};
                ~PointHead_FeedbackMessage_TypeSupportInterface () {};
            private:
                PointHead_FeedbackMessage_TypeSupportInterface (const PointHead_FeedbackMessage_TypeSupportInterface &);
                PointHead_FeedbackMessage_TypeSupportInterface & operator = (const PointHead_FeedbackMessage_TypeSupportInterface &);
            };

            class  PointHead_FeedbackMessage_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PointHead_FeedbackMessage_DataWriter_ptr _ptr_type;
                typedef PointHead_FeedbackMessage_DataWriter_var _var_type;

                static PointHead_FeedbackMessage_DataWriter_ptr _duplicate (PointHead_FeedbackMessage_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_FeedbackMessage_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_FeedbackMessage_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_FeedbackMessage_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_FeedbackMessage_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PointHead_FeedbackMessage_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PointHead_FeedbackMessage_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PointHead_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PointHead_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PointHead_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PointHead_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PointHead_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PointHead_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PointHead_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PointHead_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PointHead_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_FeedbackMessage_& instance_data) = 0;

            protected:
                PointHead_FeedbackMessage_DataWriter () {};
                ~PointHead_FeedbackMessage_DataWriter () {};
            private:
                PointHead_FeedbackMessage_DataWriter (const PointHead_FeedbackMessage_DataWriter &);
                PointHead_FeedbackMessage_DataWriter & operator = (const PointHead_FeedbackMessage_DataWriter &);
            };

            class  PointHead_FeedbackMessage_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PointHead_FeedbackMessage_DataReader_ptr _ptr_type;
                typedef PointHead_FeedbackMessage_DataReader_var _var_type;

                static PointHead_FeedbackMessage_DataReader_ptr _duplicate (PointHead_FeedbackMessage_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_FeedbackMessage_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_FeedbackMessage_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_FeedbackMessage_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_FeedbackMessage_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointHead_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointHead_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointHead_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_FeedbackMessage_& instance) = 0;

            protected:
                PointHead_FeedbackMessage_DataReader () {};
                ~PointHead_FeedbackMessage_DataReader () {};
            private:
                PointHead_FeedbackMessage_DataReader (const PointHead_FeedbackMessage_DataReader &);
                PointHead_FeedbackMessage_DataReader & operator = (const PointHead_FeedbackMessage_DataReader &);
            };

            class  PointHead_FeedbackMessage_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PointHead_FeedbackMessage_DataReaderView_ptr _ptr_type;
                typedef PointHead_FeedbackMessage_DataReaderView_var _var_type;

                static PointHead_FeedbackMessage_DataReaderView_ptr _duplicate (PointHead_FeedbackMessage_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointHead_FeedbackMessage_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PointHead_FeedbackMessage_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointHead_FeedbackMessage_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PointHead_FeedbackMessage_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointHead_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointHead_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointHead_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointHead_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointHead_FeedbackMessage_& instance) = 0;

            protected:
                PointHead_FeedbackMessage_DataReaderView () {};
                ~PointHead_FeedbackMessage_DataReaderView () {};
            private:
                PointHead_FeedbackMessage_DataReaderView (const PointHead_FeedbackMessage_DataReaderView &);
                PointHead_FeedbackMessage_DataReaderView & operator = (const PointHead_FeedbackMessage_DataReaderView &);
            };
        }

    }

}

#endif
