#ifndef H_4901CBACB39B6799D77812F213CFEF19_PointHead_SPLTYPES_H
#define H_4901CBACB39B6799D77812F213CFEF19_PointHead_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_PointHead_.h"
#include "geometry_msgs/msg/dds_opensplice/PointStamped_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/Vector3_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Duration_SplDcps.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_SplDcps.h"



extern c_metaObject __PointHead__control_msgs__load (c_base base);

extern c_metaObject __PointHead__control_msgs_action__load (c_base base);

extern c_metaObject __PointHead__control_msgs_action_dds___load (c_base base);

extern const char *control_msgs_action_dds__PointHead_Goal__metaDescriptor[];
extern const int control_msgs_action_dds__PointHead_Goal__metaDescriptorArrLength;
extern const int control_msgs_action_dds__PointHead_Goal__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__PointHead_Goal___load (c_base base);
struct _control_msgs_action_dds__PointHead_Goal_ ;
extern  v_copyin_result __control_msgs_action_dds__PointHead_Goal___copyIn(c_base base, const struct control_msgs::action::dds_::PointHead_Goal_ *from, struct _control_msgs_action_dds__PointHead_Goal_ *to);
extern  void __control_msgs_action_dds__PointHead_Goal___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__PointHead_Goal_ {
    struct _geometry_msgs_msg_dds__PointStamped_ target_;
    struct _geometry_msgs_msg_dds__Vector3_ pointing_axis_;
    c_string pointing_frame_;
    struct _builtin_interfaces_msg_dds__Duration_ min_duration_;
    c_double max_velocity_;
};

extern const char *control_msgs_action_dds__PointHead_SendGoal_Request__metaDescriptor[];
extern const int control_msgs_action_dds__PointHead_SendGoal_Request__metaDescriptorArrLength;
extern const int control_msgs_action_dds__PointHead_SendGoal_Request__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__PointHead_SendGoal_Request___load (c_base base);
struct _control_msgs_action_dds__PointHead_SendGoal_Request_ ;
extern  v_copyin_result __control_msgs_action_dds__PointHead_SendGoal_Request___copyIn(c_base base, const struct control_msgs::action::dds_::PointHead_SendGoal_Request_ *from, struct _control_msgs_action_dds__PointHead_SendGoal_Request_ *to);
extern  void __control_msgs_action_dds__PointHead_SendGoal_Request___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__PointHead_SendGoal_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
    struct _control_msgs_action_dds__PointHead_Goal_ goal_;
};

extern const char *control_msgs_action_dds__PointHead_SendGoal_Response__metaDescriptor[];
extern const int control_msgs_action_dds__PointHead_SendGoal_Response__metaDescriptorArrLength;
extern const int control_msgs_action_dds__PointHead_SendGoal_Response__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__PointHead_SendGoal_Response___load (c_base base);
struct _control_msgs_action_dds__PointHead_SendGoal_Response_ ;
extern  v_copyin_result __control_msgs_action_dds__PointHead_SendGoal_Response___copyIn(c_base base, const struct control_msgs::action::dds_::PointHead_SendGoal_Response_ *from, struct _control_msgs_action_dds__PointHead_SendGoal_Response_ *to);
extern  void __control_msgs_action_dds__PointHead_SendGoal_Response___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__PointHead_SendGoal_Response_ {
    c_bool accepted_;
    struct _builtin_interfaces_msg_dds__Time_ stamp_;
};

extern const char *control_msgs_action_dds__Sample_PointHead_SendGoal_Request__metaDescriptor[];
extern const int control_msgs_action_dds__Sample_PointHead_SendGoal_Request__metaDescriptorArrLength;
extern const int control_msgs_action_dds__Sample_PointHead_SendGoal_Request__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__Sample_PointHead_SendGoal_Request___load (c_base base);
struct _control_msgs_action_dds__Sample_PointHead_SendGoal_Request_ ;
extern  v_copyin_result __control_msgs_action_dds__Sample_PointHead_SendGoal_Request___copyIn(c_base base, const struct control_msgs::action::dds_::Sample_PointHead_SendGoal_Request_ *from, struct _control_msgs_action_dds__Sample_PointHead_SendGoal_Request_ *to);
extern  void __control_msgs_action_dds__Sample_PointHead_SendGoal_Request___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__Sample_PointHead_SendGoal_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _control_msgs_action_dds__PointHead_SendGoal_Request_ request_;
};

extern const char *control_msgs_action_dds__Sample_PointHead_SendGoal_Response__metaDescriptor[];
extern const int control_msgs_action_dds__Sample_PointHead_SendGoal_Response__metaDescriptorArrLength;
extern const int control_msgs_action_dds__Sample_PointHead_SendGoal_Response__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__Sample_PointHead_SendGoal_Response___load (c_base base);
struct _control_msgs_action_dds__Sample_PointHead_SendGoal_Response_ ;
extern  v_copyin_result __control_msgs_action_dds__Sample_PointHead_SendGoal_Response___copyIn(c_base base, const struct control_msgs::action::dds_::Sample_PointHead_SendGoal_Response_ *from, struct _control_msgs_action_dds__Sample_PointHead_SendGoal_Response_ *to);
extern  void __control_msgs_action_dds__Sample_PointHead_SendGoal_Response___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__Sample_PointHead_SendGoal_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _control_msgs_action_dds__PointHead_SendGoal_Response_ response_;
};

extern const char *control_msgs_action_dds__PointHead_Result__metaDescriptor[];
extern const int control_msgs_action_dds__PointHead_Result__metaDescriptorArrLength;
extern const int control_msgs_action_dds__PointHead_Result__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__PointHead_Result___load (c_base base);
struct _control_msgs_action_dds__PointHead_Result_ ;
extern  v_copyin_result __control_msgs_action_dds__PointHead_Result___copyIn(c_base base, const struct control_msgs::action::dds_::PointHead_Result_ *from, struct _control_msgs_action_dds__PointHead_Result_ *to);
extern  void __control_msgs_action_dds__PointHead_Result___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__PointHead_Result_ {
    c_octet structure_needs_at_least_one_member_;
};

extern const char *control_msgs_action_dds__PointHead_GetResult_Request__metaDescriptor[];
extern const int control_msgs_action_dds__PointHead_GetResult_Request__metaDescriptorArrLength;
extern const int control_msgs_action_dds__PointHead_GetResult_Request__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__PointHead_GetResult_Request___load (c_base base);
struct _control_msgs_action_dds__PointHead_GetResult_Request_ ;
extern  v_copyin_result __control_msgs_action_dds__PointHead_GetResult_Request___copyIn(c_base base, const struct control_msgs::action::dds_::PointHead_GetResult_Request_ *from, struct _control_msgs_action_dds__PointHead_GetResult_Request_ *to);
extern  void __control_msgs_action_dds__PointHead_GetResult_Request___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__PointHead_GetResult_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
};

extern const char *control_msgs_action_dds__PointHead_GetResult_Response__metaDescriptor[];
extern const int control_msgs_action_dds__PointHead_GetResult_Response__metaDescriptorArrLength;
extern const int control_msgs_action_dds__PointHead_GetResult_Response__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__PointHead_GetResult_Response___load (c_base base);
struct _control_msgs_action_dds__PointHead_GetResult_Response_ ;
extern  v_copyin_result __control_msgs_action_dds__PointHead_GetResult_Response___copyIn(c_base base, const struct control_msgs::action::dds_::PointHead_GetResult_Response_ *from, struct _control_msgs_action_dds__PointHead_GetResult_Response_ *to);
extern  void __control_msgs_action_dds__PointHead_GetResult_Response___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__PointHead_GetResult_Response_ {
    c_octet status_;
    struct _control_msgs_action_dds__PointHead_Result_ result_;
};

extern const char *control_msgs_action_dds__Sample_PointHead_GetResult_Request__metaDescriptor[];
extern const int control_msgs_action_dds__Sample_PointHead_GetResult_Request__metaDescriptorArrLength;
extern const int control_msgs_action_dds__Sample_PointHead_GetResult_Request__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__Sample_PointHead_GetResult_Request___load (c_base base);
struct _control_msgs_action_dds__Sample_PointHead_GetResult_Request_ ;
extern  v_copyin_result __control_msgs_action_dds__Sample_PointHead_GetResult_Request___copyIn(c_base base, const struct control_msgs::action::dds_::Sample_PointHead_GetResult_Request_ *from, struct _control_msgs_action_dds__Sample_PointHead_GetResult_Request_ *to);
extern  void __control_msgs_action_dds__Sample_PointHead_GetResult_Request___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__Sample_PointHead_GetResult_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _control_msgs_action_dds__PointHead_GetResult_Request_ request_;
};

extern const char *control_msgs_action_dds__Sample_PointHead_GetResult_Response__metaDescriptor[];
extern const int control_msgs_action_dds__Sample_PointHead_GetResult_Response__metaDescriptorArrLength;
extern const int control_msgs_action_dds__Sample_PointHead_GetResult_Response__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__Sample_PointHead_GetResult_Response___load (c_base base);
struct _control_msgs_action_dds__Sample_PointHead_GetResult_Response_ ;
extern  v_copyin_result __control_msgs_action_dds__Sample_PointHead_GetResult_Response___copyIn(c_base base, const struct control_msgs::action::dds_::Sample_PointHead_GetResult_Response_ *from, struct _control_msgs_action_dds__Sample_PointHead_GetResult_Response_ *to);
extern  void __control_msgs_action_dds__Sample_PointHead_GetResult_Response___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__Sample_PointHead_GetResult_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _control_msgs_action_dds__PointHead_GetResult_Response_ response_;
};

extern const char *control_msgs_action_dds__PointHead_Feedback__metaDescriptor[];
extern const int control_msgs_action_dds__PointHead_Feedback__metaDescriptorArrLength;
extern const int control_msgs_action_dds__PointHead_Feedback__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__PointHead_Feedback___load (c_base base);
struct _control_msgs_action_dds__PointHead_Feedback_ ;
extern  v_copyin_result __control_msgs_action_dds__PointHead_Feedback___copyIn(c_base base, const struct control_msgs::action::dds_::PointHead_Feedback_ *from, struct _control_msgs_action_dds__PointHead_Feedback_ *to);
extern  void __control_msgs_action_dds__PointHead_Feedback___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__PointHead_Feedback_ {
    c_double pointing_angle_error_;
};

extern const char *control_msgs_action_dds__PointHead_FeedbackMessage__metaDescriptor[];
extern const int control_msgs_action_dds__PointHead_FeedbackMessage__metaDescriptorArrLength;
extern const int control_msgs_action_dds__PointHead_FeedbackMessage__metaDescriptorLength;
extern c_metaObject __control_msgs_action_dds__PointHead_FeedbackMessage___load (c_base base);
struct _control_msgs_action_dds__PointHead_FeedbackMessage_ ;
extern  v_copyin_result __control_msgs_action_dds__PointHead_FeedbackMessage___copyIn(c_base base, const struct control_msgs::action::dds_::PointHead_FeedbackMessage_ *from, struct _control_msgs_action_dds__PointHead_FeedbackMessage_ *to);
extern  void __control_msgs_action_dds__PointHead_FeedbackMessage___copyOut(const void *_from, void *_to);
struct _control_msgs_action_dds__PointHead_FeedbackMessage_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
    struct _control_msgs_action_dds__PointHead_Feedback_ feedback_;
};

#undef OS_API
#endif
