#ifndef _H_907378FF79871B211D0B2A04D85E1DB9_SingleJointPosition_DCPS_H_
#define _H_907378FF79871B211D0B2A04D85E1DB9_SingleJointPosition_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SingleJointPosition_.h"


namespace control_msgs
{
    namespace action
    {
        namespace dds_
        {
            class SingleJointPosition_Goal_TypeSupportInterface;

            typedef SingleJointPosition_Goal_TypeSupportInterface * SingleJointPosition_Goal_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Goal_TypeSupportInterface> SingleJointPosition_Goal_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Goal_TypeSupportInterface> SingleJointPosition_Goal_TypeSupportInterface_out;


            class SingleJointPosition_Goal_DataWriter;

            typedef SingleJointPosition_Goal_DataWriter * SingleJointPosition_Goal_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Goal_DataWriter> SingleJointPosition_Goal_DataWriter_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Goal_DataWriter> SingleJointPosition_Goal_DataWriter_out;


            class SingleJointPosition_Goal_DataReader;

            typedef SingleJointPosition_Goal_DataReader * SingleJointPosition_Goal_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Goal_DataReader> SingleJointPosition_Goal_DataReader_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Goal_DataReader> SingleJointPosition_Goal_DataReader_out;


            class SingleJointPosition_Goal_DataReaderView;

            typedef SingleJointPosition_Goal_DataReaderView * SingleJointPosition_Goal_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Goal_DataReaderView> SingleJointPosition_Goal_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Goal_DataReaderView> SingleJointPosition_Goal_DataReaderView_out;

            struct SingleJointPosition_Goal_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SingleJointPosition_Goal_, struct SingleJointPosition_Goal_Seq_uniq_> SingleJointPosition_Goal_Seq;
            typedef DDS_DCPSSequence_var < SingleJointPosition_Goal_Seq> SingleJointPosition_Goal_Seq_var;
            typedef DDS_DCPSSequence_out < SingleJointPosition_Goal_Seq> SingleJointPosition_Goal_Seq_out;

            class  SingleJointPosition_Goal_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SingleJointPosition_Goal_TypeSupportInterface_ptr _ptr_type;
                typedef SingleJointPosition_Goal_TypeSupportInterface_var _var_type;

                static SingleJointPosition_Goal_TypeSupportInterface_ptr _duplicate (SingleJointPosition_Goal_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Goal_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Goal_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Goal_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Goal_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SingleJointPosition_Goal_TypeSupportInterface () {};
                ~SingleJointPosition_Goal_TypeSupportInterface () {};
            private:
                SingleJointPosition_Goal_TypeSupportInterface (const SingleJointPosition_Goal_TypeSupportInterface &);
                SingleJointPosition_Goal_TypeSupportInterface & operator = (const SingleJointPosition_Goal_TypeSupportInterface &);
            };

            class  SingleJointPosition_Goal_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SingleJointPosition_Goal_DataWriter_ptr _ptr_type;
                typedef SingleJointPosition_Goal_DataWriter_var _var_type;

                static SingleJointPosition_Goal_DataWriter_ptr _duplicate (SingleJointPosition_Goal_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Goal_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Goal_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Goal_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Goal_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SingleJointPosition_Goal_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SingleJointPosition_Goal_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SingleJointPosition_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SingleJointPosition_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SingleJointPosition_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SingleJointPosition_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SingleJointPosition_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SingleJointPosition_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SingleJointPosition_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SingleJointPosition_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_Goal_& instance_data) = 0;

            protected:
                SingleJointPosition_Goal_DataWriter () {};
                ~SingleJointPosition_Goal_DataWriter () {};
            private:
                SingleJointPosition_Goal_DataWriter (const SingleJointPosition_Goal_DataWriter &);
                SingleJointPosition_Goal_DataWriter & operator = (const SingleJointPosition_Goal_DataWriter &);
            };

            class  SingleJointPosition_Goal_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SingleJointPosition_Goal_DataReader_ptr _ptr_type;
                typedef SingleJointPosition_Goal_DataReader_var _var_type;

                static SingleJointPosition_Goal_DataReader_ptr _duplicate (SingleJointPosition_Goal_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Goal_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Goal_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Goal_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Goal_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_Goal_& instance) = 0;

            protected:
                SingleJointPosition_Goal_DataReader () {};
                ~SingleJointPosition_Goal_DataReader () {};
            private:
                SingleJointPosition_Goal_DataReader (const SingleJointPosition_Goal_DataReader &);
                SingleJointPosition_Goal_DataReader & operator = (const SingleJointPosition_Goal_DataReader &);
            };

            class  SingleJointPosition_Goal_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SingleJointPosition_Goal_DataReaderView_ptr _ptr_type;
                typedef SingleJointPosition_Goal_DataReaderView_var _var_type;

                static SingleJointPosition_Goal_DataReaderView_ptr _duplicate (SingleJointPosition_Goal_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Goal_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Goal_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Goal_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Goal_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_Goal_& instance) = 0;

            protected:
                SingleJointPosition_Goal_DataReaderView () {};
                ~SingleJointPosition_Goal_DataReaderView () {};
            private:
                SingleJointPosition_Goal_DataReaderView (const SingleJointPosition_Goal_DataReaderView &);
                SingleJointPosition_Goal_DataReaderView & operator = (const SingleJointPosition_Goal_DataReaderView &);
            };
            class SingleJointPosition_SendGoal_Request_TypeSupportInterface;

            typedef SingleJointPosition_SendGoal_Request_TypeSupportInterface * SingleJointPosition_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_SendGoal_Request_TypeSupportInterface> SingleJointPosition_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_SendGoal_Request_TypeSupportInterface> SingleJointPosition_SendGoal_Request_TypeSupportInterface_out;


            class SingleJointPosition_SendGoal_Request_DataWriter;

            typedef SingleJointPosition_SendGoal_Request_DataWriter * SingleJointPosition_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_SendGoal_Request_DataWriter> SingleJointPosition_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_SendGoal_Request_DataWriter> SingleJointPosition_SendGoal_Request_DataWriter_out;


            class SingleJointPosition_SendGoal_Request_DataReader;

            typedef SingleJointPosition_SendGoal_Request_DataReader * SingleJointPosition_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_SendGoal_Request_DataReader> SingleJointPosition_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_SendGoal_Request_DataReader> SingleJointPosition_SendGoal_Request_DataReader_out;


            class SingleJointPosition_SendGoal_Request_DataReaderView;

            typedef SingleJointPosition_SendGoal_Request_DataReaderView * SingleJointPosition_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_SendGoal_Request_DataReaderView> SingleJointPosition_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_SendGoal_Request_DataReaderView> SingleJointPosition_SendGoal_Request_DataReaderView_out;

            struct SingleJointPosition_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SingleJointPosition_SendGoal_Request_, struct SingleJointPosition_SendGoal_Request_Seq_uniq_> SingleJointPosition_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < SingleJointPosition_SendGoal_Request_Seq> SingleJointPosition_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SingleJointPosition_SendGoal_Request_Seq> SingleJointPosition_SendGoal_Request_Seq_out;

            class  SingleJointPosition_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SingleJointPosition_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SingleJointPosition_SendGoal_Request_TypeSupportInterface_var _var_type;

                static SingleJointPosition_SendGoal_Request_TypeSupportInterface_ptr _duplicate (SingleJointPosition_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SingleJointPosition_SendGoal_Request_TypeSupportInterface () {};
                ~SingleJointPosition_SendGoal_Request_TypeSupportInterface () {};
            private:
                SingleJointPosition_SendGoal_Request_TypeSupportInterface (const SingleJointPosition_SendGoal_Request_TypeSupportInterface &);
                SingleJointPosition_SendGoal_Request_TypeSupportInterface & operator = (const SingleJointPosition_SendGoal_Request_TypeSupportInterface &);
            };

            class  SingleJointPosition_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SingleJointPosition_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef SingleJointPosition_SendGoal_Request_DataWriter_var _var_type;

                static SingleJointPosition_SendGoal_Request_DataWriter_ptr _duplicate (SingleJointPosition_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SingleJointPosition_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SingleJointPosition_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SingleJointPosition_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SingleJointPosition_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SingleJointPosition_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SingleJointPosition_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SingleJointPosition_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SingleJointPosition_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SingleJointPosition_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SingleJointPosition_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_SendGoal_Request_& instance_data) = 0;

            protected:
                SingleJointPosition_SendGoal_Request_DataWriter () {};
                ~SingleJointPosition_SendGoal_Request_DataWriter () {};
            private:
                SingleJointPosition_SendGoal_Request_DataWriter (const SingleJointPosition_SendGoal_Request_DataWriter &);
                SingleJointPosition_SendGoal_Request_DataWriter & operator = (const SingleJointPosition_SendGoal_Request_DataWriter &);
            };

            class  SingleJointPosition_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SingleJointPosition_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef SingleJointPosition_SendGoal_Request_DataReader_var _var_type;

                static SingleJointPosition_SendGoal_Request_DataReader_ptr _duplicate (SingleJointPosition_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_SendGoal_Request_& instance) = 0;

            protected:
                SingleJointPosition_SendGoal_Request_DataReader () {};
                ~SingleJointPosition_SendGoal_Request_DataReader () {};
            private:
                SingleJointPosition_SendGoal_Request_DataReader (const SingleJointPosition_SendGoal_Request_DataReader &);
                SingleJointPosition_SendGoal_Request_DataReader & operator = (const SingleJointPosition_SendGoal_Request_DataReader &);
            };

            class  SingleJointPosition_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SingleJointPosition_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef SingleJointPosition_SendGoal_Request_DataReaderView_var _var_type;

                static SingleJointPosition_SendGoal_Request_DataReaderView_ptr _duplicate (SingleJointPosition_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_SendGoal_Request_& instance) = 0;

            protected:
                SingleJointPosition_SendGoal_Request_DataReaderView () {};
                ~SingleJointPosition_SendGoal_Request_DataReaderView () {};
            private:
                SingleJointPosition_SendGoal_Request_DataReaderView (const SingleJointPosition_SendGoal_Request_DataReaderView &);
                SingleJointPosition_SendGoal_Request_DataReaderView & operator = (const SingleJointPosition_SendGoal_Request_DataReaderView &);
            };
            class SingleJointPosition_SendGoal_Response_TypeSupportInterface;

            typedef SingleJointPosition_SendGoal_Response_TypeSupportInterface * SingleJointPosition_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_SendGoal_Response_TypeSupportInterface> SingleJointPosition_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_SendGoal_Response_TypeSupportInterface> SingleJointPosition_SendGoal_Response_TypeSupportInterface_out;


            class SingleJointPosition_SendGoal_Response_DataWriter;

            typedef SingleJointPosition_SendGoal_Response_DataWriter * SingleJointPosition_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_SendGoal_Response_DataWriter> SingleJointPosition_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_SendGoal_Response_DataWriter> SingleJointPosition_SendGoal_Response_DataWriter_out;


            class SingleJointPosition_SendGoal_Response_DataReader;

            typedef SingleJointPosition_SendGoal_Response_DataReader * SingleJointPosition_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_SendGoal_Response_DataReader> SingleJointPosition_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_SendGoal_Response_DataReader> SingleJointPosition_SendGoal_Response_DataReader_out;


            class SingleJointPosition_SendGoal_Response_DataReaderView;

            typedef SingleJointPosition_SendGoal_Response_DataReaderView * SingleJointPosition_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_SendGoal_Response_DataReaderView> SingleJointPosition_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_SendGoal_Response_DataReaderView> SingleJointPosition_SendGoal_Response_DataReaderView_out;

            struct SingleJointPosition_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SingleJointPosition_SendGoal_Response_, struct SingleJointPosition_SendGoal_Response_Seq_uniq_> SingleJointPosition_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < SingleJointPosition_SendGoal_Response_Seq> SingleJointPosition_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < SingleJointPosition_SendGoal_Response_Seq> SingleJointPosition_SendGoal_Response_Seq_out;

            class  SingleJointPosition_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SingleJointPosition_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef SingleJointPosition_SendGoal_Response_TypeSupportInterface_var _var_type;

                static SingleJointPosition_SendGoal_Response_TypeSupportInterface_ptr _duplicate (SingleJointPosition_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SingleJointPosition_SendGoal_Response_TypeSupportInterface () {};
                ~SingleJointPosition_SendGoal_Response_TypeSupportInterface () {};
            private:
                SingleJointPosition_SendGoal_Response_TypeSupportInterface (const SingleJointPosition_SendGoal_Response_TypeSupportInterface &);
                SingleJointPosition_SendGoal_Response_TypeSupportInterface & operator = (const SingleJointPosition_SendGoal_Response_TypeSupportInterface &);
            };

            class  SingleJointPosition_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SingleJointPosition_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef SingleJointPosition_SendGoal_Response_DataWriter_var _var_type;

                static SingleJointPosition_SendGoal_Response_DataWriter_ptr _duplicate (SingleJointPosition_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SingleJointPosition_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SingleJointPosition_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SingleJointPosition_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SingleJointPosition_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SingleJointPosition_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SingleJointPosition_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SingleJointPosition_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SingleJointPosition_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SingleJointPosition_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SingleJointPosition_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_SendGoal_Response_& instance_data) = 0;

            protected:
                SingleJointPosition_SendGoal_Response_DataWriter () {};
                ~SingleJointPosition_SendGoal_Response_DataWriter () {};
            private:
                SingleJointPosition_SendGoal_Response_DataWriter (const SingleJointPosition_SendGoal_Response_DataWriter &);
                SingleJointPosition_SendGoal_Response_DataWriter & operator = (const SingleJointPosition_SendGoal_Response_DataWriter &);
            };

            class  SingleJointPosition_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SingleJointPosition_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef SingleJointPosition_SendGoal_Response_DataReader_var _var_type;

                static SingleJointPosition_SendGoal_Response_DataReader_ptr _duplicate (SingleJointPosition_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_SendGoal_Response_& instance) = 0;

            protected:
                SingleJointPosition_SendGoal_Response_DataReader () {};
                ~SingleJointPosition_SendGoal_Response_DataReader () {};
            private:
                SingleJointPosition_SendGoal_Response_DataReader (const SingleJointPosition_SendGoal_Response_DataReader &);
                SingleJointPosition_SendGoal_Response_DataReader & operator = (const SingleJointPosition_SendGoal_Response_DataReader &);
            };

            class  SingleJointPosition_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SingleJointPosition_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef SingleJointPosition_SendGoal_Response_DataReaderView_var _var_type;

                static SingleJointPosition_SendGoal_Response_DataReaderView_ptr _duplicate (SingleJointPosition_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_SendGoal_Response_& instance) = 0;

            protected:
                SingleJointPosition_SendGoal_Response_DataReaderView () {};
                ~SingleJointPosition_SendGoal_Response_DataReaderView () {};
            private:
                SingleJointPosition_SendGoal_Response_DataReaderView (const SingleJointPosition_SendGoal_Response_DataReaderView &);
                SingleJointPosition_SendGoal_Response_DataReaderView & operator = (const SingleJointPosition_SendGoal_Response_DataReaderView &);
            };
            class Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface;

            typedef Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface * Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface> Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface> Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface_out;


            class Sample_SingleJointPosition_SendGoal_Request_DataWriter;

            typedef Sample_SingleJointPosition_SendGoal_Request_DataWriter * Sample_SingleJointPosition_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SingleJointPosition_SendGoal_Request_DataWriter> Sample_SingleJointPosition_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SingleJointPosition_SendGoal_Request_DataWriter> Sample_SingleJointPosition_SendGoal_Request_DataWriter_out;


            class Sample_SingleJointPosition_SendGoal_Request_DataReader;

            typedef Sample_SingleJointPosition_SendGoal_Request_DataReader * Sample_SingleJointPosition_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SingleJointPosition_SendGoal_Request_DataReader> Sample_SingleJointPosition_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SingleJointPosition_SendGoal_Request_DataReader> Sample_SingleJointPosition_SendGoal_Request_DataReader_out;


            class Sample_SingleJointPosition_SendGoal_Request_DataReaderView;

            typedef Sample_SingleJointPosition_SendGoal_Request_DataReaderView * Sample_SingleJointPosition_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SingleJointPosition_SendGoal_Request_DataReaderView> Sample_SingleJointPosition_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SingleJointPosition_SendGoal_Request_DataReaderView> Sample_SingleJointPosition_SendGoal_Request_DataReaderView_out;

            struct Sample_SingleJointPosition_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_SingleJointPosition_SendGoal_Request_, struct Sample_SingleJointPosition_SendGoal_Request_Seq_uniq_> Sample_SingleJointPosition_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_SingleJointPosition_SendGoal_Request_Seq> Sample_SingleJointPosition_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SingleJointPosition_SendGoal_Request_Seq> Sample_SingleJointPosition_SendGoal_Request_Seq_out;

            class  Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface_var _var_type;

                static Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface_ptr _duplicate (Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface () {};
                ~Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface () {};
            private:
                Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface (const Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface &);
                Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface & operator = (const Sample_SingleJointPosition_SendGoal_Request_TypeSupportInterface &);
            };

            class  Sample_SingleJointPosition_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SingleJointPosition_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef Sample_SingleJointPosition_SendGoal_Request_DataWriter_var _var_type;

                static Sample_SingleJointPosition_SendGoal_Request_DataWriter_ptr _duplicate (Sample_SingleJointPosition_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SingleJointPosition_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SingleJointPosition_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SingleJointPosition_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SingleJointPosition_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SingleJointPosition_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SingleJointPosition_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SingleJointPosition_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SingleJointPosition_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SingleJointPosition_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SingleJointPosition_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SingleJointPosition_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SingleJointPosition_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SingleJointPosition_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SingleJointPosition_SendGoal_Request_& instance_data) = 0;

            protected:
                Sample_SingleJointPosition_SendGoal_Request_DataWriter () {};
                ~Sample_SingleJointPosition_SendGoal_Request_DataWriter () {};
            private:
                Sample_SingleJointPosition_SendGoal_Request_DataWriter (const Sample_SingleJointPosition_SendGoal_Request_DataWriter &);
                Sample_SingleJointPosition_SendGoal_Request_DataWriter & operator = (const Sample_SingleJointPosition_SendGoal_Request_DataWriter &);
            };

            class  Sample_SingleJointPosition_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SingleJointPosition_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef Sample_SingleJointPosition_SendGoal_Request_DataReader_var _var_type;

                static Sample_SingleJointPosition_SendGoal_Request_DataReader_ptr _duplicate (Sample_SingleJointPosition_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SingleJointPosition_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SingleJointPosition_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SingleJointPosition_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SingleJointPosition_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SingleJointPosition_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SingleJointPosition_SendGoal_Request_& instance) = 0;

            protected:
                Sample_SingleJointPosition_SendGoal_Request_DataReader () {};
                ~Sample_SingleJointPosition_SendGoal_Request_DataReader () {};
            private:
                Sample_SingleJointPosition_SendGoal_Request_DataReader (const Sample_SingleJointPosition_SendGoal_Request_DataReader &);
                Sample_SingleJointPosition_SendGoal_Request_DataReader & operator = (const Sample_SingleJointPosition_SendGoal_Request_DataReader &);
            };

            class  Sample_SingleJointPosition_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SingleJointPosition_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_SingleJointPosition_SendGoal_Request_DataReaderView_var _var_type;

                static Sample_SingleJointPosition_SendGoal_Request_DataReaderView_ptr _duplicate (Sample_SingleJointPosition_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SingleJointPosition_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SingleJointPosition_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SingleJointPosition_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SingleJointPosition_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SingleJointPosition_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SingleJointPosition_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SingleJointPosition_SendGoal_Request_& instance) = 0;

            protected:
                Sample_SingleJointPosition_SendGoal_Request_DataReaderView () {};
                ~Sample_SingleJointPosition_SendGoal_Request_DataReaderView () {};
            private:
                Sample_SingleJointPosition_SendGoal_Request_DataReaderView (const Sample_SingleJointPosition_SendGoal_Request_DataReaderView &);
                Sample_SingleJointPosition_SendGoal_Request_DataReaderView & operator = (const Sample_SingleJointPosition_SendGoal_Request_DataReaderView &);
            };
            class Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface;

            typedef Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface * Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface> Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface> Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface_out;


            class Sample_SingleJointPosition_SendGoal_Response_DataWriter;

            typedef Sample_SingleJointPosition_SendGoal_Response_DataWriter * Sample_SingleJointPosition_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SingleJointPosition_SendGoal_Response_DataWriter> Sample_SingleJointPosition_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SingleJointPosition_SendGoal_Response_DataWriter> Sample_SingleJointPosition_SendGoal_Response_DataWriter_out;


            class Sample_SingleJointPosition_SendGoal_Response_DataReader;

            typedef Sample_SingleJointPosition_SendGoal_Response_DataReader * Sample_SingleJointPosition_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SingleJointPosition_SendGoal_Response_DataReader> Sample_SingleJointPosition_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SingleJointPosition_SendGoal_Response_DataReader> Sample_SingleJointPosition_SendGoal_Response_DataReader_out;


            class Sample_SingleJointPosition_SendGoal_Response_DataReaderView;

            typedef Sample_SingleJointPosition_SendGoal_Response_DataReaderView * Sample_SingleJointPosition_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SingleJointPosition_SendGoal_Response_DataReaderView> Sample_SingleJointPosition_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SingleJointPosition_SendGoal_Response_DataReaderView> Sample_SingleJointPosition_SendGoal_Response_DataReaderView_out;

            struct Sample_SingleJointPosition_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_SingleJointPosition_SendGoal_Response_, struct Sample_SingleJointPosition_SendGoal_Response_Seq_uniq_> Sample_SingleJointPosition_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_SingleJointPosition_SendGoal_Response_Seq> Sample_SingleJointPosition_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SingleJointPosition_SendGoal_Response_Seq> Sample_SingleJointPosition_SendGoal_Response_Seq_out;

            class  Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface_var _var_type;

                static Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface_ptr _duplicate (Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface () {};
                ~Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface () {};
            private:
                Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface (const Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface &);
                Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface & operator = (const Sample_SingleJointPosition_SendGoal_Response_TypeSupportInterface &);
            };

            class  Sample_SingleJointPosition_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SingleJointPosition_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef Sample_SingleJointPosition_SendGoal_Response_DataWriter_var _var_type;

                static Sample_SingleJointPosition_SendGoal_Response_DataWriter_ptr _duplicate (Sample_SingleJointPosition_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SingleJointPosition_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SingleJointPosition_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SingleJointPosition_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SingleJointPosition_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SingleJointPosition_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SingleJointPosition_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SingleJointPosition_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SingleJointPosition_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SingleJointPosition_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SingleJointPosition_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SingleJointPosition_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SingleJointPosition_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SingleJointPosition_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SingleJointPosition_SendGoal_Response_& instance_data) = 0;

            protected:
                Sample_SingleJointPosition_SendGoal_Response_DataWriter () {};
                ~Sample_SingleJointPosition_SendGoal_Response_DataWriter () {};
            private:
                Sample_SingleJointPosition_SendGoal_Response_DataWriter (const Sample_SingleJointPosition_SendGoal_Response_DataWriter &);
                Sample_SingleJointPosition_SendGoal_Response_DataWriter & operator = (const Sample_SingleJointPosition_SendGoal_Response_DataWriter &);
            };

            class  Sample_SingleJointPosition_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SingleJointPosition_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef Sample_SingleJointPosition_SendGoal_Response_DataReader_var _var_type;

                static Sample_SingleJointPosition_SendGoal_Response_DataReader_ptr _duplicate (Sample_SingleJointPosition_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SingleJointPosition_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SingleJointPosition_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SingleJointPosition_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SingleJointPosition_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SingleJointPosition_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SingleJointPosition_SendGoal_Response_& instance) = 0;

            protected:
                Sample_SingleJointPosition_SendGoal_Response_DataReader () {};
                ~Sample_SingleJointPosition_SendGoal_Response_DataReader () {};
            private:
                Sample_SingleJointPosition_SendGoal_Response_DataReader (const Sample_SingleJointPosition_SendGoal_Response_DataReader &);
                Sample_SingleJointPosition_SendGoal_Response_DataReader & operator = (const Sample_SingleJointPosition_SendGoal_Response_DataReader &);
            };

            class  Sample_SingleJointPosition_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SingleJointPosition_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_SingleJointPosition_SendGoal_Response_DataReaderView_var _var_type;

                static Sample_SingleJointPosition_SendGoal_Response_DataReaderView_ptr _duplicate (Sample_SingleJointPosition_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SingleJointPosition_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SingleJointPosition_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SingleJointPosition_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SingleJointPosition_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SingleJointPosition_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SingleJointPosition_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SingleJointPosition_SendGoal_Response_& instance) = 0;

            protected:
                Sample_SingleJointPosition_SendGoal_Response_DataReaderView () {};
                ~Sample_SingleJointPosition_SendGoal_Response_DataReaderView () {};
            private:
                Sample_SingleJointPosition_SendGoal_Response_DataReaderView (const Sample_SingleJointPosition_SendGoal_Response_DataReaderView &);
                Sample_SingleJointPosition_SendGoal_Response_DataReaderView & operator = (const Sample_SingleJointPosition_SendGoal_Response_DataReaderView &);
            };
            class SingleJointPosition_Result_TypeSupportInterface;

            typedef SingleJointPosition_Result_TypeSupportInterface * SingleJointPosition_Result_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Result_TypeSupportInterface> SingleJointPosition_Result_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Result_TypeSupportInterface> SingleJointPosition_Result_TypeSupportInterface_out;


            class SingleJointPosition_Result_DataWriter;

            typedef SingleJointPosition_Result_DataWriter * SingleJointPosition_Result_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Result_DataWriter> SingleJointPosition_Result_DataWriter_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Result_DataWriter> SingleJointPosition_Result_DataWriter_out;


            class SingleJointPosition_Result_DataReader;

            typedef SingleJointPosition_Result_DataReader * SingleJointPosition_Result_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Result_DataReader> SingleJointPosition_Result_DataReader_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Result_DataReader> SingleJointPosition_Result_DataReader_out;


            class SingleJointPosition_Result_DataReaderView;

            typedef SingleJointPosition_Result_DataReaderView * SingleJointPosition_Result_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Result_DataReaderView> SingleJointPosition_Result_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Result_DataReaderView> SingleJointPosition_Result_DataReaderView_out;

            struct SingleJointPosition_Result_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SingleJointPosition_Result_, struct SingleJointPosition_Result_Seq_uniq_> SingleJointPosition_Result_Seq;
            typedef DDS_DCPSSequence_var < SingleJointPosition_Result_Seq> SingleJointPosition_Result_Seq_var;
            typedef DDS_DCPSSequence_out < SingleJointPosition_Result_Seq> SingleJointPosition_Result_Seq_out;

            class  SingleJointPosition_Result_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SingleJointPosition_Result_TypeSupportInterface_ptr _ptr_type;
                typedef SingleJointPosition_Result_TypeSupportInterface_var _var_type;

                static SingleJointPosition_Result_TypeSupportInterface_ptr _duplicate (SingleJointPosition_Result_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Result_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Result_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Result_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Result_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SingleJointPosition_Result_TypeSupportInterface () {};
                ~SingleJointPosition_Result_TypeSupportInterface () {};
            private:
                SingleJointPosition_Result_TypeSupportInterface (const SingleJointPosition_Result_TypeSupportInterface &);
                SingleJointPosition_Result_TypeSupportInterface & operator = (const SingleJointPosition_Result_TypeSupportInterface &);
            };

            class  SingleJointPosition_Result_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SingleJointPosition_Result_DataWriter_ptr _ptr_type;
                typedef SingleJointPosition_Result_DataWriter_var _var_type;

                static SingleJointPosition_Result_DataWriter_ptr _duplicate (SingleJointPosition_Result_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Result_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Result_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Result_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Result_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SingleJointPosition_Result_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SingleJointPosition_Result_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SingleJointPosition_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SingleJointPosition_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SingleJointPosition_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SingleJointPosition_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SingleJointPosition_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SingleJointPosition_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SingleJointPosition_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SingleJointPosition_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_Result_& instance_data) = 0;

            protected:
                SingleJointPosition_Result_DataWriter () {};
                ~SingleJointPosition_Result_DataWriter () {};
            private:
                SingleJointPosition_Result_DataWriter (const SingleJointPosition_Result_DataWriter &);
                SingleJointPosition_Result_DataWriter & operator = (const SingleJointPosition_Result_DataWriter &);
            };

            class  SingleJointPosition_Result_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SingleJointPosition_Result_DataReader_ptr _ptr_type;
                typedef SingleJointPosition_Result_DataReader_var _var_type;

                static SingleJointPosition_Result_DataReader_ptr _duplicate (SingleJointPosition_Result_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Result_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Result_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Result_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Result_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_Result_& instance) = 0;

            protected:
                SingleJointPosition_Result_DataReader () {};
                ~SingleJointPosition_Result_DataReader () {};
            private:
                SingleJointPosition_Result_DataReader (const SingleJointPosition_Result_DataReader &);
                SingleJointPosition_Result_DataReader & operator = (const SingleJointPosition_Result_DataReader &);
            };

            class  SingleJointPosition_Result_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SingleJointPosition_Result_DataReaderView_ptr _ptr_type;
                typedef SingleJointPosition_Result_DataReaderView_var _var_type;

                static SingleJointPosition_Result_DataReaderView_ptr _duplicate (SingleJointPosition_Result_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Result_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Result_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Result_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Result_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_Result_& instance) = 0;

            protected:
                SingleJointPosition_Result_DataReaderView () {};
                ~SingleJointPosition_Result_DataReaderView () {};
            private:
                SingleJointPosition_Result_DataReaderView (const SingleJointPosition_Result_DataReaderView &);
                SingleJointPosition_Result_DataReaderView & operator = (const SingleJointPosition_Result_DataReaderView &);
            };
            class SingleJointPosition_GetResult_Request_TypeSupportInterface;

            typedef SingleJointPosition_GetResult_Request_TypeSupportInterface * SingleJointPosition_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_GetResult_Request_TypeSupportInterface> SingleJointPosition_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_GetResult_Request_TypeSupportInterface> SingleJointPosition_GetResult_Request_TypeSupportInterface_out;


            class SingleJointPosition_GetResult_Request_DataWriter;

            typedef SingleJointPosition_GetResult_Request_DataWriter * SingleJointPosition_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_GetResult_Request_DataWriter> SingleJointPosition_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_GetResult_Request_DataWriter> SingleJointPosition_GetResult_Request_DataWriter_out;


            class SingleJointPosition_GetResult_Request_DataReader;

            typedef SingleJointPosition_GetResult_Request_DataReader * SingleJointPosition_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_GetResult_Request_DataReader> SingleJointPosition_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_GetResult_Request_DataReader> SingleJointPosition_GetResult_Request_DataReader_out;


            class SingleJointPosition_GetResult_Request_DataReaderView;

            typedef SingleJointPosition_GetResult_Request_DataReaderView * SingleJointPosition_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_GetResult_Request_DataReaderView> SingleJointPosition_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_GetResult_Request_DataReaderView> SingleJointPosition_GetResult_Request_DataReaderView_out;

            struct SingleJointPosition_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SingleJointPosition_GetResult_Request_, struct SingleJointPosition_GetResult_Request_Seq_uniq_> SingleJointPosition_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < SingleJointPosition_GetResult_Request_Seq> SingleJointPosition_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SingleJointPosition_GetResult_Request_Seq> SingleJointPosition_GetResult_Request_Seq_out;

            class  SingleJointPosition_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SingleJointPosition_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SingleJointPosition_GetResult_Request_TypeSupportInterface_var _var_type;

                static SingleJointPosition_GetResult_Request_TypeSupportInterface_ptr _duplicate (SingleJointPosition_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SingleJointPosition_GetResult_Request_TypeSupportInterface () {};
                ~SingleJointPosition_GetResult_Request_TypeSupportInterface () {};
            private:
                SingleJointPosition_GetResult_Request_TypeSupportInterface (const SingleJointPosition_GetResult_Request_TypeSupportInterface &);
                SingleJointPosition_GetResult_Request_TypeSupportInterface & operator = (const SingleJointPosition_GetResult_Request_TypeSupportInterface &);
            };

            class  SingleJointPosition_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SingleJointPosition_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef SingleJointPosition_GetResult_Request_DataWriter_var _var_type;

                static SingleJointPosition_GetResult_Request_DataWriter_ptr _duplicate (SingleJointPosition_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SingleJointPosition_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SingleJointPosition_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SingleJointPosition_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SingleJointPosition_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SingleJointPosition_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SingleJointPosition_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SingleJointPosition_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SingleJointPosition_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SingleJointPosition_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SingleJointPosition_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_GetResult_Request_& instance_data) = 0;

            protected:
                SingleJointPosition_GetResult_Request_DataWriter () {};
                ~SingleJointPosition_GetResult_Request_DataWriter () {};
            private:
                SingleJointPosition_GetResult_Request_DataWriter (const SingleJointPosition_GetResult_Request_DataWriter &);
                SingleJointPosition_GetResult_Request_DataWriter & operator = (const SingleJointPosition_GetResult_Request_DataWriter &);
            };

            class  SingleJointPosition_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SingleJointPosition_GetResult_Request_DataReader_ptr _ptr_type;
                typedef SingleJointPosition_GetResult_Request_DataReader_var _var_type;

                static SingleJointPosition_GetResult_Request_DataReader_ptr _duplicate (SingleJointPosition_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_GetResult_Request_& instance) = 0;

            protected:
                SingleJointPosition_GetResult_Request_DataReader () {};
                ~SingleJointPosition_GetResult_Request_DataReader () {};
            private:
                SingleJointPosition_GetResult_Request_DataReader (const SingleJointPosition_GetResult_Request_DataReader &);
                SingleJointPosition_GetResult_Request_DataReader & operator = (const SingleJointPosition_GetResult_Request_DataReader &);
            };

            class  SingleJointPosition_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SingleJointPosition_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef SingleJointPosition_GetResult_Request_DataReaderView_var _var_type;

                static SingleJointPosition_GetResult_Request_DataReaderView_ptr _duplicate (SingleJointPosition_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_GetResult_Request_& instance) = 0;

            protected:
                SingleJointPosition_GetResult_Request_DataReaderView () {};
                ~SingleJointPosition_GetResult_Request_DataReaderView () {};
            private:
                SingleJointPosition_GetResult_Request_DataReaderView (const SingleJointPosition_GetResult_Request_DataReaderView &);
                SingleJointPosition_GetResult_Request_DataReaderView & operator = (const SingleJointPosition_GetResult_Request_DataReaderView &);
            };
            class SingleJointPosition_GetResult_Response_TypeSupportInterface;

            typedef SingleJointPosition_GetResult_Response_TypeSupportInterface * SingleJointPosition_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_GetResult_Response_TypeSupportInterface> SingleJointPosition_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_GetResult_Response_TypeSupportInterface> SingleJointPosition_GetResult_Response_TypeSupportInterface_out;


            class SingleJointPosition_GetResult_Response_DataWriter;

            typedef SingleJointPosition_GetResult_Response_DataWriter * SingleJointPosition_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_GetResult_Response_DataWriter> SingleJointPosition_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_GetResult_Response_DataWriter> SingleJointPosition_GetResult_Response_DataWriter_out;


            class SingleJointPosition_GetResult_Response_DataReader;

            typedef SingleJointPosition_GetResult_Response_DataReader * SingleJointPosition_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_GetResult_Response_DataReader> SingleJointPosition_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_GetResult_Response_DataReader> SingleJointPosition_GetResult_Response_DataReader_out;


            class SingleJointPosition_GetResult_Response_DataReaderView;

            typedef SingleJointPosition_GetResult_Response_DataReaderView * SingleJointPosition_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_GetResult_Response_DataReaderView> SingleJointPosition_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_GetResult_Response_DataReaderView> SingleJointPosition_GetResult_Response_DataReaderView_out;

            struct SingleJointPosition_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SingleJointPosition_GetResult_Response_, struct SingleJointPosition_GetResult_Response_Seq_uniq_> SingleJointPosition_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < SingleJointPosition_GetResult_Response_Seq> SingleJointPosition_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < SingleJointPosition_GetResult_Response_Seq> SingleJointPosition_GetResult_Response_Seq_out;

            class  SingleJointPosition_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SingleJointPosition_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef SingleJointPosition_GetResult_Response_TypeSupportInterface_var _var_type;

                static SingleJointPosition_GetResult_Response_TypeSupportInterface_ptr _duplicate (SingleJointPosition_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SingleJointPosition_GetResult_Response_TypeSupportInterface () {};
                ~SingleJointPosition_GetResult_Response_TypeSupportInterface () {};
            private:
                SingleJointPosition_GetResult_Response_TypeSupportInterface (const SingleJointPosition_GetResult_Response_TypeSupportInterface &);
                SingleJointPosition_GetResult_Response_TypeSupportInterface & operator = (const SingleJointPosition_GetResult_Response_TypeSupportInterface &);
            };

            class  SingleJointPosition_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SingleJointPosition_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef SingleJointPosition_GetResult_Response_DataWriter_var _var_type;

                static SingleJointPosition_GetResult_Response_DataWriter_ptr _duplicate (SingleJointPosition_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SingleJointPosition_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SingleJointPosition_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SingleJointPosition_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SingleJointPosition_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SingleJointPosition_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SingleJointPosition_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SingleJointPosition_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SingleJointPosition_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SingleJointPosition_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SingleJointPosition_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_GetResult_Response_& instance_data) = 0;

            protected:
                SingleJointPosition_GetResult_Response_DataWriter () {};
                ~SingleJointPosition_GetResult_Response_DataWriter () {};
            private:
                SingleJointPosition_GetResult_Response_DataWriter (const SingleJointPosition_GetResult_Response_DataWriter &);
                SingleJointPosition_GetResult_Response_DataWriter & operator = (const SingleJointPosition_GetResult_Response_DataWriter &);
            };

            class  SingleJointPosition_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SingleJointPosition_GetResult_Response_DataReader_ptr _ptr_type;
                typedef SingleJointPosition_GetResult_Response_DataReader_var _var_type;

                static SingleJointPosition_GetResult_Response_DataReader_ptr _duplicate (SingleJointPosition_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_GetResult_Response_& instance) = 0;

            protected:
                SingleJointPosition_GetResult_Response_DataReader () {};
                ~SingleJointPosition_GetResult_Response_DataReader () {};
            private:
                SingleJointPosition_GetResult_Response_DataReader (const SingleJointPosition_GetResult_Response_DataReader &);
                SingleJointPosition_GetResult_Response_DataReader & operator = (const SingleJointPosition_GetResult_Response_DataReader &);
            };

            class  SingleJointPosition_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SingleJointPosition_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef SingleJointPosition_GetResult_Response_DataReaderView_var _var_type;

                static SingleJointPosition_GetResult_Response_DataReaderView_ptr _duplicate (SingleJointPosition_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_GetResult_Response_& instance) = 0;

            protected:
                SingleJointPosition_GetResult_Response_DataReaderView () {};
                ~SingleJointPosition_GetResult_Response_DataReaderView () {};
            private:
                SingleJointPosition_GetResult_Response_DataReaderView (const SingleJointPosition_GetResult_Response_DataReaderView &);
                SingleJointPosition_GetResult_Response_DataReaderView & operator = (const SingleJointPosition_GetResult_Response_DataReaderView &);
            };
            class Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface;

            typedef Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface * Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface> Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface> Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface_out;


            class Sample_SingleJointPosition_GetResult_Request_DataWriter;

            typedef Sample_SingleJointPosition_GetResult_Request_DataWriter * Sample_SingleJointPosition_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SingleJointPosition_GetResult_Request_DataWriter> Sample_SingleJointPosition_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SingleJointPosition_GetResult_Request_DataWriter> Sample_SingleJointPosition_GetResult_Request_DataWriter_out;


            class Sample_SingleJointPosition_GetResult_Request_DataReader;

            typedef Sample_SingleJointPosition_GetResult_Request_DataReader * Sample_SingleJointPosition_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SingleJointPosition_GetResult_Request_DataReader> Sample_SingleJointPosition_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SingleJointPosition_GetResult_Request_DataReader> Sample_SingleJointPosition_GetResult_Request_DataReader_out;


            class Sample_SingleJointPosition_GetResult_Request_DataReaderView;

            typedef Sample_SingleJointPosition_GetResult_Request_DataReaderView * Sample_SingleJointPosition_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SingleJointPosition_GetResult_Request_DataReaderView> Sample_SingleJointPosition_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SingleJointPosition_GetResult_Request_DataReaderView> Sample_SingleJointPosition_GetResult_Request_DataReaderView_out;

            struct Sample_SingleJointPosition_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_SingleJointPosition_GetResult_Request_, struct Sample_SingleJointPosition_GetResult_Request_Seq_uniq_> Sample_SingleJointPosition_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_SingleJointPosition_GetResult_Request_Seq> Sample_SingleJointPosition_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SingleJointPosition_GetResult_Request_Seq> Sample_SingleJointPosition_GetResult_Request_Seq_out;

            class  Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface_var _var_type;

                static Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface_ptr _duplicate (Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface () {};
                ~Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface () {};
            private:
                Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface (const Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface &);
                Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface & operator = (const Sample_SingleJointPosition_GetResult_Request_TypeSupportInterface &);
            };

            class  Sample_SingleJointPosition_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SingleJointPosition_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef Sample_SingleJointPosition_GetResult_Request_DataWriter_var _var_type;

                static Sample_SingleJointPosition_GetResult_Request_DataWriter_ptr _duplicate (Sample_SingleJointPosition_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SingleJointPosition_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SingleJointPosition_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SingleJointPosition_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SingleJointPosition_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SingleJointPosition_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SingleJointPosition_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SingleJointPosition_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SingleJointPosition_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SingleJointPosition_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SingleJointPosition_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SingleJointPosition_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SingleJointPosition_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SingleJointPosition_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SingleJointPosition_GetResult_Request_& instance_data) = 0;

            protected:
                Sample_SingleJointPosition_GetResult_Request_DataWriter () {};
                ~Sample_SingleJointPosition_GetResult_Request_DataWriter () {};
            private:
                Sample_SingleJointPosition_GetResult_Request_DataWriter (const Sample_SingleJointPosition_GetResult_Request_DataWriter &);
                Sample_SingleJointPosition_GetResult_Request_DataWriter & operator = (const Sample_SingleJointPosition_GetResult_Request_DataWriter &);
            };

            class  Sample_SingleJointPosition_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SingleJointPosition_GetResult_Request_DataReader_ptr _ptr_type;
                typedef Sample_SingleJointPosition_GetResult_Request_DataReader_var _var_type;

                static Sample_SingleJointPosition_GetResult_Request_DataReader_ptr _duplicate (Sample_SingleJointPosition_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SingleJointPosition_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SingleJointPosition_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SingleJointPosition_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SingleJointPosition_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SingleJointPosition_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SingleJointPosition_GetResult_Request_& instance) = 0;

            protected:
                Sample_SingleJointPosition_GetResult_Request_DataReader () {};
                ~Sample_SingleJointPosition_GetResult_Request_DataReader () {};
            private:
                Sample_SingleJointPosition_GetResult_Request_DataReader (const Sample_SingleJointPosition_GetResult_Request_DataReader &);
                Sample_SingleJointPosition_GetResult_Request_DataReader & operator = (const Sample_SingleJointPosition_GetResult_Request_DataReader &);
            };

            class  Sample_SingleJointPosition_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SingleJointPosition_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_SingleJointPosition_GetResult_Request_DataReaderView_var _var_type;

                static Sample_SingleJointPosition_GetResult_Request_DataReaderView_ptr _duplicate (Sample_SingleJointPosition_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SingleJointPosition_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SingleJointPosition_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SingleJointPosition_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SingleJointPosition_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SingleJointPosition_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SingleJointPosition_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SingleJointPosition_GetResult_Request_& instance) = 0;

            protected:
                Sample_SingleJointPosition_GetResult_Request_DataReaderView () {};
                ~Sample_SingleJointPosition_GetResult_Request_DataReaderView () {};
            private:
                Sample_SingleJointPosition_GetResult_Request_DataReaderView (const Sample_SingleJointPosition_GetResult_Request_DataReaderView &);
                Sample_SingleJointPosition_GetResult_Request_DataReaderView & operator = (const Sample_SingleJointPosition_GetResult_Request_DataReaderView &);
            };
            class Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface;

            typedef Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface * Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface> Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface> Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface_out;


            class Sample_SingleJointPosition_GetResult_Response_DataWriter;

            typedef Sample_SingleJointPosition_GetResult_Response_DataWriter * Sample_SingleJointPosition_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SingleJointPosition_GetResult_Response_DataWriter> Sample_SingleJointPosition_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SingleJointPosition_GetResult_Response_DataWriter> Sample_SingleJointPosition_GetResult_Response_DataWriter_out;


            class Sample_SingleJointPosition_GetResult_Response_DataReader;

            typedef Sample_SingleJointPosition_GetResult_Response_DataReader * Sample_SingleJointPosition_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SingleJointPosition_GetResult_Response_DataReader> Sample_SingleJointPosition_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SingleJointPosition_GetResult_Response_DataReader> Sample_SingleJointPosition_GetResult_Response_DataReader_out;


            class Sample_SingleJointPosition_GetResult_Response_DataReaderView;

            typedef Sample_SingleJointPosition_GetResult_Response_DataReaderView * Sample_SingleJointPosition_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SingleJointPosition_GetResult_Response_DataReaderView> Sample_SingleJointPosition_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SingleJointPosition_GetResult_Response_DataReaderView> Sample_SingleJointPosition_GetResult_Response_DataReaderView_out;

            struct Sample_SingleJointPosition_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_SingleJointPosition_GetResult_Response_, struct Sample_SingleJointPosition_GetResult_Response_Seq_uniq_> Sample_SingleJointPosition_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_SingleJointPosition_GetResult_Response_Seq> Sample_SingleJointPosition_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SingleJointPosition_GetResult_Response_Seq> Sample_SingleJointPosition_GetResult_Response_Seq_out;

            class  Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface_var _var_type;

                static Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface_ptr _duplicate (Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface () {};
                ~Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface () {};
            private:
                Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface (const Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface &);
                Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface & operator = (const Sample_SingleJointPosition_GetResult_Response_TypeSupportInterface &);
            };

            class  Sample_SingleJointPosition_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SingleJointPosition_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef Sample_SingleJointPosition_GetResult_Response_DataWriter_var _var_type;

                static Sample_SingleJointPosition_GetResult_Response_DataWriter_ptr _duplicate (Sample_SingleJointPosition_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SingleJointPosition_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SingleJointPosition_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SingleJointPosition_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SingleJointPosition_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SingleJointPosition_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SingleJointPosition_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SingleJointPosition_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SingleJointPosition_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SingleJointPosition_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SingleJointPosition_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SingleJointPosition_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SingleJointPosition_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SingleJointPosition_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SingleJointPosition_GetResult_Response_& instance_data) = 0;

            protected:
                Sample_SingleJointPosition_GetResult_Response_DataWriter () {};
                ~Sample_SingleJointPosition_GetResult_Response_DataWriter () {};
            private:
                Sample_SingleJointPosition_GetResult_Response_DataWriter (const Sample_SingleJointPosition_GetResult_Response_DataWriter &);
                Sample_SingleJointPosition_GetResult_Response_DataWriter & operator = (const Sample_SingleJointPosition_GetResult_Response_DataWriter &);
            };

            class  Sample_SingleJointPosition_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SingleJointPosition_GetResult_Response_DataReader_ptr _ptr_type;
                typedef Sample_SingleJointPosition_GetResult_Response_DataReader_var _var_type;

                static Sample_SingleJointPosition_GetResult_Response_DataReader_ptr _duplicate (Sample_SingleJointPosition_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SingleJointPosition_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SingleJointPosition_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SingleJointPosition_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SingleJointPosition_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SingleJointPosition_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SingleJointPosition_GetResult_Response_& instance) = 0;

            protected:
                Sample_SingleJointPosition_GetResult_Response_DataReader () {};
                ~Sample_SingleJointPosition_GetResult_Response_DataReader () {};
            private:
                Sample_SingleJointPosition_GetResult_Response_DataReader (const Sample_SingleJointPosition_GetResult_Response_DataReader &);
                Sample_SingleJointPosition_GetResult_Response_DataReader & operator = (const Sample_SingleJointPosition_GetResult_Response_DataReader &);
            };

            class  Sample_SingleJointPosition_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SingleJointPosition_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_SingleJointPosition_GetResult_Response_DataReaderView_var _var_type;

                static Sample_SingleJointPosition_GetResult_Response_DataReaderView_ptr _duplicate (Sample_SingleJointPosition_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SingleJointPosition_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SingleJointPosition_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SingleJointPosition_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SingleJointPosition_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SingleJointPosition_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SingleJointPosition_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SingleJointPosition_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SingleJointPosition_GetResult_Response_& instance) = 0;

            protected:
                Sample_SingleJointPosition_GetResult_Response_DataReaderView () {};
                ~Sample_SingleJointPosition_GetResult_Response_DataReaderView () {};
            private:
                Sample_SingleJointPosition_GetResult_Response_DataReaderView (const Sample_SingleJointPosition_GetResult_Response_DataReaderView &);
                Sample_SingleJointPosition_GetResult_Response_DataReaderView & operator = (const Sample_SingleJointPosition_GetResult_Response_DataReaderView &);
            };
            class SingleJointPosition_Feedback_TypeSupportInterface;

            typedef SingleJointPosition_Feedback_TypeSupportInterface * SingleJointPosition_Feedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Feedback_TypeSupportInterface> SingleJointPosition_Feedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Feedback_TypeSupportInterface> SingleJointPosition_Feedback_TypeSupportInterface_out;


            class SingleJointPosition_Feedback_DataWriter;

            typedef SingleJointPosition_Feedback_DataWriter * SingleJointPosition_Feedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Feedback_DataWriter> SingleJointPosition_Feedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Feedback_DataWriter> SingleJointPosition_Feedback_DataWriter_out;


            class SingleJointPosition_Feedback_DataReader;

            typedef SingleJointPosition_Feedback_DataReader * SingleJointPosition_Feedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Feedback_DataReader> SingleJointPosition_Feedback_DataReader_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Feedback_DataReader> SingleJointPosition_Feedback_DataReader_out;


            class SingleJointPosition_Feedback_DataReaderView;

            typedef SingleJointPosition_Feedback_DataReaderView * SingleJointPosition_Feedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_Feedback_DataReaderView> SingleJointPosition_Feedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_Feedback_DataReaderView> SingleJointPosition_Feedback_DataReaderView_out;

            struct SingleJointPosition_Feedback_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SingleJointPosition_Feedback_, struct SingleJointPosition_Feedback_Seq_uniq_> SingleJointPosition_Feedback_Seq;
            typedef DDS_DCPSSequence_var < SingleJointPosition_Feedback_Seq> SingleJointPosition_Feedback_Seq_var;
            typedef DDS_DCPSSequence_out < SingleJointPosition_Feedback_Seq> SingleJointPosition_Feedback_Seq_out;

            class  SingleJointPosition_Feedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SingleJointPosition_Feedback_TypeSupportInterface_ptr _ptr_type;
                typedef SingleJointPosition_Feedback_TypeSupportInterface_var _var_type;

                static SingleJointPosition_Feedback_TypeSupportInterface_ptr _duplicate (SingleJointPosition_Feedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Feedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Feedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Feedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Feedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SingleJointPosition_Feedback_TypeSupportInterface () {};
                ~SingleJointPosition_Feedback_TypeSupportInterface () {};
            private:
                SingleJointPosition_Feedback_TypeSupportInterface (const SingleJointPosition_Feedback_TypeSupportInterface &);
                SingleJointPosition_Feedback_TypeSupportInterface & operator = (const SingleJointPosition_Feedback_TypeSupportInterface &);
            };

            class  SingleJointPosition_Feedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SingleJointPosition_Feedback_DataWriter_ptr _ptr_type;
                typedef SingleJointPosition_Feedback_DataWriter_var _var_type;

                static SingleJointPosition_Feedback_DataWriter_ptr _duplicate (SingleJointPosition_Feedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Feedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Feedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Feedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Feedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SingleJointPosition_Feedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SingleJointPosition_Feedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SingleJointPosition_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SingleJointPosition_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SingleJointPosition_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SingleJointPosition_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SingleJointPosition_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SingleJointPosition_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SingleJointPosition_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SingleJointPosition_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_Feedback_& instance_data) = 0;

            protected:
                SingleJointPosition_Feedback_DataWriter () {};
                ~SingleJointPosition_Feedback_DataWriter () {};
            private:
                SingleJointPosition_Feedback_DataWriter (const SingleJointPosition_Feedback_DataWriter &);
                SingleJointPosition_Feedback_DataWriter & operator = (const SingleJointPosition_Feedback_DataWriter &);
            };

            class  SingleJointPosition_Feedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SingleJointPosition_Feedback_DataReader_ptr _ptr_type;
                typedef SingleJointPosition_Feedback_DataReader_var _var_type;

                static SingleJointPosition_Feedback_DataReader_ptr _duplicate (SingleJointPosition_Feedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Feedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Feedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Feedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Feedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_Feedback_& instance) = 0;

            protected:
                SingleJointPosition_Feedback_DataReader () {};
                ~SingleJointPosition_Feedback_DataReader () {};
            private:
                SingleJointPosition_Feedback_DataReader (const SingleJointPosition_Feedback_DataReader &);
                SingleJointPosition_Feedback_DataReader & operator = (const SingleJointPosition_Feedback_DataReader &);
            };

            class  SingleJointPosition_Feedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SingleJointPosition_Feedback_DataReaderView_ptr _ptr_type;
                typedef SingleJointPosition_Feedback_DataReaderView_var _var_type;

                static SingleJointPosition_Feedback_DataReaderView_ptr _duplicate (SingleJointPosition_Feedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_Feedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Feedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_Feedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_Feedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_Feedback_& instance) = 0;

            protected:
                SingleJointPosition_Feedback_DataReaderView () {};
                ~SingleJointPosition_Feedback_DataReaderView () {};
            private:
                SingleJointPosition_Feedback_DataReaderView (const SingleJointPosition_Feedback_DataReaderView &);
                SingleJointPosition_Feedback_DataReaderView & operator = (const SingleJointPosition_Feedback_DataReaderView &);
            };
            class SingleJointPosition_FeedbackMessage_TypeSupportInterface;

            typedef SingleJointPosition_FeedbackMessage_TypeSupportInterface * SingleJointPosition_FeedbackMessage_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_FeedbackMessage_TypeSupportInterface> SingleJointPosition_FeedbackMessage_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_FeedbackMessage_TypeSupportInterface> SingleJointPosition_FeedbackMessage_TypeSupportInterface_out;


            class SingleJointPosition_FeedbackMessage_DataWriter;

            typedef SingleJointPosition_FeedbackMessage_DataWriter * SingleJointPosition_FeedbackMessage_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_FeedbackMessage_DataWriter> SingleJointPosition_FeedbackMessage_DataWriter_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_FeedbackMessage_DataWriter> SingleJointPosition_FeedbackMessage_DataWriter_out;


            class SingleJointPosition_FeedbackMessage_DataReader;

            typedef SingleJointPosition_FeedbackMessage_DataReader * SingleJointPosition_FeedbackMessage_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_FeedbackMessage_DataReader> SingleJointPosition_FeedbackMessage_DataReader_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_FeedbackMessage_DataReader> SingleJointPosition_FeedbackMessage_DataReader_out;


            class SingleJointPosition_FeedbackMessage_DataReaderView;

            typedef SingleJointPosition_FeedbackMessage_DataReaderView * SingleJointPosition_FeedbackMessage_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SingleJointPosition_FeedbackMessage_DataReaderView> SingleJointPosition_FeedbackMessage_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SingleJointPosition_FeedbackMessage_DataReaderView> SingleJointPosition_FeedbackMessage_DataReaderView_out;

            struct SingleJointPosition_FeedbackMessage_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SingleJointPosition_FeedbackMessage_, struct SingleJointPosition_FeedbackMessage_Seq_uniq_> SingleJointPosition_FeedbackMessage_Seq;
            typedef DDS_DCPSSequence_var < SingleJointPosition_FeedbackMessage_Seq> SingleJointPosition_FeedbackMessage_Seq_var;
            typedef DDS_DCPSSequence_out < SingleJointPosition_FeedbackMessage_Seq> SingleJointPosition_FeedbackMessage_Seq_out;

            class  SingleJointPosition_FeedbackMessage_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SingleJointPosition_FeedbackMessage_TypeSupportInterface_ptr _ptr_type;
                typedef SingleJointPosition_FeedbackMessage_TypeSupportInterface_var _var_type;

                static SingleJointPosition_FeedbackMessage_TypeSupportInterface_ptr _duplicate (SingleJointPosition_FeedbackMessage_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_FeedbackMessage_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_FeedbackMessage_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_FeedbackMessage_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_FeedbackMessage_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SingleJointPosition_FeedbackMessage_TypeSupportInterface () {};
                ~SingleJointPosition_FeedbackMessage_TypeSupportInterface () {};
            private:
                SingleJointPosition_FeedbackMessage_TypeSupportInterface (const SingleJointPosition_FeedbackMessage_TypeSupportInterface &);
                SingleJointPosition_FeedbackMessage_TypeSupportInterface & operator = (const SingleJointPosition_FeedbackMessage_TypeSupportInterface &);
            };

            class  SingleJointPosition_FeedbackMessage_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SingleJointPosition_FeedbackMessage_DataWriter_ptr _ptr_type;
                typedef SingleJointPosition_FeedbackMessage_DataWriter_var _var_type;

                static SingleJointPosition_FeedbackMessage_DataWriter_ptr _duplicate (SingleJointPosition_FeedbackMessage_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_FeedbackMessage_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_FeedbackMessage_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_FeedbackMessage_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_FeedbackMessage_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SingleJointPosition_FeedbackMessage_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SingleJointPosition_FeedbackMessage_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SingleJointPosition_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SingleJointPosition_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SingleJointPosition_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SingleJointPosition_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SingleJointPosition_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SingleJointPosition_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SingleJointPosition_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SingleJointPosition_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_FeedbackMessage_& instance_data) = 0;

            protected:
                SingleJointPosition_FeedbackMessage_DataWriter () {};
                ~SingleJointPosition_FeedbackMessage_DataWriter () {};
            private:
                SingleJointPosition_FeedbackMessage_DataWriter (const SingleJointPosition_FeedbackMessage_DataWriter &);
                SingleJointPosition_FeedbackMessage_DataWriter & operator = (const SingleJointPosition_FeedbackMessage_DataWriter &);
            };

            class  SingleJointPosition_FeedbackMessage_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SingleJointPosition_FeedbackMessage_DataReader_ptr _ptr_type;
                typedef SingleJointPosition_FeedbackMessage_DataReader_var _var_type;

                static SingleJointPosition_FeedbackMessage_DataReader_ptr _duplicate (SingleJointPosition_FeedbackMessage_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_FeedbackMessage_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_FeedbackMessage_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_FeedbackMessage_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_FeedbackMessage_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_FeedbackMessage_& instance) = 0;

            protected:
                SingleJointPosition_FeedbackMessage_DataReader () {};
                ~SingleJointPosition_FeedbackMessage_DataReader () {};
            private:
                SingleJointPosition_FeedbackMessage_DataReader (const SingleJointPosition_FeedbackMessage_DataReader &);
                SingleJointPosition_FeedbackMessage_DataReader & operator = (const SingleJointPosition_FeedbackMessage_DataReader &);
            };

            class  SingleJointPosition_FeedbackMessage_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SingleJointPosition_FeedbackMessage_DataReaderView_ptr _ptr_type;
                typedef SingleJointPosition_FeedbackMessage_DataReaderView_var _var_type;

                static SingleJointPosition_FeedbackMessage_DataReaderView_ptr _duplicate (SingleJointPosition_FeedbackMessage_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SingleJointPosition_FeedbackMessage_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SingleJointPosition_FeedbackMessage_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SingleJointPosition_FeedbackMessage_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SingleJointPosition_FeedbackMessage_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SingleJointPosition_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SingleJointPosition_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SingleJointPosition_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SingleJointPosition_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SingleJointPosition_FeedbackMessage_& instance) = 0;

            protected:
                SingleJointPosition_FeedbackMessage_DataReaderView () {};
                ~SingleJointPosition_FeedbackMessage_DataReaderView () {};
            private:
                SingleJointPosition_FeedbackMessage_DataReaderView (const SingleJointPosition_FeedbackMessage_DataReaderView &);
                SingleJointPosition_FeedbackMessage_DataReaderView & operator = (const SingleJointPosition_FeedbackMessage_DataReaderView &);
            };
        }

    }

}

#endif
