#ifndef _H_887F538990C0E29AD231983F5F353479_JointControllerState_DCPS_H_
#define _H_887F538990C0E29AD231983F5F353479_JointControllerState_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "JointControllerState_.h"


namespace control_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class JointControllerState_TypeSupportInterface;

            typedef JointControllerState_TypeSupportInterface * JointControllerState_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < JointControllerState_TypeSupportInterface> JointControllerState_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < JointControllerState_TypeSupportInterface> JointControllerState_TypeSupportInterface_out;


            class JointControllerState_DataWriter;

            typedef JointControllerState_DataWriter * JointControllerState_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < JointControllerState_DataWriter> JointControllerState_DataWriter_var;
            typedef DDS_DCPSInterface_out < JointControllerState_DataWriter> JointControllerState_DataWriter_out;


            class JointControllerState_DataReader;

            typedef JointControllerState_DataReader * JointControllerState_DataReader_ptr;
            typedef DDS_DCPSInterface_var < JointControllerState_DataReader> JointControllerState_DataReader_var;
            typedef DDS_DCPSInterface_out < JointControllerState_DataReader> JointControllerState_DataReader_out;


            class JointControllerState_DataReaderView;

            typedef JointControllerState_DataReaderView * JointControllerState_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < JointControllerState_DataReaderView> JointControllerState_DataReaderView_var;
            typedef DDS_DCPSInterface_out < JointControllerState_DataReaderView> JointControllerState_DataReaderView_out;

            struct JointControllerState_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < JointControllerState_, struct JointControllerState_Seq_uniq_> JointControllerState_Seq;
            typedef DDS_DCPSSequence_var < JointControllerState_Seq> JointControllerState_Seq_var;
            typedef DDS_DCPSSequence_out < JointControllerState_Seq> JointControllerState_Seq_out;

            class  JointControllerState_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef JointControllerState_TypeSupportInterface_ptr _ptr_type;
                typedef JointControllerState_TypeSupportInterface_var _var_type;

                static JointControllerState_TypeSupportInterface_ptr _duplicate (JointControllerState_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static JointControllerState_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static JointControllerState_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static JointControllerState_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                JointControllerState_TypeSupportInterface_ptr _this () { return this; }


            protected:
                JointControllerState_TypeSupportInterface () {};
                ~JointControllerState_TypeSupportInterface () {};
            private:
                JointControllerState_TypeSupportInterface (const JointControllerState_TypeSupportInterface &);
                JointControllerState_TypeSupportInterface & operator = (const JointControllerState_TypeSupportInterface &);
            };

            class  JointControllerState_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef JointControllerState_DataWriter_ptr _ptr_type;
                typedef JointControllerState_DataWriter_var _var_type;

                static JointControllerState_DataWriter_ptr _duplicate (JointControllerState_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static JointControllerState_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static JointControllerState_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static JointControllerState_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                JointControllerState_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const JointControllerState_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const JointControllerState_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const JointControllerState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const JointControllerState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const JointControllerState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const JointControllerState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const JointControllerState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const JointControllerState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const JointControllerState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const JointControllerState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (JointControllerState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const JointControllerState_& instance_data) = 0;

            protected:
                JointControllerState_DataWriter () {};
                ~JointControllerState_DataWriter () {};
            private:
                JointControllerState_DataWriter (const JointControllerState_DataWriter &);
                JointControllerState_DataWriter & operator = (const JointControllerState_DataWriter &);
            };

            class  JointControllerState_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef JointControllerState_DataReader_ptr _ptr_type;
                typedef JointControllerState_DataReader_var _var_type;

                static JointControllerState_DataReader_ptr _duplicate (JointControllerState_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static JointControllerState_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static JointControllerState_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static JointControllerState_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                JointControllerState_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (JointControllerState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (JointControllerState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (JointControllerState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const JointControllerState_& instance) = 0;

            protected:
                JointControllerState_DataReader () {};
                ~JointControllerState_DataReader () {};
            private:
                JointControllerState_DataReader (const JointControllerState_DataReader &);
                JointControllerState_DataReader & operator = (const JointControllerState_DataReader &);
            };

            class  JointControllerState_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef JointControllerState_DataReaderView_ptr _ptr_type;
                typedef JointControllerState_DataReaderView_var _var_type;

                static JointControllerState_DataReaderView_ptr _duplicate (JointControllerState_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static JointControllerState_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static JointControllerState_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static JointControllerState_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                JointControllerState_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (JointControllerState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (JointControllerState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (JointControllerState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (JointControllerState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const JointControllerState_& instance) = 0;

            protected:
                JointControllerState_DataReaderView () {};
                ~JointControllerState_DataReaderView () {};
            private:
                JointControllerState_DataReaderView (const JointControllerState_DataReaderView &);
                JointControllerState_DataReaderView & operator = (const JointControllerState_DataReaderView &);
            };
        }

    }

}

#endif
