#ifndef _H_C87961588971803DF4F92198162114B8_JointTolerance_DCPS_H_
#define _H_C87961588971803DF4F92198162114B8_JointTolerance_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "JointTolerance_.h"


namespace control_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class JointTolerance_TypeSupportInterface;

            typedef JointTolerance_TypeSupportInterface * JointTolerance_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < JointTolerance_TypeSupportInterface> JointTolerance_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < JointTolerance_TypeSupportInterface> JointTolerance_TypeSupportInterface_out;


            class JointTolerance_DataWriter;

            typedef JointTolerance_DataWriter * JointTolerance_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < JointTolerance_DataWriter> JointTolerance_DataWriter_var;
            typedef DDS_DCPSInterface_out < JointTolerance_DataWriter> JointTolerance_DataWriter_out;


            class JointTolerance_DataReader;

            typedef JointTolerance_DataReader * JointTolerance_DataReader_ptr;
            typedef DDS_DCPSInterface_var < JointTolerance_DataReader> JointTolerance_DataReader_var;
            typedef DDS_DCPSInterface_out < JointTolerance_DataReader> JointTolerance_DataReader_out;


            class JointTolerance_DataReaderView;

            typedef JointTolerance_DataReaderView * JointTolerance_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < JointTolerance_DataReaderView> JointTolerance_DataReaderView_var;
            typedef DDS_DCPSInterface_out < JointTolerance_DataReaderView> JointTolerance_DataReaderView_out;

            struct JointTolerance_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < JointTolerance_, struct JointTolerance_Seq_uniq_> JointTolerance_Seq;
            typedef DDS_DCPSSequence_var < JointTolerance_Seq> JointTolerance_Seq_var;
            typedef DDS_DCPSSequence_out < JointTolerance_Seq> JointTolerance_Seq_out;

            class  JointTolerance_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef JointTolerance_TypeSupportInterface_ptr _ptr_type;
                typedef JointTolerance_TypeSupportInterface_var _var_type;

                static JointTolerance_TypeSupportInterface_ptr _duplicate (JointTolerance_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static JointTolerance_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static JointTolerance_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static JointTolerance_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                JointTolerance_TypeSupportInterface_ptr _this () { return this; }


            protected:
                JointTolerance_TypeSupportInterface () {};
                ~JointTolerance_TypeSupportInterface () {};
            private:
                JointTolerance_TypeSupportInterface (const JointTolerance_TypeSupportInterface &);
                JointTolerance_TypeSupportInterface & operator = (const JointTolerance_TypeSupportInterface &);
            };

            class  JointTolerance_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef JointTolerance_DataWriter_ptr _ptr_type;
                typedef JointTolerance_DataWriter_var _var_type;

                static JointTolerance_DataWriter_ptr _duplicate (JointTolerance_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static JointTolerance_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static JointTolerance_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static JointTolerance_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                JointTolerance_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const JointTolerance_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const JointTolerance_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const JointTolerance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const JointTolerance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const JointTolerance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const JointTolerance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const JointTolerance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const JointTolerance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const JointTolerance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const JointTolerance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (JointTolerance_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const JointTolerance_& instance_data) = 0;

            protected:
                JointTolerance_DataWriter () {};
                ~JointTolerance_DataWriter () {};
            private:
                JointTolerance_DataWriter (const JointTolerance_DataWriter &);
                JointTolerance_DataWriter & operator = (const JointTolerance_DataWriter &);
            };

            class  JointTolerance_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef JointTolerance_DataReader_ptr _ptr_type;
                typedef JointTolerance_DataReader_var _var_type;

                static JointTolerance_DataReader_ptr _duplicate (JointTolerance_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static JointTolerance_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static JointTolerance_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static JointTolerance_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                JointTolerance_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (JointTolerance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (JointTolerance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (JointTolerance_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const JointTolerance_& instance) = 0;

            protected:
                JointTolerance_DataReader () {};
                ~JointTolerance_DataReader () {};
            private:
                JointTolerance_DataReader (const JointTolerance_DataReader &);
                JointTolerance_DataReader & operator = (const JointTolerance_DataReader &);
            };

            class  JointTolerance_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef JointTolerance_DataReaderView_ptr _ptr_type;
                typedef JointTolerance_DataReaderView_var _var_type;

                static JointTolerance_DataReaderView_ptr _duplicate (JointTolerance_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static JointTolerance_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static JointTolerance_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static JointTolerance_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                JointTolerance_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (JointTolerance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (JointTolerance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (JointTolerance_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (JointTolerance_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const JointTolerance_& instance) = 0;

            protected:
                JointTolerance_DataReaderView () {};
                ~JointTolerance_DataReaderView () {};
            private:
                JointTolerance_DataReaderView (const JointTolerance_DataReaderView &);
                JointTolerance_DataReaderView & operator = (const JointTolerance_DataReaderView &);
            };
        }

    }

}

#endif
