#ifndef _H_355C3FA8346F82973D2C490CCB0AB10B_QueryCalibrationState__H_
#define _H_355C3FA8346F82973D2C490CCB0AB10B_QueryCalibrationState__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace control_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  QueryCalibrationState_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<QueryCalibrationState_Request_> QueryCalibrationState_Request__var;
            typedef QueryCalibrationState_Request_& QueryCalibrationState_Request__out;

            struct  QueryCalibrationState_Response_
            {
                ::DDS::Boolean is_calibrated_;
            };

            typedef DDS_DCPSStruct_var<QueryCalibrationState_Response_> QueryCalibrationState_Response__var;
            typedef QueryCalibrationState_Response_& QueryCalibrationState_Response__out;

            struct  Sample_QueryCalibrationState_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::control_msgs::srv::dds_::QueryCalibrationState_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_QueryCalibrationState_Request_> Sample_QueryCalibrationState_Request__var;
            typedef Sample_QueryCalibrationState_Request_& Sample_QueryCalibrationState_Request__out;

            struct  Sample_QueryCalibrationState_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::control_msgs::srv::dds_::QueryCalibrationState_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_QueryCalibrationState_Response_> Sample_QueryCalibrationState_Response__var;
            typedef Sample_QueryCalibrationState_Response_& Sample_QueryCalibrationState_Response__out;

        }

    }

}

#endif /* _H_355C3FA8346F82973D2C490CCB0AB10B_QueryCalibrationState__H_ */
