#ifndef _H_355C3FA8346F82973D2C490CCB0AB10B_QueryCalibrationState_DCPS_H_
#define _H_355C3FA8346F82973D2C490CCB0AB10B_QueryCalibrationState_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "QueryCalibrationState_.h"


namespace control_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class QueryCalibrationState_Request_TypeSupportInterface;

            typedef QueryCalibrationState_Request_TypeSupportInterface * QueryCalibrationState_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < QueryCalibrationState_Request_TypeSupportInterface> QueryCalibrationState_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < QueryCalibrationState_Request_TypeSupportInterface> QueryCalibrationState_Request_TypeSupportInterface_out;


            class QueryCalibrationState_Request_DataWriter;

            typedef QueryCalibrationState_Request_DataWriter * QueryCalibrationState_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < QueryCalibrationState_Request_DataWriter> QueryCalibrationState_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < QueryCalibrationState_Request_DataWriter> QueryCalibrationState_Request_DataWriter_out;


            class QueryCalibrationState_Request_DataReader;

            typedef QueryCalibrationState_Request_DataReader * QueryCalibrationState_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < QueryCalibrationState_Request_DataReader> QueryCalibrationState_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < QueryCalibrationState_Request_DataReader> QueryCalibrationState_Request_DataReader_out;


            class QueryCalibrationState_Request_DataReaderView;

            typedef QueryCalibrationState_Request_DataReaderView * QueryCalibrationState_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < QueryCalibrationState_Request_DataReaderView> QueryCalibrationState_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < QueryCalibrationState_Request_DataReaderView> QueryCalibrationState_Request_DataReaderView_out;

            struct QueryCalibrationState_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < QueryCalibrationState_Request_, struct QueryCalibrationState_Request_Seq_uniq_> QueryCalibrationState_Request_Seq;
            typedef DDS_DCPSSequence_var < QueryCalibrationState_Request_Seq> QueryCalibrationState_Request_Seq_var;
            typedef DDS_DCPSSequence_out < QueryCalibrationState_Request_Seq> QueryCalibrationState_Request_Seq_out;

            class  QueryCalibrationState_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef QueryCalibrationState_Request_TypeSupportInterface_ptr _ptr_type;
                typedef QueryCalibrationState_Request_TypeSupportInterface_var _var_type;

                static QueryCalibrationState_Request_TypeSupportInterface_ptr _duplicate (QueryCalibrationState_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static QueryCalibrationState_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static QueryCalibrationState_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static QueryCalibrationState_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                QueryCalibrationState_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                QueryCalibrationState_Request_TypeSupportInterface () {};
                ~QueryCalibrationState_Request_TypeSupportInterface () {};
            private:
                QueryCalibrationState_Request_TypeSupportInterface (const QueryCalibrationState_Request_TypeSupportInterface &);
                QueryCalibrationState_Request_TypeSupportInterface & operator = (const QueryCalibrationState_Request_TypeSupportInterface &);
            };

            class  QueryCalibrationState_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef QueryCalibrationState_Request_DataWriter_ptr _ptr_type;
                typedef QueryCalibrationState_Request_DataWriter_var _var_type;

                static QueryCalibrationState_Request_DataWriter_ptr _duplicate (QueryCalibrationState_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static QueryCalibrationState_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static QueryCalibrationState_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static QueryCalibrationState_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                QueryCalibrationState_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const QueryCalibrationState_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const QueryCalibrationState_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const QueryCalibrationState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const QueryCalibrationState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const QueryCalibrationState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const QueryCalibrationState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const QueryCalibrationState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const QueryCalibrationState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const QueryCalibrationState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const QueryCalibrationState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (QueryCalibrationState_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const QueryCalibrationState_Request_& instance_data) = 0;

            protected:
                QueryCalibrationState_Request_DataWriter () {};
                ~QueryCalibrationState_Request_DataWriter () {};
            private:
                QueryCalibrationState_Request_DataWriter (const QueryCalibrationState_Request_DataWriter &);
                QueryCalibrationState_Request_DataWriter & operator = (const QueryCalibrationState_Request_DataWriter &);
            };

            class  QueryCalibrationState_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef QueryCalibrationState_Request_DataReader_ptr _ptr_type;
                typedef QueryCalibrationState_Request_DataReader_var _var_type;

                static QueryCalibrationState_Request_DataReader_ptr _duplicate (QueryCalibrationState_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static QueryCalibrationState_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static QueryCalibrationState_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static QueryCalibrationState_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                QueryCalibrationState_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (QueryCalibrationState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (QueryCalibrationState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (QueryCalibrationState_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const QueryCalibrationState_Request_& instance) = 0;

            protected:
                QueryCalibrationState_Request_DataReader () {};
                ~QueryCalibrationState_Request_DataReader () {};
            private:
                QueryCalibrationState_Request_DataReader (const QueryCalibrationState_Request_DataReader &);
                QueryCalibrationState_Request_DataReader & operator = (const QueryCalibrationState_Request_DataReader &);
            };

            class  QueryCalibrationState_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef QueryCalibrationState_Request_DataReaderView_ptr _ptr_type;
                typedef QueryCalibrationState_Request_DataReaderView_var _var_type;

                static QueryCalibrationState_Request_DataReaderView_ptr _duplicate (QueryCalibrationState_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static QueryCalibrationState_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static QueryCalibrationState_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static QueryCalibrationState_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                QueryCalibrationState_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (QueryCalibrationState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (QueryCalibrationState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (QueryCalibrationState_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const QueryCalibrationState_Request_& instance) = 0;

            protected:
                QueryCalibrationState_Request_DataReaderView () {};
                ~QueryCalibrationState_Request_DataReaderView () {};
            private:
                QueryCalibrationState_Request_DataReaderView (const QueryCalibrationState_Request_DataReaderView &);
                QueryCalibrationState_Request_DataReaderView & operator = (const QueryCalibrationState_Request_DataReaderView &);
            };
            class QueryCalibrationState_Response_TypeSupportInterface;

            typedef QueryCalibrationState_Response_TypeSupportInterface * QueryCalibrationState_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < QueryCalibrationState_Response_TypeSupportInterface> QueryCalibrationState_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < QueryCalibrationState_Response_TypeSupportInterface> QueryCalibrationState_Response_TypeSupportInterface_out;


            class QueryCalibrationState_Response_DataWriter;

            typedef QueryCalibrationState_Response_DataWriter * QueryCalibrationState_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < QueryCalibrationState_Response_DataWriter> QueryCalibrationState_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < QueryCalibrationState_Response_DataWriter> QueryCalibrationState_Response_DataWriter_out;


            class QueryCalibrationState_Response_DataReader;

            typedef QueryCalibrationState_Response_DataReader * QueryCalibrationState_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < QueryCalibrationState_Response_DataReader> QueryCalibrationState_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < QueryCalibrationState_Response_DataReader> QueryCalibrationState_Response_DataReader_out;


            class QueryCalibrationState_Response_DataReaderView;

            typedef QueryCalibrationState_Response_DataReaderView * QueryCalibrationState_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < QueryCalibrationState_Response_DataReaderView> QueryCalibrationState_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < QueryCalibrationState_Response_DataReaderView> QueryCalibrationState_Response_DataReaderView_out;

            struct QueryCalibrationState_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < QueryCalibrationState_Response_, struct QueryCalibrationState_Response_Seq_uniq_> QueryCalibrationState_Response_Seq;
            typedef DDS_DCPSSequence_var < QueryCalibrationState_Response_Seq> QueryCalibrationState_Response_Seq_var;
            typedef DDS_DCPSSequence_out < QueryCalibrationState_Response_Seq> QueryCalibrationState_Response_Seq_out;

            class  QueryCalibrationState_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef QueryCalibrationState_Response_TypeSupportInterface_ptr _ptr_type;
                typedef QueryCalibrationState_Response_TypeSupportInterface_var _var_type;

                static QueryCalibrationState_Response_TypeSupportInterface_ptr _duplicate (QueryCalibrationState_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static QueryCalibrationState_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static QueryCalibrationState_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static QueryCalibrationState_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                QueryCalibrationState_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                QueryCalibrationState_Response_TypeSupportInterface () {};
                ~QueryCalibrationState_Response_TypeSupportInterface () {};
            private:
                QueryCalibrationState_Response_TypeSupportInterface (const QueryCalibrationState_Response_TypeSupportInterface &);
                QueryCalibrationState_Response_TypeSupportInterface & operator = (const QueryCalibrationState_Response_TypeSupportInterface &);
            };

            class  QueryCalibrationState_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef QueryCalibrationState_Response_DataWriter_ptr _ptr_type;
                typedef QueryCalibrationState_Response_DataWriter_var _var_type;

                static QueryCalibrationState_Response_DataWriter_ptr _duplicate (QueryCalibrationState_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static QueryCalibrationState_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static QueryCalibrationState_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static QueryCalibrationState_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                QueryCalibrationState_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const QueryCalibrationState_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const QueryCalibrationState_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const QueryCalibrationState_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const QueryCalibrationState_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const QueryCalibrationState_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const QueryCalibrationState_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const QueryCalibrationState_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const QueryCalibrationState_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const QueryCalibrationState_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const QueryCalibrationState_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (QueryCalibrationState_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const QueryCalibrationState_Response_& instance_data) = 0;

            protected:
                QueryCalibrationState_Response_DataWriter () {};
                ~QueryCalibrationState_Response_DataWriter () {};
            private:
                QueryCalibrationState_Response_DataWriter (const QueryCalibrationState_Response_DataWriter &);
                QueryCalibrationState_Response_DataWriter & operator = (const QueryCalibrationState_Response_DataWriter &);
            };

            class  QueryCalibrationState_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef QueryCalibrationState_Response_DataReader_ptr _ptr_type;
                typedef QueryCalibrationState_Response_DataReader_var _var_type;

                static QueryCalibrationState_Response_DataReader_ptr _duplicate (QueryCalibrationState_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static QueryCalibrationState_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static QueryCalibrationState_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static QueryCalibrationState_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                QueryCalibrationState_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (QueryCalibrationState_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (QueryCalibrationState_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (QueryCalibrationState_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const QueryCalibrationState_Response_& instance) = 0;

            protected:
                QueryCalibrationState_Response_DataReader () {};
                ~QueryCalibrationState_Response_DataReader () {};
            private:
                QueryCalibrationState_Response_DataReader (const QueryCalibrationState_Response_DataReader &);
                QueryCalibrationState_Response_DataReader & operator = (const QueryCalibrationState_Response_DataReader &);
            };

            class  QueryCalibrationState_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef QueryCalibrationState_Response_DataReaderView_ptr _ptr_type;
                typedef QueryCalibrationState_Response_DataReaderView_var _var_type;

                static QueryCalibrationState_Response_DataReaderView_ptr _duplicate (QueryCalibrationState_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static QueryCalibrationState_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static QueryCalibrationState_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static QueryCalibrationState_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                QueryCalibrationState_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (QueryCalibrationState_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (QueryCalibrationState_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (QueryCalibrationState_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const QueryCalibrationState_Response_& instance) = 0;

            protected:
                QueryCalibrationState_Response_DataReaderView () {};
                ~QueryCalibrationState_Response_DataReaderView () {};
            private:
                QueryCalibrationState_Response_DataReaderView (const QueryCalibrationState_Response_DataReaderView &);
                QueryCalibrationState_Response_DataReaderView & operator = (const QueryCalibrationState_Response_DataReaderView &);
            };
            class Sample_QueryCalibrationState_Request_TypeSupportInterface;

            typedef Sample_QueryCalibrationState_Request_TypeSupportInterface * Sample_QueryCalibrationState_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_QueryCalibrationState_Request_TypeSupportInterface> Sample_QueryCalibrationState_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_QueryCalibrationState_Request_TypeSupportInterface> Sample_QueryCalibrationState_Request_TypeSupportInterface_out;


            class Sample_QueryCalibrationState_Request_DataWriter;

            typedef Sample_QueryCalibrationState_Request_DataWriter * Sample_QueryCalibrationState_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_QueryCalibrationState_Request_DataWriter> Sample_QueryCalibrationState_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_QueryCalibrationState_Request_DataWriter> Sample_QueryCalibrationState_Request_DataWriter_out;


            class Sample_QueryCalibrationState_Request_DataReader;

            typedef Sample_QueryCalibrationState_Request_DataReader * Sample_QueryCalibrationState_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_QueryCalibrationState_Request_DataReader> Sample_QueryCalibrationState_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_QueryCalibrationState_Request_DataReader> Sample_QueryCalibrationState_Request_DataReader_out;


            class Sample_QueryCalibrationState_Request_DataReaderView;

            typedef Sample_QueryCalibrationState_Request_DataReaderView * Sample_QueryCalibrationState_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_QueryCalibrationState_Request_DataReaderView> Sample_QueryCalibrationState_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_QueryCalibrationState_Request_DataReaderView> Sample_QueryCalibrationState_Request_DataReaderView_out;

            struct Sample_QueryCalibrationState_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_QueryCalibrationState_Request_, struct Sample_QueryCalibrationState_Request_Seq_uniq_> Sample_QueryCalibrationState_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_QueryCalibrationState_Request_Seq> Sample_QueryCalibrationState_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_QueryCalibrationState_Request_Seq> Sample_QueryCalibrationState_Request_Seq_out;

            class  Sample_QueryCalibrationState_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_QueryCalibrationState_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_QueryCalibrationState_Request_TypeSupportInterface_var _var_type;

                static Sample_QueryCalibrationState_Request_TypeSupportInterface_ptr _duplicate (Sample_QueryCalibrationState_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_QueryCalibrationState_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_QueryCalibrationState_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_QueryCalibrationState_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_QueryCalibrationState_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_QueryCalibrationState_Request_TypeSupportInterface () {};
                ~Sample_QueryCalibrationState_Request_TypeSupportInterface () {};
            private:
                Sample_QueryCalibrationState_Request_TypeSupportInterface (const Sample_QueryCalibrationState_Request_TypeSupportInterface &);
                Sample_QueryCalibrationState_Request_TypeSupportInterface & operator = (const Sample_QueryCalibrationState_Request_TypeSupportInterface &);
            };

            class  Sample_QueryCalibrationState_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_QueryCalibrationState_Request_DataWriter_ptr _ptr_type;
                typedef Sample_QueryCalibrationState_Request_DataWriter_var _var_type;

                static Sample_QueryCalibrationState_Request_DataWriter_ptr _duplicate (Sample_QueryCalibrationState_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_QueryCalibrationState_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_QueryCalibrationState_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_QueryCalibrationState_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_QueryCalibrationState_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_QueryCalibrationState_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_QueryCalibrationState_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_QueryCalibrationState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_QueryCalibrationState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_QueryCalibrationState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_QueryCalibrationState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_QueryCalibrationState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_QueryCalibrationState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_QueryCalibrationState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_QueryCalibrationState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_QueryCalibrationState_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_QueryCalibrationState_Request_& instance_data) = 0;

            protected:
                Sample_QueryCalibrationState_Request_DataWriter () {};
                ~Sample_QueryCalibrationState_Request_DataWriter () {};
            private:
                Sample_QueryCalibrationState_Request_DataWriter (const Sample_QueryCalibrationState_Request_DataWriter &);
                Sample_QueryCalibrationState_Request_DataWriter & operator = (const Sample_QueryCalibrationState_Request_DataWriter &);
            };

            class  Sample_QueryCalibrationState_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_QueryCalibrationState_Request_DataReader_ptr _ptr_type;
                typedef Sample_QueryCalibrationState_Request_DataReader_var _var_type;

                static Sample_QueryCalibrationState_Request_DataReader_ptr _duplicate (Sample_QueryCalibrationState_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_QueryCalibrationState_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_QueryCalibrationState_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_QueryCalibrationState_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_QueryCalibrationState_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_QueryCalibrationState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_QueryCalibrationState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_QueryCalibrationState_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_QueryCalibrationState_Request_& instance) = 0;

            protected:
                Sample_QueryCalibrationState_Request_DataReader () {};
                ~Sample_QueryCalibrationState_Request_DataReader () {};
            private:
                Sample_QueryCalibrationState_Request_DataReader (const Sample_QueryCalibrationState_Request_DataReader &);
                Sample_QueryCalibrationState_Request_DataReader & operator = (const Sample_QueryCalibrationState_Request_DataReader &);
            };

            class  Sample_QueryCalibrationState_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_QueryCalibrationState_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_QueryCalibrationState_Request_DataReaderView_var _var_type;

                static Sample_QueryCalibrationState_Request_DataReaderView_ptr _duplicate (Sample_QueryCalibrationState_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_QueryCalibrationState_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_QueryCalibrationState_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_QueryCalibrationState_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_QueryCalibrationState_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_QueryCalibrationState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_QueryCalibrationState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_QueryCalibrationState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_QueryCalibrationState_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_QueryCalibrationState_Request_& instance) = 0;

            protected:
                Sample_QueryCalibrationState_Request_DataReaderView () {};
                ~Sample_QueryCalibrationState_Request_DataReaderView () {};
            private:
                Sample_QueryCalibrationState_Request_DataReaderView (const Sample_QueryCalibrationState_Request_DataReaderView &);
                Sample_QueryCalibrationState_Request_DataReaderView & operator = (const Sample_QueryCalibrationState_Request_DataReaderView &);
            };
            class Sample_QueryCalibrationState_Response_TypeSupportInterface;

            typedef Sample_QueryCalibrationState_Response_TypeSupportInterface * Sample_QueryCalibrationState_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_QueryCalibrationState_Response_TypeSupportInterface> Sample_QueryCalibrationState_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_QueryCalibrationState_Response_TypeSupportInterface> Sample_QueryCalibrationState_Response_TypeSupportInterface_out;


            class Sample_QueryCalibrationState_Response_DataWriter;

            typedef Sample_QueryCalibrationState_Response_DataWriter * Sample_QueryCalibrationState_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_QueryCalibrationState_Response_DataWriter> Sample_QueryCalibrationState_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_QueryCalibrationState_Response_DataWriter> Sample_QueryCalibrationState_Response_DataWriter_out;


            class Sample_QueryCalibrationState_Response_DataReader;

            typedef Sample_QueryCalibrationState_Response_DataReader * Sample_QueryCalibrationState_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_QueryCalibrationState_Response_DataReader> Sample_QueryCalibrationState_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_QueryCalibrationState_Response_DataReader> Sample_QueryCalibrationState_Response_DataReader_out;


            class Sample_QueryCalibrationState_Response_DataReaderView;

            typedef Sample_QueryCalibrationState_Response_DataReaderView * Sample_QueryCalibrationState_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_QueryCalibrationState_Response_DataReaderView> Sample_QueryCalibrationState_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_QueryCalibrationState_Response_DataReaderView> Sample_QueryCalibrationState_Response_DataReaderView_out;

            struct Sample_QueryCalibrationState_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_QueryCalibrationState_Response_, struct Sample_QueryCalibrationState_Response_Seq_uniq_> Sample_QueryCalibrationState_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_QueryCalibrationState_Response_Seq> Sample_QueryCalibrationState_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_QueryCalibrationState_Response_Seq> Sample_QueryCalibrationState_Response_Seq_out;

            class  Sample_QueryCalibrationState_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_QueryCalibrationState_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_QueryCalibrationState_Response_TypeSupportInterface_var _var_type;

                static Sample_QueryCalibrationState_Response_TypeSupportInterface_ptr _duplicate (Sample_QueryCalibrationState_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_QueryCalibrationState_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_QueryCalibrationState_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_QueryCalibrationState_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_QueryCalibrationState_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_QueryCalibrationState_Response_TypeSupportInterface () {};
                ~Sample_QueryCalibrationState_Response_TypeSupportInterface () {};
            private:
                Sample_QueryCalibrationState_Response_TypeSupportInterface (const Sample_QueryCalibrationState_Response_TypeSupportInterface &);
                Sample_QueryCalibrationState_Response_TypeSupportInterface & operator = (const Sample_QueryCalibrationState_Response_TypeSupportInterface &);
            };

            class  Sample_QueryCalibrationState_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_QueryCalibrationState_Response_DataWriter_ptr _ptr_type;
                typedef Sample_QueryCalibrationState_Response_DataWriter_var _var_type;

                static Sample_QueryCalibrationState_Response_DataWriter_ptr _duplicate (Sample_QueryCalibrationState_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_QueryCalibrationState_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_QueryCalibrationState_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_QueryCalibrationState_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_QueryCalibrationState_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_QueryCalibrationState_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_QueryCalibrationState_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_QueryCalibrationState_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_QueryCalibrationState_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_QueryCalibrationState_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_QueryCalibrationState_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_QueryCalibrationState_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_QueryCalibrationState_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_QueryCalibrationState_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_QueryCalibrationState_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_QueryCalibrationState_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_QueryCalibrationState_Response_& instance_data) = 0;

            protected:
                Sample_QueryCalibrationState_Response_DataWriter () {};
                ~Sample_QueryCalibrationState_Response_DataWriter () {};
            private:
                Sample_QueryCalibrationState_Response_DataWriter (const Sample_QueryCalibrationState_Response_DataWriter &);
                Sample_QueryCalibrationState_Response_DataWriter & operator = (const Sample_QueryCalibrationState_Response_DataWriter &);
            };

            class  Sample_QueryCalibrationState_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_QueryCalibrationState_Response_DataReader_ptr _ptr_type;
                typedef Sample_QueryCalibrationState_Response_DataReader_var _var_type;

                static Sample_QueryCalibrationState_Response_DataReader_ptr _duplicate (Sample_QueryCalibrationState_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_QueryCalibrationState_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_QueryCalibrationState_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_QueryCalibrationState_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_QueryCalibrationState_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_QueryCalibrationState_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_QueryCalibrationState_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_QueryCalibrationState_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_QueryCalibrationState_Response_& instance) = 0;

            protected:
                Sample_QueryCalibrationState_Response_DataReader () {};
                ~Sample_QueryCalibrationState_Response_DataReader () {};
            private:
                Sample_QueryCalibrationState_Response_DataReader (const Sample_QueryCalibrationState_Response_DataReader &);
                Sample_QueryCalibrationState_Response_DataReader & operator = (const Sample_QueryCalibrationState_Response_DataReader &);
            };

            class  Sample_QueryCalibrationState_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_QueryCalibrationState_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_QueryCalibrationState_Response_DataReaderView_var _var_type;

                static Sample_QueryCalibrationState_Response_DataReaderView_ptr _duplicate (Sample_QueryCalibrationState_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_QueryCalibrationState_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_QueryCalibrationState_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_QueryCalibrationState_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_QueryCalibrationState_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_QueryCalibrationState_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_QueryCalibrationState_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_QueryCalibrationState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_QueryCalibrationState_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_QueryCalibrationState_Response_& instance) = 0;

            protected:
                Sample_QueryCalibrationState_Response_DataReaderView () {};
                ~Sample_QueryCalibrationState_Response_DataReaderView () {};
            private:
                Sample_QueryCalibrationState_Response_DataReaderView (const Sample_QueryCalibrationState_Response_DataReaderView &);
                Sample_QueryCalibrationState_Response_DataReaderView & operator = (const Sample_QueryCalibrationState_Response_DataReaderView &);
            };
        }

    }

}

#endif
